/**
 * Functions to manage Gallery
 */
 
var __gallery;

(function(my_app, $){
var __myapp=my_app;

var __menu = my_app.detectMenu('#my-home');

// Add gallery block into the DOM 

// Album div
$('#my-gallery').remove();
$('body').append($('<div/>').attr({id:'my-gallery','aid':'104', "class":'my-page my-gallery', 'my-role':'page'}));
var __clone = $('#my-home').children().clone();
__myapp.removeScriptFromClone(__clone);
$('#my-gallery[aid=104]').append(__clone);
$('#fixed_head', '#my-gallery[aid=104]').remove();
$('#scroller','#my-gallery[aid=104]').empty();
$('.menu-bar-row','#my-gallery[aid=104]').empty();
$('#my-footer','#my-gallery[aid=104]').css('display', 'none');
my_app.createMenu('my-gallery', __menu);


// Gallery div
$('#my-gallery-images').remove(); 
$('body').append($('<div/>').attr({id:'my-gallery-images', "class":'my-page my-gallery', 'my-role':'page'}));
__clone = $('#my-home').children().clone();
__myapp.removeScriptFromClone(__clone);
$('#my-gallery-images').append(__clone);
$('#fixed_head', '#my-gallery-images').remove();
$('#scroller','#my-gallery-images').empty();
my_app.setBackLink("my-gallery-images", "my-gallery", null, "slide");
$("#my-gallery-images").bind("pageloaded", function(){
	var __alb = $("#my-body", "#my-gallery-images").attr("alb-name");
	if (__alb) __myapp.updateHeadTitle("my-gallery-images", __alb);
	var evt = $.Event();
	evt.currentTarget = $(this)[0];
	my_app.updatebodyScroll(evt);
});
$('.menu-bar-row','#my-gallery-images').empty();
$('#my-footer','#my-gallery-images').css('display', 'none');
my_app.createMenu('my-gallery-images', __menu);


// Image div
$('#my-gallery-image').remove();
$('body').append($('<div/>').attr({id:'my-gallery-image', "class":'my-page my-gallery', 'my-role':'page'}));
__clone = $('#my-home').children().clone();
__myapp.removeScriptFromClone(__clone);
$('#my-gallery-image').append(__clone);
$('#scroller','#my-gallery-image').empty();
$('#fixed_head', '#my-gallery-image').remove();
my_app.setBackLink("my-gallery-image", "my-gallery-images", null, "slide");
$("#my-gallery-image").bind("pageloaded", function(){
	var evt = $.Event();
	evt.currentTarget = $(this)[0];
	my_app.updatebodyScroll(evt);
});
$('.menu-bar-row','#my-gallery-image').empty();
$('#my-footer','#my-gallery-image').css('display', 'none');
my_app.createMenu('my-gallery-image', __menu);

var __msg = (myapp.translate) ? myapp.translate('__l0358') : "Pictures gallery";
$('.my-head-titleLabel','#my-gallery').removeAttr('lid').html(__msg);

/**
* Add album in the page
*/ 
var addGalleryAlbum = function (AppID) {
	var __galEmpty = true;
	$("#scroller","#my-gallery[aid=104]").empty();
	for (var albIndex in __gallery) {
		if (__gallery.hasOwnProperty(albIndex)) {
			$("#scroller","#my-gallery[aid=104]").append($('<div/>').attr({id:'my-album', "class":'my-album-item', 'alb-name':__gallery[albIndex].name, index:albIndex}).html(__gallery[albIndex].name));
			__galEmpty = false;
		}
	}
	albIndex=null;
	if (__galEmpty) {
		var __msg = (myapp.translate) ? myapp.translate('__l0365') : "No images available";

		$("#scroller","#my-gallery[aid=104]").empty().append($('<div/>').addClass("my-gallery_errorMsg").html(__msg));
	} else {
		$('div.my-album-item', "#my-gallery[aid=104]").click(function() {
			// Change to gallery images page
			loadGalleryAlbumImages(AppID, $(this).attr('alb-name'), $(this).attr('index'));
			$.mobile.changePage("#my-gallery-images", "slide", false);
		});
	}
};

/**
* Get Album list
*/
var loadAlbum = function (AppID, updateScroll, callback) {
	var __albURL = BASE_URL + "/_mMedia.php?app="+ AppID +"&diap=list&cms=1";
	$.get(__albURL, function(data) {
		__gallery =  $.parseJSON(data);
		addGalleryAlbum(AppID);
		if (updateScroll) {
			var evt = $.Event();
			evt.currentTarget = $("#my-gallery[aid=104]")[0];
			__myapp.updatebodyScroll(evt);
		}

		if(callback && typeof callback == 'function') callback();
	});
};

/**
* Display album images 
*/
var loadGalleryAlbumImages = function(AppID, AlbumName, AlbumIndex) {
	try{
		$("#scroller", "#my-gallery-images").empty();
		$("#my-body", "#my-gallery-images").attr("alb-name", AlbumName).attr("index", AlbumIndex);
		my_app.updateHeadTitle("my-gallery-images", AlbumName);
		if(__gallery.hasOwnProperty(AlbumIndex) && __gallery[AlbumIndex].hasOwnProperty("pics")){
			for (var imgIndex in __gallery[AlbumIndex].pics) {
				if (__gallery[AlbumIndex].pics.hasOwnProperty(imgIndex)) {
					var __imgURL = BASE_URL + "/_mMedia.php?app="+AppID+"&diap=img&cms=1&album="+ encodeURIComponent(AlbumIndex) +"&name="+ encodeURIComponent(imgIndex),
					__imgDiv = $("<div/>").attr("class","my-gallery-image-item").appendTo($("#scroller","#my-gallery-images"));
					__imgDiv.css({
						"background-image":"url('"+(__imgURL+"&w=75&h=75")+"')",
						"background-position":"center"
					});
					__imgDiv.attr("img-url", __imgURL);

					__imgDiv.click(function() {
						var __imgURL = $(this).attr("img-url");
						// Remove all resizing parameters from URL
						__imgURL = __imgURL.replace(/&?w=[0-9]+/,"");
						__imgURL = __imgURL.replace(/&?h=[0-9]+/,"");
						loadGalleryAlbumImage(__imgURL);
						$.mobile.changePage("#my-gallery-image", "slide", false);
					});
				}
			}
		}
	}catch(e){}
};

/**
* Display an Image from a Gallery Album
*/
var loadGalleryAlbumImage = function(ImgURL) {
	$("#scroller", "#my-gallery-image").empty();
	$(".my-head-titleLabel","#my-gallery-image").removeAttr('lid').text("");
	// Get size of the content body
	var __w = 320,
	__h = 345,
	__imgURL = ImgURL + "&best=1" +"&w="+__w+"&h="+__h,
	__img = $("<img/>").attr({"class":'my-gallery-image', src:__imgURL}).css('width', '100%');
	$("#scroller","#my-gallery-image").append(__img);
	__img.bind("load", function(e){
		my_app.iscroll.refresh();
	});
};

/**
* Global function to update gallery page content
*/
my_app.updateGalleryPage = function(callback) {
	loadAlbum(my_app.AppID, true, callback);
};

my_app.simFn.gallery={
	loadGalleryAlbumImages:function(album, index){
		loadAlbum(my_app.AppID, false, function(){
			loadGalleryAlbumImages(my_app.AppID, album, index);
		});
	},
	triggerAlbum:function(album, index){
		/*loadGalleryAlbumImages(my_app.AppID, album, index);
		$.mobile.changePage("#my-gallery-images", "slide", false);*/
		if(index){
			$('div.my-album-item', "#my-gallery[aid=104]").filter('[index='+index+']').trigger('click');
		}else{
			$('div.my-album-item', "#my-gallery[aid=104]").filter('[alb-name='+(album)+']').trigger('click');//JB 2012 10 05 : remove escape() on album
		}
	},
	goHome:function(album){
		$.mobile.changePage('#my-gallery', 'none', false);
	}
};

$("#my-gallery[aid=104]").bind("pagebeforeshow", function(e){
	if(e && e.evData && e.evData.prevPage.nextPage !== 'my-gallery-images') loadAlbum(my_app.AppID, true);
});
 
})(myapp, jQuery);