/**
 * Copyright (c) 2011 myapphone.com, http://myapphone.com/
 * Version 1.0.0 - Last updated: -
 * 
 * Module to manage the dynamic list.
 * This module ask the server for content update. If necessary download the new content from 
 * the server then update the application page.
 */

// -----------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------
// Declaration of the callback functions for dialogs box ...

    /*
     * Callback function for native dialobox dummy callback
     * @see updateNativePage
     */

    function __CB_foo(id, sel){
    }

    /*
     * Callback function for native dialobox dummy callback
     * @see updateNativePage
     */

    function __CB_dispNoContent(id, sel){
    	try{
            console.log("[__CB_dispNoContent] ...");
    	}catch(e){}
        if(id === "err"){
            if(myapp.NATIVE) __I_native_event('enmenu');
            if(!myapp.NATIVE) $.mobile.pageLoading(true);
        }
    }

    /*
     * Callback function for native dialobox
     * @see updateNativePage
     */

    function __CB_updateNativePage(id, sel){
        if(id === "err"){
            if(myapp.NATIVE) __I_native_event('enmenu');
        }
    }

	/*
	 * Callback function for native dialobox
	 * @see updateList2
	 */
	function __CB__updateList2(id, sel, params){
		if(id === 'err_null'){
			if(myapp.flow_end_splash){
				myapp.FlowBackGroundEndSplash();
			}
		}
		
		if(id === 'err_data_null'){
			myapp.getSingleListContent2(null, params, null, false, true, true, null, null);
		}

	}//end __CB__updateList2	

// -----------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------

var myapp = (function(my_app, $){
	// private properties. 
	var __listMan = {};
	var __myapp = my_app;
	
	/*
		Object of the initial content,
	*/
	var __contentParam = {};	
	var __tmplistParam = {};
	
	var __listContent = {};
	
	// time stamp of the mast error message displayed else null
	my_app.comErrMsgDisplay = null;
	my_app.comErrStack = null;
	
	// delay between 2 error message display
	my_app.delayBet2ErrorMsg = 300000; // 5 minutes between to error message display
	var __cleanErrorTimer = null;
	var __isCleanErrorTimer = false;

	// Constructor
	(function __init(){
		__loadStoredContent();
	}());
	
	function unescapeChar(str){
		if(str == undefined) return str;
		else return str.replace(/&amp;/g, "&").replace(/&lt;/g, "<").replace(/&gt;/g, ">").replace(/&quot;/g, '"').replace(/&#039;/g, '\'');
	}
	
	function __isEmpty(ob){
	  	for(var i in ob){ if(ob.hasOwnProperty(i)){return false;}}
	 	return true;
	}
	
	function __typeObject(a){
		var __type = Object.prototype.toString.apply(a);
		if(__type == '[object Array]') return 'array';
		if(__type == '[object Object]') return 'object';
		return null;
	}
	
	/*
	 * @deprecated
	 * @see __encodeCharForNative possible duplication ...
	 */
	function html_entity_decode(str){
    	try{
    		console.log("[html_entity_decode deprecated] enter in...");
    	}catch(e){}
		/*Firefox (and IE if the string contains no elements surrounded by angle brackets )*/
		try{
			var ta=document.createElement("textarea");
			ta.innerHTML=str;
			return ta.value;
		}catch(e){};
		return str;
	}

	/*
		Get the informations regarding List stored in the localStorage
		@deprecated
	*/
	function __loadStoredContent(){
		if(__I_db_exist("list-content")){
			__listContent = $.evalJSON(__I_db_read("list-content"));
		}
		if(__I_db_exist("initCont")){
			__contentParam = $.evalJSON(__I_db_read("initCont"));
		}
	}
	
	
	/*
	 * 
	 */
	function __setSimpleShareLink(__indexSubSimpleShare, data, idItem, __itMod, ssid) {
		var __simpleShare = $("#" + idItem + "_simpleShare", __itMod),
		__simpleShare_href='myapp://simpleshare';
		if(data && data.pm.pid){
			var __simpleShare_params=$.parseJSON(unescapeChar(__indexSubSimpleShare));
			__simpleShare_params=__simpleShare_params[idItem + "_simpleShare"];

			if(__simpleShare_params !== undefined){
				/**
				* set value for simpleShare parameters
				* @index
				*/
				function __setSimpleShareVal(index){
					if(__simpleShare_params[index]){
						var __val=__simpleShare_params[index],
						__reg = new RegExp("%_([0-9]*)", "g"),
						__matches=__val.match(__reg),
						__pidVal,
						__replaceVal='';

						if(__matches){
							for(var __i=0;__i<__matches.length;__i++){
								__pidVal=__matches[__i].replace('%_', '');
								if (ssid) {
									if(data.c[ssid].label && data.c[ssid].label[__pidVal]){
										__replaceVal=data.c[ssid].label[__pidVal];
									}else if(data.c[ssid].timestamp && data.c[ssid].timestamp[__pidVal]){
										__replaceVal=my_app.timestampToDate(data.c[ssid].timestamp[__pidVal], 'yyyy-mm-dd hh:mm');
									}else{
										__replaceVal='';
									}
								}else {
									if(data.label && data.label[__pidVal]){
										__replaceVal=data.label[__pidVal];
									}else if(data.timestamp && data.timestamp[__pidVal]){
										__replaceVal=my_app.timestampToDate(data.timestamp[__pidVal], 'yyyy-mm-dd hh:mm');
									}else{
										__replaceVal='';
									}
								}
								__val=__val.replace(__matches[__i], __replaceVal);

								__pidVal=null;
							}
						}
						__reg=__matches=null;

						__simpleShare_href+=':'+encodeURIComponent(unescapeChar(__val));
						__val=null;
					}else{
						__simpleShare_href+=':';
					}
				}

				__setSimpleShareVal('0');
				__setSimpleShareVal('1');
			}
			__simpleShare_params=null;
		}
		__simpleShare.attr('href', __simpleShare_href).css('display','block');
		__simpleShare=__simpleShare_href=null;
	}
	/*
	 * Management of the temporary cache system
	 * This case is alive during a application session, all the content will be remove 
	 * once the application is relaunched.
	 */
	my_app.cacheTMP={};
	
	my_app.saveTmpCache = function (name, content){
		if(content != null){
			if(__I_db_exist("list-tmp")){
				my_app.cacheTMP = $.evalJSON(__I_db_read("list-tmp"));
			}else{
				my_app.cacheTMP ={};
			}
			
			var __pID = '_tmp_'+ name;
			my_app.cachePage[__pID] = true;
			var __tmp = $.toJSON(my_app.cacheTMP);
			__I_db_save("list-tmp", __tmp);
			__I_db_save(__pID, $.toJSON(content));
		}
	};//End saveTmpCache

	my_app.getTmpCache = function (name){
		if(__I_db_exist('_tmp_'+ name)){
			return $.evalJSON(__I_db_read('_tmp_'+ name));
		}else{
			return null;
		}
	};//end getTmpCache
	
	my_app.refactorTmpCache = function(){
		if(__I_db_exist("list-tmp")){
			try{
				my_app.cacheTMP = $.evalJSON(__I_db_read("list-tmp"));
				for (id in my_app.cacheTMP){
					__I_db_delete(id);
					delete my_app.cacheTMP[id];
				}
			}catch(err){
		    	try{
					console.log("ERR [refactorTmpCache]" + err.message);
		    	}catch(e){}
			}
			
			if(COUNTPROP(my_app.cachePage) == 0){
				__I_db_delete("list-tmp");
			}			
		}
	};//end refactorTmpCache

	
	
	/*
	 * Management of the cache system
	 * This cache data has a certain liftime (in days ...) 
	 */
	my_app.cachePage={};
	
	my_app.updateListContent = function(name, content){
		__updateListContent(name, content);
	};

	/*
	 *	update the local localStorage
	 */
	function __updateListContent(name, content, Dur){
		
		//if(my_app.sim) return;
		
		duration = (Dur)?(Dur * DAY_MS):(my_app.pageCacheDuration * DAY_MS);
		
		if(content != null){
			if(__I_db_exist("list-page")){
				my_app.cachePage = $.evalJSON(__I_db_read("list-page"));
			}else{
				my_app.cachePage ={};
			}
			
			var __pID = name;
			my_app.cachePage[__pID] = (new Date()).getTime() + duration;
			var __tmp = $.toJSON(my_app.cachePage);
			__I_db_save("list-page", __tmp);
			__I_db_save(name, $.toJSON(content));
	    	try{
				console.log("SAVE .... " + name );
	    	}catch(e){}
		}
	}//End __updateListContent

	function __evalNumberAgr(){
		var __nb = 0;
		if(__I_db_exist("list-page")){
			my_app.cachePage = $.evalJSON(__I_db_read("list-page"));
			for (id in my_app.cachePage){
				if(id.startsWith("#p")){
					__nb++;
				}
			}
		}
		return __nb;
	}//End __evalNumberAgr

	my_app.refactorCache = function(id){
		if(__I_db_exist("list-page")){
			try{
				my_app.cachePage = $.evalJSON(__I_db_read("list-page"));
				var __date = (new Date()).getTime();
				if (id) {
					if(my_app.cacheImage[id] < __date){
						__I_db_delete(id);
						delete my_app.cachePage[id];
					}
				}
				else {
					for (id in my_app.cachePage){
						if(my_app.cacheImage[id] < __date){
							__I_db_delete(id);
							delete my_app.cachePage[id];
						}
					}
				}
			}catch(err){
		    	try{
					console.log("ERR [refactorCache]" + err.message);
		    	}catch(e){}
			}
			
			if(COUNTPROP(my_app.cachePage) == 0){
				__I_db_delete("list-page");
			}			
		}
	};//end refactorCache
	
	my_app.deleteFromCache = function(name){
		__deleteFromCache(name);
	};//end deleteFromCache

	__deleteFromCache = function(name){
		if(__I_db_exist("list-page")){
			try{
				my_app.cachePage = $.evalJSON(__I_db_read("list-page"));
				__I_db_delete(name);
				delete my_app.cachePage[name];
				var __tmp = $.toJSON(my_app.cachePage);
				__I_db_save("list-page", __tmp);
			}catch(err){
		    	try{
					console.log("ERR [__my.refactorCacheImage]" + err.message);
		    	}catch(e){}
			}
		}
	};//end deleteFromCache
	
	my_app.loadCacheContent = function(name){
		return __loadCacheContent(name);
	};//end loadCacheContent

	/*
		Load a list stored in the localstorage.
	*/
	function __loadCacheContent(index){
		my_app.refactorCache(index);	
		if(__I_db_exist(index)){
			return $.evalJSON(__I_db_read(index));
		}
		else return null;
	}//end __loadCacheContent
	
	
	/*
	 * full-favorites management 
	 * (full page stored in localstorage)
	 */
	var __FullFavoriteList;
	
	my_app.addFullFavorite = function(id , str_data){
		if(__FullFavoriteList == undefined){
			__FullFavoriteList = __loadCacheContent("__fullFavList");
			if(__FullFavoriteList == null){
				__FullFavoriteList = {};
			}
		}
		__FullFavoriteList[id] = {};
		__FullFavoriteList[id].t = (new Date()).getTime();
		var __name = "__ffav_" + id;

		__I_db_save("__fullFavList", $.toJSON(__FullFavoriteList));
		__I_db_save(__name, $.toJSON(str_data));
             
//        __I_create_dialog('L\'article a été ajouté à vos favoris !', '__CB_foo', 'err', null, null, 'info', 'Favoris');
	};//end addFullFavorite

	my_app.removeFullFavorite = function(id, idfavpage){
		if(__FullFavoriteList == undefined){
			__FullFavoriteList = __loadCacheContent("__fullFavList");
			if(__FullFavoriteList == null){
				return true;
			}
		}
		delete __FullFavoriteList[id];
		var __name = "__ffav_" + id;

		__I_db_save("__fullFavList", $.toJSON(__FullFavoriteList));
		__I_db_delete(__name);
		
		//update back to fav page 
		if(idfavpage){
			var __data = myapp.createFullFavoriteListObject();
			my_app.createListFromContent(__data, idfavpage, 'slide');
			//$.mobile.changePage(idfavpage, "slide", false, null, {from:"remfav"});
		}
		
	};//end removeFullFavorite

	/*
	 * Useful method to store the resume of an item in the favorite list
	 * @page : id of the list page concerned 
	 * @idx : index of the corresponding item in the list. 
	 * @guid : guid parameter of the corresponding item in the liste. 
	 */
	my_app.storeListResume = function(page, idx, Guid){
		guid = (Guid)?Guid:null;
		var __fguid = false;
		var __List = __loadCacheContent(page);
		if(guid != null){
			for (var __it in __List.c){
				if(__List.c[__it].guid == guid){
					__I_db_save("__currentResume", $.toJSON(__List.c[__it]));
					__fguid = true;
					break;
				}
			}
			if(!__fguid){
				__deleteFromCache("__currentResume");
			}
		}else __I_db_save("__currentResume", $.toJSON(__List.c[idx]));
	};
	
	/*
	 * Useful method to create the full list of favorite.
	 */
	my_app.createFullFavoriteListObject = function(){
		if(__FullFavoriteList == undefined){
			__FullFavoriteList = __loadCacheContent("__fullFavList");
			if(__FullFavoriteList == null){
				// empty list
				return null;
			}
		}
		
		// display list.
		var __res = {};

		__res.up = 1;
		__res.pm = {};
		__res.pm.pid = true;
		__res.pm.bk = 1;
		__res.c = {};
		
		var i=0;
		for (var it_id in __FullFavoriteList){
			var __name = "__ffav_" + it_id;
			// get Objet from data base ...
			__item = __loadCacheContent(__name);
			// populate list...
			__res.c[i] = {};
			
			__res.c[i].id = __item.resume.id;
			__res.c[i].guid = __item.resume.guid;
			
			__res.c[i].label = {};
			for(__pid in __item.resume.label){
				__res.c[i].label[__pid] = __item.resume.label[__pid];
			}

			// update image
			__res.c[i].img = {};
			for(__pid in __item.resume.img){
				__res.c[i].img[__pid] = {};
				__res.c[i].img[__pid].v = __item.resume.img[__pid].v;
			}
			
			__item = null;
			i++;
		}
		
		return __res;
	};//end createFullFavoriteListObject
	
	/*
		Check if a var exist.
	*/
	function __existvar(name){
		var __existvar = false;
		try{
			eval("__existvar = (typeof("+name+")!='undefined')");
			return __existvar;
		}catch(err){
			return false;
		}
	}
	
	my_app.existFunc = function(name){
		return __existFunc(name);
	};
	
	/*
		Check if a function exist.
	*/
	function __existFunc(name){
		var __existfunc = false;
		try{
			eval("__existfunc = (typeof "+name+" == 'function');");
			return __existfunc;
		}catch(err){
			return false;
		}
	}
	
// ################################################################################################################
// Function to manage spinner content ------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------	
	var __Spinner = null,
	__selSpinner,
	__spincallBack,
	__spinSel = {};
	
	/**
	* must declare function 'spinDataLoaded' to work
	*
	* @idSpin : (string)
	* @idAgr : (int)
	* @Callback : (function)
	* @Categ : 
	* @SelVal : 
	*/
	my_app.updateSpinner = function(idSpin, idAgr, Callback, Categ, SelVal){
		var __url;
		if(SelVal)
			__url = "/_mCont_3.php?spin=1&ida="+idAgr+"&cat="+Categ + "&val="+SelVal;
		else
			__url = "/_mCont_3.php?spin=1&ida="+idAgr+"&cat="+Categ;
		
		__url = BASE_URL + __url;

		/*
		* JB : 21 May 2013
		* private function to execute spinDataLoaded function
		*/
		function __callSpinDataLoaded(){
			if(typeof spinDataLoaded === 'function'){
				// inform that spinner (idSpin) is ready 
				eval('spinDataLoaded("'+idSpin+'");');
			}else if(eval('typeof spinDataLoaded_'+idAgr+' === "function"')){
				// inform that spinner (idSpin) is ready 
				eval('spinDataLoaded_'+idAgr+'("'+idSpin+'");');
			}else{
				throw "my_app.updateSpinner : function 'spinDataLoaded' not found";
			}
		}

		__myapp.getObjectFrom(__url,function(data){
	    	try{
				console.log("[updateSpinner] Data for (" + __url + ") :" + data.up);
	    	}catch(e){}
			my_app.comErrMsgDisplay = null;
			if(data.up == 1){
				
				if((data.pm)&&(data.pm.bk)){
					__deleteFromCache("#sp" + idSpin);
					__updateListContent("#sp" + idSpin, data);
				}

				__callSpinDataLoaded();
			}else{
				if((data.pm)&&(data.pm.bk)){
					if(data.pm.bk == -1000) __deleteFromCache("#sp" + idSpin);
				}
				// load back-up content
				var __cont = __loadCacheContent("#sp" + idSpin);
				if(__cont != null){
					__callSpinDataLoaded();
					// enable spin
					__cont = null;
				}else{
					try{
						console.log("[updateSpinner] no content available ...");
					}catch(e){}
				}
			}
			
		},function (err){
			var __cont = __loadCacheContent("#sp" + idSpin);
			if(__cont != null){
				__callSpinDataLoaded();
				// call method to manage the returned content
				if(dispSpin) __myapp.displaySpin(idSpin, data, Callback);
				
				// enable spin
				__cont = null;
			}else{
				try{
					console.log("[updateSpinner] no content available ...");
				}catch(e){}
			}
		});
		return true;
	};

	__myapp.isSpinLoaded = function(spinId){
		return __I_db_exist("#sp" + spinId);
	};

	__myapp.setSpinSel = function(spinid, Sel){
		__spinSel[spinid] = Sel;
	};
	
	__myapp.getSpinSel = function(spinid){
		if(__spinSel[spinid]) return __spinSel[spinid];
		else return false;
	};

	/**
	* @spinIds : (array)
	*/
	__myapp.clearSpinner = function(spinIds){
		for (var i=0; i<spinIds.length; i++){
			__deleteFromCache("#sp" + spinIds[i]);
			delete __spinSel[spinIds[i]];
		}
	};

	__myapp.getSpinContent=function getSpinContent(spinId){
		return __loadCacheContent("#sp"+spinId);
	};
	
	__myapp.displaySpin = function(spinid, Callback){
		if(__myapp.sim){
			// launch spinner.
			// Call spinner with content.
			__selSpinner = spinid;
			__spincallBack = Callback;
			if((__Spinner == null)||(!__Spinner.isShow())){
				if(__Spinner != null) __Spinner.reset();
				__Spinner =  SpinningWheel;
				__Spinner.setCancelAction(mysim_spin_cancel);
				__Spinner.setDoneAction(mysim_spin_done);
			}
		}
		
		var __cont = __loadCacheContent("#sp" + spinid),
		__res = "";
		if(__cont != null){
			try{
				var __res = '[';
			    for(var spincol in __cont.l) {
					if(__myapp.sim){
						var slot = {};
						var __i = 1;
					}
					__res += '[';
					for (var i=0; i<__cont.l[spincol].length; i++){
				    	__res += '"'+__cont.l[spincol][i] + '",';
						if(__myapp.sim){
							slot[__i] = __cont.l[spincol][i];
							__i++;
						}
					}
				    __res = __res.slice(0, -1);
					__res += ']';
					if(__myapp.sim){
						if(!__Spinner.isShow()){
							__Spinner.addSlot(slot);
						}
					}
				}
				__res += ']';
				
				if(__myapp.sim){
					// launch spinner.
					// Call spinner with content.
					var sel = __myapp.getSpinSel(spinid);
					if(sel !== false){
				    	try{
							console.log("[displaySpin] Sel : " + sel);
				    	}catch(e){}
					}else{
				    	try{
							console.log("[displaySpin] No sel ...");
				    	}catch(e){}
					}
					if(!__Spinner.isShow()){
						__Spinner.open();
					}
				}else{
					var sel = __myapp.getSpinSel(spinid);
					if(sel !== false){
						sel = "[\""+sel+"\"]";
					}else{
						sel = "[]";
					}
					var __pickURL = ':custom:' + encodeURIComponent(__res) + ':'+sel+':' + Callback;
					window.location = "myapp://picker" + __pickURL;
				}
			}catch(e){
		    	try{
					console.log("ERR [__populateSpin] specified content doesn't exist ("+spinid+") : "+e.message);
		    	}catch(e){}
			}
		}else{
	    	try{
				console.log("[__populateSpin] no content for ("+spinid+")");
	    	}catch(e){}
		}		
		return null;
	};//end displaySpin ...
	
	// function use to sort arr regarding pid
	my_app.sortArrayByPid = function (arr, pid, asc){
//		return a.replace(/[^.0-9]/g, "") - b.replace(/[^.0-9]/g, "")
	    var prop = ["label", pid];
	    var len = prop.length;
	    
	    arr.sort(function (a, b) {
	        var i = 0;
	        while( i < len ) {
	            a = a[prop[i]];
	            b = b[prop[i]];
	            i++;
	        }
	        
	        var __da = parseDate(a); 
	        var __db = parseDate(b); 
			if((__da != null)&&(__db != null)){
				a = __da;
				b = __db;
			}else{
				var __fa = parseFloat(a);
				var __fb = parseFloat(b);
				if((!isNaN(__fa))&&(!isNaN(__fb))){
					a = __fa;
					b = __fb;
				}
			}
			
	        var __res;
	        if (a < b) {
	        	__res = -1;
	        } else if (a > b) {
	        	__res = 1;
	        } else {
	        	__res = 0;
	        }
			return (asc)?__res:(__res*(-1));
	    });
	    return arr;
	};//end sortPidfunction
	
	function parseDate(dstr){
		var dateParts = dstr.split("/");
		if(dateParts.length == 3){
			var __p0 = parseInt(dateParts[0], 10);
			var __p1 = parseInt(dateParts[1], 10);
			var __p2 = parseInt(dateParts[2], 10);
			if((!isNaN(__p0))&&(!isNaN(__p1))&&(!isNaN(__p2))){
				var __d = new Date(__p2, (__p1 - 1) ,__p0);
				return __d.getTime();
			}else return null;
		}else return null;
	}
	
	// use ful function for html spinner
	function mysim_spin_cancel(){
		__selSpinner = null;
		__spincallBack = null;
	}
	
	function mysim_spin_done(){
		var results = __Spinner.getSelectedValues();
		var __ressel = '\'["' + results.values[0] + '"]\'';
		__strEval = __spincallBack+'(' + __ressel + ');';
		eval(__strEval);
		__selSpinner = null;
		__spincallBack = null;
	}
	
	/*
	 * @param page id of the concerned page
	 * @param idBarToDisplayed id of menu bar to display
	 * @param callback callback function called when the switch of the menu bar is finished 
	 * in order to finish the configuration process of the menu bar.
	 * @param disButton optional this parameter contain the id of button to disable in case of favoris page.
	 */
	my_app.switchHeadBar = function(page, idBarToDisplayed, callback, disButton){

		if(my_app.sim) callback = null;

		var dBut = (disButton)?disButton:null,
		__fH = $("#fixed_head", '#'+page);

		//JB - 05-14-2013 : add this condition
		if($("#"+idBarToDisplayed, __fH).length==1){
			//case bar(s) are in fixed_head
			$("div.page-topBar-table", __fH).css('display', 'none');
			if(idBarToDisplayed == null);
			else{
				$("#"+idBarToDisplayed, __fH).css('display', '');
				if(callback) callback();
			}
		}else{
			//case bar(s) are not in fixed_head
			if(idBarToDisplayed == null){
				__fH.empty();
				__fH.attr("style","display:none;");
			}else{
				__fH.empty();
				__fH.attr("style","");
				var __div = $("#" + idBarToDisplayed);
				if(__div.length){
					if(dBut != null){
						// enable or disable button if we are in favoris display
						var __style = ((__mainThis.myapp.isFav)?'none':'block');
						$("#" + dBut, __div).parent().attr("style","display:"+__style+";");
						__style = null;
					}
					var __cDiv = '<div id="'+idBarToDisplayed+'" width="100%">'+ $(__div).html()+'</div>';
					$(__fH).html(__cDiv);
					__cDiv = null;
					if(callback) callback();
				}else{
					try{
						console.log("[switchHeadBar] no bar to load");
					}catch(e){}
				}
				__div = null;
			}
		}
		dBut, __fH;
	};

	my_app.sortListByPid = function(page, pidToSort){
		try{
			if(my_app.sim) return;
			__spinSortAsc = !__spinSortAsc;
			if(__spinlistArray == null){
				var list = __loadCacheContent("#"+page);
				__spinlistArray = my_app.convertListObjectToArray(list.c);
				__spinlistObj = list;
				delete __spinlistObj.c;
			}
			my_app.sortArrayByPid(__spinlistArray,pidToSort, __spinSortAsc);
			__spinlistObj["c"] = my_app.convertArrayToListObject(__spinlistArray);
			my_app.createListFromContent(__spinlistObj, page);
		}catch(e){}
	};
	

// ################################################################################################################
// Function for list content updating process ---------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
	
	/*
		Intermediary data mapping, used to transform the inbound data flow if it is not 
		conform with the normal data format.
		@see updateList2
	*/
	my_app.transformListData = function (page, data){
		if(__existFunc('__myTransformData')){
			return __myTransformData(page, data);
		}else return data;
	};

	my_app.sortCacheList = function (page, data){
		if(__existFunc('__myRefactorData')){
			return __myRefactorData(page, data);
		}else return data;
	};
	
	/*
		Function to update a list inside e page
		(list item is provide as attribut of page definition)
		@useImg : use embeeded images (ie. my_app.catImg)
		@loading : tell to display a loading wait pop-up
		@loop : DEPRECATED allow the page to be not display if the content is empty of contain only one sub-menu
		@idAgr : id of the aggregation
		@IsRSS : Check if the content is RSS flow cosmpliant or JSON, by default application will not use RSS but if my_rss.js 
				is loaded, then RSS is enable.
		
		return : no return 
		
		IMPORTANT : for native dialog suppoprt in iPhone : 
			depuis un script ou un fonction cette methode ne doit etre appelee que si 
			elle est la dernière tache effectuée par ce script ou cette fonction.
			Eviter d'appeler cette methode depuis des fonctions imbriquées.
			
		TODO EG:15.11.11 remove definitively Loop parameter
			  
	*/
	my_app.updateList2 = function(page, url, title, change, useImg, Loading, Loop, idAgr, IsRSS){

    	try{
    		console.log("[updateList2] Update List (" + url + ") : page-("+page+")");
    	}catch(e){}
		
		loading = (Loading == null)?false:Loading;
		idagr = (idAgr)?idAgr:null;
		isRss = (IsRSS == null)?my_app.rss:IsRSS;

		if(idagr != null){
			my_app.registerAction(idAgr, ACT_VIEW_AGR);
			my_app.currentAgr=idagr;
		}
		
		if(loading){
			if(!my_app.NATIVE) $.mobile.pageLoading();
			if(my_app.NATIVE) __I_native_event('dismenu');
		}

		var __url;
		if(isRss) __url = url;
		else if(url.match(/^http[s]?:\/\//)) __url=url;
		else __url = BASE_URL + url;
		
		$_pager = $("#"+page).attr('pager_type');
		if($_pager != undefined) __url = BASE_URL + url + "&pager=" + $_pager;
		
		__myapp.getObjectFrom(__url, function(data){
			my_app.comErrMsgDisplay = null;
			
			data = my_app.transformListData(page, data);
			
			if(data){
		    	try{
					console.log("[updateList2] Data for (" + url + ") :" + ((data.up)?data.up:"non data"));
		    	}catch(e){}

				data.title = title;

				if(data.up == 1){
					// if update of list
					// force la sauvegarde des données 
					if(my_app.sim) data.pm.bk = 1;
					
					if((data.pm)&&(data.pm.bk)){
						if(data.pm.bk == 1) __updateListContent("#" + page, data);
						if(data.pm.bk == -1000) __deleteFromCache("#" + page);
					}
					__getSingleListContent2(data, page, change, useImg, loading, false, false, idagr);
					
					if(__myapp.flow_end_splash){
						__myapp.FlowBackGroundEndSplash();
					}
					
				}else{
					if((data.pm)&&(data.pm.bk)){
						if(data.pm.bk == -1000) __deleteFromCache("#" + page);
					}
					if(__myapp.sim) var __cont = null;
					else var __cont = __loadCacheContent("#" + page);
					if(__cont != null){
						__getSingleListContent2(__cont, page, change, useImg, loading, false, false, idagr);
						__cont = null;
					}else{
						// no content from cache.
						if(loading){
							if(!my_app.NATIVE) $.mobile.pageLoading(true);
							if(my_app.NATIVE) __I_native_event('enmenu');
						}
						// call no content page
						if(data.msg) __cmsg = data.msg;
						else __cmsg = MY_ERROR_MESSAGE[my_app.setLang]["1100"];
						
						__getSingleListContent2(data, page, change, useImg, loading, true, __cmsg);
						
					}
					
					if(__myapp.flow_end_splash){
						__myapp.FlowBackGroundEndSplash();
					}
				}
			}else{
				__getlistContentErr(undefined,"1100", false, '__CB__updateList2', 'err_data_null', page);
				__getSingleListContent2(null, page, change, useImg, loading, true, MY_ERROR_MESSAGE[my_app.setLang]["1100"]);
				if(__myapp.flow_end_splash){
					__myapp.FlowBackGroundEndSplash();
				}
			}
			
			if(__myapp.myEventEnd != null) $(__myapp.myEventEnd).trigger("end_load");
			
		},function (err){
			if(__myapp.sim) var __cont = null;
			else var __cont = __loadCacheContent("#" + page);
			if(__cont != null){
				// load cache 
				__getSingleListContent2(__cont, page, change, useImg, loading, false, false, idagr);
				__cont = null;
				__getlistContentErr(err,"1006", false, '__CB__updateList2', 'err_null');
			}else{
				// display no content page
				__getSingleListContent2(null, page, change, false, true, true, null, null);
				// force end splash in case of error.
				if(__myapp.flow_end_splash){
					__myapp.FlowBackGroundEndSplash();
				}
				__getlistContentErr(err,"1006", false, '__CB__updateList2', 'err_null');
			}
			
			if(__myapp.myEventEnd != null) $(__myapp.myEventEnd).trigger("end_load");
			
		}, isRss);
	};
	
	// ----------------------------------------------------------------------------------------------------------------
	// END Function for list content updating process -----------------------------------------------------------------
	// ----------------------------------------------------------------------------------------------------------------

	// ################################################################################################################
	// Function to call a native page ------------------------------------------------------------------------------------
	// ----------------------------------------------------------------------------------------------------------------
	
	/*
	 * Fonction used to display a native without native process to get the content (now only applicable for video)
	 * nat : name of the page id.
	 * 
	 * @see my_process.advancedClick()
	 */
	my_app.updateNativePage = function(url, nat){
		if(my_app.NATIVE) __I_native_event('dismenu');
		if(!my_app.NATIVE) $.mobile.pageLoading();
		var __url = BASE_URL + url;
		__myapp.getObjectFrom(__url,function(data){
			if(data){
				if(data.up == 1){
					if(!my_app.NATIVE) $.mobile.pageLoading();
					if(!data.c) nat = "none";
					switch(nat){
						case "my-video":
							my_app.registerAction("my-video", ACT_VIEW_AGR);

							if(__isEmpty(data.c)){
								if(!my_app.NATIVE) $.mobile.pageLoading(true);
								else __I_create_dialog(MY_ERROR_MESSAGE[my_app.setLang]["2000"], '__CB_updateNativePage','err');
								//alert(MY_ERROR_MESSAGE[my_app.setLang]["2000"]);
								//if(my_app.NATIVE) __I_native_event('enmenu');
							}else{
								try{
									var __res = "[";
									for (var id in data.c){
										__res += '["'+unescapeChar(data.c[id].label['0'])+'","'+unescapeChar(data.c[id].label['1'])+'","'+data.c[id].video['2'].id+'"],';	
									}
									if(__res.length>1) __res = __res.slice(0, -1);
									__res += "]";
									//alert ("myapp://video?" + encodeURI(__res));
									if(my_app.sim){
										//alert("Le simulateur ne supporte pas cette fonction ...");
									}else{
										window.location = "myapp://video:" +  encodeURIComponent(__res);
									}
									if(!my_app.NATIVE) $.mobile.pageLoading(true);
									if(my_app.NATIVE) __I_native_event('enmenu');
								}catch(err){
							    	try{
										console.log("ERR [updateNativePage] Error on video :" + err.message);
							    	}catch(e){}
									if(!my_app.NATIVE) $.mobile.pageLoading(true);
									else __I_create_dialog(MY_ERROR_MESSAGE[my_app.setLang]["2000"], '__CB_updateNativePage','err');
									//alert(MY_ERROR_MESSAGE[my_app.setLang]["2000"]);
									//if(my_app.NATIVE) __I_native_event('enmenu');
								}
							}
							break;
						// end video.	
							
						default:
							if(!my_app.NATIVE) $.mobile.pageLoading(true);
							__I_create_dialog(MY_ERROR_MESSAGE[my_app.setLang]["1100"], '__CB_updateNativePage', 'err');
							// alert(MY_ERROR_MESSAGE[my_app.setLang]["1100"]);
							// if(my_app.NATIVE) __I_native_event('enmenu');
					}
				}else{
					if(!my_app.NATIVE) $.mobile.pageLoading(true);
					__I_create_dialog(MY_ERROR_MESSAGE[my_app.setLang]["1100"], '__CB_updateNativePage', 'err');
					// alert(MY_ERROR_MESSAGE[my_app.setLang]["1100"]);
					// if(my_app.NATIVE) __I_native_event('enmenu');
				}
			}else{
				if(!my_app.NATIVE) $.mobile.pageLoading(true);
				__I_create_dialog(MY_ERROR_MESSAGE[my_app.setLang]["1100"], '__CB_updateNativePage', 'err');
				// alert(MY_ERROR_MESSAGE[my_app.setLang]["1100"]);
				// if(my_app.NATIVE) __I_native_event('enmenu');
			}

		},function (err){
			if(!my_app.NATIVE) $.mobile.pageLoading(true);
			__getlistContentErr(err,"1000", true, '__CB_updateNativePage', 'err');
		});
		return true;
	};//end updateNativePage
	
// ################################################################################################################
// Function to populate a page ------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
	/*
	 * change = false mean doesn't manage the page change. 
	 */
	my_app.updatePage = function(page, url, title, Change, idAgr, IsRSS, Toolbar){
		idagr = (idAgr)?idAgr:null;
		isRss = (IsRSS == null)?my_app.rss:IsRSS;
		toolbar = (Toolbar == null)?null:Toolbar;

		//update aid of page
		if(idagr){
			$('#'+page).attr('aid', idagr);
			my_app.currentPage=idagr;
		}

		if(idagr != null){
			my_app.registerAction(idAgr, ACT_VIEW_AGR);
		}
		change=( (Change==null) || (Change==undefined) )?MY_DEF_NO_TRANS:Change;
		
		if(my_app.NATIVE) __I_native_event('dismenu');
		if(!my_app.NATIVE) $.mobile.pageLoading();
		
		var __url;
		if(isRss) __url = url;
		else if(url.match(/^http[s]?:\/\//)) __url=url;
		else __url = BASE_URL + url;

		var idItem = $("#"+page).attr('my-model');

		__myapp.getObjectFrom(__url,function(data){
			my_app.comErrMsgDisplay = null;

			if(data){
				if(data.up == 1){

					//detect if they are only an url in data label, true : loadwebview with this url
					if(data.label && __myapp.NATIVE){
						if(COUNTPROP(data.label) == 1){
							for(var __x in data.label){
								var __match;
								if( __match=data.label[__x].trim().match(/^&lt;a(.*)?href=&quot;(.*)?&quot;(.*)?&gt;(.*)?&lt;\/a&gt;$/) ){
									var __href=__match[2].trim();
									__I_native_event('loadurl:'+encodeURIComponent(__href));
									__I_native_event('enmenu');
									return;
								}
							}
						}
					}

					if(title) data.title = title;
					if((data.pm)&&(data.pm.bk)){
						if(idagr != null){
							if(__evalNumberAgr() < MAX_PAGE_STORE){
								if(data.pm.bk == 1){
									if(data.pm.dur){
										__updateListContent("#p" + page + "_" + idagr, data, data.pm.dur);
									}else{
										__updateListContent("#p" + page + "_" + idagr, data);
									}
								}
							}
							if(data.pm.bk == -1000) __deleteFromCache("#p" + page + "_" + idagr);
						}
					}
					
					// stockage de la page dans le localstore temporaire
					if((data.pm)&&(data.pm.guid)){
						__deleteFromCache("__curentPage");
						__deleteFromCache("__curentPageID");
						var __Resume = __loadCacheContent("__currentResume");
						if(__Resume != null){
							data.resume = __Resume;
							data.resume.guid = data.pm.guid;
							// vide localstore temp
							// enregistre la page dans le localstore temporaire
							var __dt = $.toJSON(data);
							__updateListContent("__curentPage", __dt);
							__updateListContent("__curentPageID", data.pm.guid);
							__dt = null;
						}
					}
					
					if(__existFunc("p_" + idItem)){
						//update item class element size.
						eval("p_" + idItem + "(data.pm);");
					}
					__getSingleContent(data, page, false, false, idagr);
					// end data.up == 1
				}else{
					__getSingleContent(null, page, false, false, idagr);
				}
                              
				if(!my_app.NATIVE) $.mobile.pageLoading(true);
				$("#" + page).live('pageshow',function(evt, ui){
					$("#" + page).die('pageshow');
					if(my_app.NATIVE) __I_native_event('enmenu');
				});

				if(my_app.NATIVE && change == false) __I_native_event('enmenu');
				if(change != false) $.mobile.changePage("#" + page, change, false, false, {"title":title});

				if(my_app.NATIVE){
					if(toolbar != null) {
					    if (toolbar != 'unbind')
						__I_native_event('toolbar:'+ toolbar);
					    $("#" + page).bind('pagebeforehide', function(evt, args){
                                            	__I_native_event('toolbar:'+ 'unbind');
					    });
					}
				}

			}else{ // end data
		    	try{
					console.log("[updatePage] enter in data = null ...");
				}catch(e){}

				__getlistContentErr(undefined,"1100", false, '__CB__updateList2', 'err_data_null', page);
				__getSingleContent(null, page, true, false, idagr);
				$("#" + page).live('pageshow',function(evt, ui){
					$("#" + page).die('pageshow');
					if(my_app.NATIVE) __I_native_event('enmenu');
				});
			}

		},function (err){
	    	try{
	            console.log("[updatePage] enter in err ("+err+")");
	    	}catch(e){}
            
			if(!my_app.NATIVE) $.mobile.pageLoading(true);
			var data = __loadCacheContent("#p" + page + "_" + idagr);
			if(data !=null){
				if(__existFunc("p_" + idItem)){
					//update item class element size.
					eval("p_" + idItem + "(data.pm);");
				}
				__getSingleContent(data, page, false, false, idagr);
				if(!my_app.NATIVE) $.mobile.pageLoading(true);
				/*$("#" + page).live('pageshow',function(evt, ui){
					$("#" + page).die('pageshow');
					if(my_app.NATIVE) __I_native_event('enmenu');
				});*/
				if(change != false) $.mobile.changePage("#" + page, change);
				if(my_app.NATIVE){
					if(toolbar != null) __I_native_event('toolbar:'+ toolbar);
				}
			}else{
				// display no content message.
				__getSingleContent(null, page, true, false, idagr);
 			}
			if(my_app.NATIVE) __I_native_event('enmenu');
		},isRss, true);
		return true;
	};//end updatePage
	
	// ----------------------------------------------------------------------------------------------------------------
	// END Function to populate a page --------------------------------------------------------------------------------
	// ----------------------------------------------------------------------------------------------------------------
	
	
// ################################################################################################################
// Useful functions   ---------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------

	/*
		@params additional parameters (ie. URL query parameters).
	*/
	my_app.backReloadImage = function(img, params){
		$(img).attr('src', 'img/myapp/ajax-loader.gif');
		$(img).css('margin', '0 auto 0 auto');
		_resize = {
			w:(params && params.w ? params.w : 32),
			h:(params && params.h ? params.h : 32)
		};
		__resizeImage(img, _resize.w, _resize.h, _resize);
		my_app.loadB64Image(img, params);
	};

	/*
		@params additional parameters (ie. URL query parameters).
		@callback : (function) callback for onload event on image
		* JB 2012-09-11 add search img in a folder(diap or gallery)
	*/
	my_app.loadB64Image = function (loader, params, callback){
		folder=$(loader).attr('albName');
		var image_id = $(loader).attr('id');
		try{
			console.log("LOAD image : " + image_id);
		}catch(e){}
		var __imgUrl;
//		if(my_app.useFlow)
//			__imgUrl = BASE_URL + "/_mMedia.php?image=1&flow=1&id=" + image_id;
//		else

		var __tmsp = new Date().getTime();
		if(folder){
			__imgUrl = BASE_URL + "/_mMedia.php?"+__tmsp+"&diap=img&album="+encodeURIComponent(folder)+"&name="+encodeURIComponent(image_id)+"&isB64=1";
		}else{
			__imgUrl = BASE_URL + "/_mMedia.php?"+__tmsp+"&image=1&id=" + image_id;
		}
		var __maxS = $(loader).attr('max_size');
		if(__maxS){
			__maxS = $.parseJSON(__maxS);

			//test if unit parameters isset
			if(__maxS.unit){
				if(__maxS.unit==="%"){
					//get w and h properties as percent value and get pixels equivalent
					if(__maxS.w){
						__maxS.w=my_app.W*__maxS.w/100;
					}
					if(__maxS.h){
						__maxS.h=my_app.H*__maxS.h/100;
					}
				}
			}

			// get Hash code of the image.
			var __hash = my_app.popImage(image_id,__maxS.w, __maxS.h, true);
			if(__hash != null) {
				__maxS["hash"] = __hash.hash;
			}
		}else{
			__maxS = {"zoom":1, "bk":0};
		}

		var __reduce = $(loader).attr('my_reduce');

		if(__reduce) __maxS["red"] = __reduce;
		else __maxS["red"] = 0;

		if(__maxS) __imgUrl = __imgUrl + "&ms=" + $.toJSON(__maxS);
		if(params)__imgUrl = __imgUrl + "&" + params;
		
		$.get(
			__imgUrl,
			function(data) {
				var __img;
				try{
					if(data.indexOf("data:")==0){
						__img=data;
					}else{
						__img = $.parseJSON(data);
					}
				}catch(e){
					__img=data;
				}
				if(__img){
					var _id = $(loader).attr('id'), __imgC=(__img.c) ? __img.c : __img;

					//var __bk = (__img.red)&&(__img.red == 0)&&(__img.bk)&&(__img.bk == 1);
					var __bk = ((__img.bk)&&(__img.bk == 1))?true:false;

					if(__bk) my_app.pushImage(_id, __imgC, __img.w, __img.h, __img.hash);
					if(callback && typeof callback == 'function') $(loader).onload=callback();
					$(loader).attr('src', __imgC).removeClass('loadable-image');

					__resizeImage(loader, __img.w, __img.h, $(loader).attr('max_size'));
					
					if(!my_app.hasEvent(loader, 'click')){
						$(loader).click(function(evt){
							my_app.reloadImage(this);
						});
					}

					if(__img.red == 1){
						$(loader).attr("my_reduce", "0");
						// Reload Image.
						my_app.loadB64Image(loader, params);
					}

					// Refactor cache images.
					setTimeout(function(){
						if(my_app.iscroll){
							my_app.updatebodyScroll_Active();
							//my_app.iscroll.refresh();
							try{
								console.log("[loadB64Image] Refresh scroller delay 750...");
							}catch(e){}
						}
					}, 500);

				}//End if __img
			}
		).error(function(err){
			if(!my_app.hasEvent(loader, 'click')){
				$(loader).click(function(evt){
					my_app.reloadImage(this);
				});
			}
			$(loader).attr('src', 'img/myapp/unk-icon.png');
		});
	};
	
	my_app.loadImage = function (loader, pCallback){
		image_src = $(loader).attr('src');
		$(loader).html('<img src="./img/myapp/ajax-loader.gif"/>');

		img = new Image();
		$(img).hide();

		$(img).load(function() {
			cb_js = $(loader).get(0).getAttribute('onload');
			onload_cb = function(){
				eval(cb_js);
			};

			$(loader).html(this);
			$(loader).removeClass('loadable-image');
			$(loader).removeAttr('src');
			$(loader).removeAttr('onload');
			$(this).show(); 
			if (onload_cb){
				onload_cb($(this));
			}
			if (pCallback){
				cb = pCallback;
				cb($(this));
			}else{
				if(my_app.iscroll){
					my_app.iscroll.refresh();
				}
			}
		})
		.error(function(err) { $(this).attr('src', "img/myapp/unk-icon.png").show(); })
		.attr('src', image_src)
		.show();
	};

	/*
	 * Simple loader for external image ...
	 */
	my_app.loadImage2 = function (wrapper){
		var image_src = $(wrapper).attr('__src');
		var __img = $("img",wrapper);

		$(__img).load(function() {
			$(wrapper).css('background','none');
			$(wrapper).removeAttr('__src');
			$(wrapper).removeClass('laod-ext-image');
			
			if(my_app.iscroll){
				my_app.iscroll.refresh();
			}
		})
		.error(function(err) { $(this).attr('src', "img/myapp/unk-icon.png").show(); })
		.attr('src', image_src)
		.show();
	};

	my_app.loadAllImage = function (){
		$('.load-img-inprog .loadable-image').each(function(){
			var loader = $(this);
			my_app.loadB64Image(loader);
		});
		$('.reloadable-image').each(function(){
			var loader = $(this);
			if(!my_app.hasEvent(loader, 'click')){
				$(loader).click(function(evt){
					my_app.reloadImage(this);
				});
			}
		});
		$('.laod-ext-image').each(function(){
			my_app.loadImage2(this);
		});
	};

	/*
		function to check backup in localstore then regarding 
		the localstore content to create URL for updating process.
		@page : reference to page sid 
	*/
	my_app.createSyncURL = function(page){	
		var __prev = __loadCacheContent("#" + page);
		if(__prev){
			var __ret = "";
			if(__prev.pm){
				if (__prev.pm.h) __ret = __ret + "&h="+__prev.pm.h;
				if (__prev.pm.dt) __ret = __ret + "&dt="+__prev.pm.dt;
				return __ret;
			}else return "";
		}else{
			return "";
		}
	};

	/*
		Function to populate a list with the content provide inside the HTML code 
		@data : var json array which contain the list content.
			Ex: 
			var __130C = {
			"1":{"id":"43","label":{"fr":{"0":"Label 1 in english"}},"img":{"0":"./img/image1.png"}},
			"2":{"id":"24","label":{"fr":{"0":"Label 2 in english"}},"img":{"0":"./img/image2.png"}}
			};
		@page : page sid to update 
	*/
	my_app.staticList = function(data, page){

        if(my_app.NATIVE) __I_native_event('dismenu');
		if(!my_app.NATIVE) $.mobile.pageLoading();

		var __page = $("#"+page),
		__idModel = __page.attr('my-list'),
		__wrapperUL = $('#' + page + ' .' + __idModel + '-inner'),
		__idItem = __wrapperUL.attr('my-item'),
		__selLang = "",
		__itMod = $('#' + __idItem + "-item");

		if(__wrapperUL.length > 0)$('#' + page + ' .' + __idModel + '-inner').empty();

		if(!__isEmpty(data)){
			var __idClass = __itMod.attr('my-wrap');
			var __nb = 0;
			for (var i in data){
				if(data.hasOwnProperty(i) && i!='nb'){
					var __itWrap = $(__itMod).clone();
					__myapp.removeScriptFromClone(__itWrap);
					var __en = (data[i].en != undefined)?data[i].en:true;//enable
					if(__en){
						if(data[i].id){
							$('li', __itWrap).attr('my-id', data[i].id);
						}
						// lang selection
						if(__selLang == ""){
							if(data[i].label[my_app.setLang]){
								__selLang = my_app.setLang;
							}else{
								try{
									console.log("[staticList] Lang not available !");
								}catch(e){}
								for(key in data[i].label){
									__selLang = key;
									break;
								}
							}
						}

						// add a global link arround the li item.
						if(data[i].link){
							var __child = $(__itWrap).children();
							if(__child.length){
								$(__child).wrapInner('<a class="autolnk" href="'+data[i].link.l+'"></a>');
							}
						}

						if(data[i].label){
							for (var pid in data[i].label[__selLang]){
								var __lbls;
								__lbls = $('span[pid="'+pid+'"]',__itWrap);
								if(!__lbls.length){
									__lbls = $("."+__idItem+"-l"+pid,__itWrap);
								}
								for (var k=0; k<__lbls.length; k++){
									var __html = data[i].label[__selLang][pid];
									__lbls[k].innerHTML = unescapeChar(__html);
									__html = null;
								}
							}
						}

						if(data[i].img){
							for (var pid in data[i].img){
								var __lbls;
								__lbls = $('img[pid="'+pid+'"]',__itWrap);
								if(!__lbls.length){
									__lbls = $("."+__idItem+"-img"+pid,__itWrap);
								}
								for (var k=0; k<__lbls.length; k++){
									__lbls.attr('src', data[i].img[pid]);
								}
							}
						}else if(my_app.defaultImage){
							$('img[pid]',__itWrap).each(function(){
								$(this).attr('src', my_app.defaultImage);
							});
						}

						__nb++;

						// Image overwrite.
						__wrapperUL.append(__itWrap.html());
					}//end if __en
				}
			}//end for
			data.nb = __nb;
			$("li", __wrapperUL).wrapAll('<ul class="'+__idClass+'-ul"/>');
		}else{
			try{
				console.error("[staticList] No data to create list for page : " + page + "\n- Verify you have a corresponding <menu> in <my_params> definition.");
			}catch(e){}
		}
		
		if(__existFunc("p_" + __idItem)){
			//update idItem class element size.
			eval("p_" + __idItem + "();");
		}
		
		if(my_app.iscroll) my_app.iscroll.refresh();		
		
		if(!my_app.NATIVE) $.mobile.pageLoading(true);
		if(my_app.NATIVE) __I_native_event('enmenu');
		return true;
	};
	
	// ----------------------------------------------------------------------------------------------------------------
	// END Useful functions  ------------------------------------------------------------------------------------------
	// ----------------------------------------------------------------------------------------------------------------
	
	
// ################################################################################################################
// Misc private functions  ----------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------	
	
	/*
	 * Force the title of a page to be updated ...
	 * @page id of the concerned page
	 * @title title to set.
	 */
	my_app.updateHeadTitle = function(page, title){
		my_app.currentTitle = title; 
		__updateHeadTitle(page, title);
	};
	
	function __updateHeadTitle(page, title){
		//update header title
		if((title == null)||(title == undefined)) return;

		$("#"+page+" .my-head-titleLabel").removeAttr("style");
		$("#"+page+" .my-head-titleLabel").empty();
		var __headerBlock=$("#"+page+" .my-header-l1");
		if(__headerBlock.length){
			var __sizeBlock=__headerBlock[0].offsetWidth;
			var __sizeTitle = my_app.getMaxStrWidthClass(["headerTable", "my-head-titleLabel"], title);

			//added to take care about childs css(padding, border-width, margin) in length calculation
			var __children=$(__headerBlock[0]).children();
			var __sizeChildren=0, __off;
			for(var __i=0;__i<__children.length;__i++){
				__off=__children[__i].offsetWidth;
				if(__off>__sizeChildren) __sizeChildren=__off;
			}
			__off=__children=null;

			if( __sizeTitle > (__sizeBlock-__sizeChildren) ){
				var __fontSize = my_app.extractFirstNums($("#"+page+" .my-head-titleLabel").css("font-size"));
				//__fontSize=__fontSize-5;
				$("#"+page+" .my-head-titleLabel").attr("style", "font-size:" + __fontSize+"px;");
				__sizeTitle = my_app.getMaxStrWidthClass(["headerTable", "my-head-titleLabel"], title,"font-size:" + __fontSize+"px;" );

				var __nbChar= title.length;
				var __toNb=(__nbChar/__sizeTitle)*(__sizeBlock-__sizeChildren);
				__toNb=Math.round(__toNb-1)-3;
				title=title.substr(0,__toNb)+"...";
			}
			//$('.'+page+'-title').attr('innerHTML', title);
			$("#"+page+" .my-head-titleLabel").html(title);
		}
	}

	/*
	 * @see my_process.initFavMenu()
	 * @see my_list.sortListByPid()
	 */
//	my_app.updateListContent = function(data, page){
	my_app.createListFromContent = function(data, page, Change, idAgr){
		change = (Change)?Change:null;
		idagr = (idAgr)?idAgr:null;

		if(idagr != null){
			my_app.registerAction(idAgr, ACT_VIEW_AGR);
		}

		if(my_app.NATIVE) __I_native_event('dismenu');
		if((data)&&(COUNTPROP(data.c) > 0)) {
			__getSingleListContent2(data, page, change, false, true, false, null, idagr);
		}else{
			__getSingleListContent2(null, page, change, false, true, true, null, idagr);
		}
	};
	
	/*
	 * Used by error call back function.
	 */
	my_app.getSingleListContent2=function(data, page, change, useImg, loading, noContent, noctmsg, idAgr){
		__getSingleListContent2(data, page, change, useImg, loading, noContent, noctmsg, idAgr);
	};
	
	/*
		@see my_app.updateList2
		@useImg : use embeeded images (ie. my_app.catImg)
	*/
	function __getSingleListContent2(data, page, change, useImg, loading, noContent, noctmsg, idAgr){
		
		loading = (loading == null)?false:loading;
		nocontent = (noContent == null)?false:noContent;
		idagr = (idAgr)?idAgr:null;
		
		try{
			console.log("[__getSingleListContent2] for page "+ page + ", nocontent:" +  nocontent);
		}catch(e){}

		//update header title
		if(data && data.title){
			if(my_app.hasEvent($("#"+page), "pageloaded")){
			}else{
				//$('.'+page+'-title').attr('innerHTML', data.title)
				$("#"+page).bind("pageloaded", function(){
					__updateHeadTitle(page, data.title);
					$("#"+page).unbind("pageloaded");//JB 2012-12-05 : solve issue which title was set by first title
				});
			}
		};

		if(nocontent){
			noctmsg = (noctmsg)?noctmsg:(MY_ERROR_MESSAGE[my_app.setLang]["1100"]);
			__displayNoContent(page, noctmsg);
			
			if((change)&&(change!==false)){
				setTimeout(function __finish_pop(){
					if(!my_app.NATIVE) $.mobile.pageLoading(true);
					if(my_app.iscroll) my_app.iscroll.refresh();
					if(change){
						$("#" + page).live('pageshow',function(evt, ui){
							$("#" + page).die('pageshow');
							if(my_app.NATIVE) __I_native_event('enmenu');
						});
						if(change == MY_DEF_NO_TRANS){
							$.mobile.changePage("#" + page, MY_DEF_NO_TRANS, false);
						}else{
							$.mobile.changePage("#" + page, change);
						}
						$("#"+ page).removeClass("load-img-inprog");
					}else{
						if(my_app.NATIVE) __I_native_event('enmenu');
					}
				},1000);
			}else{
				try{
					console.log("[__getSingleListContent2] WARNING (page:"+ page +") no change require!");
				}catch(e){}
				if(my_app.NATIVE) __I_native_event('enmenu');
			}			
			return null;
		}
		
		// @see __CB__updateList2
		// Impossible (conflict with nocontent)
/*		
		if(data == null){
//			alert(MY_ERROR_MESSAGE[my_app.setLang]["1150"]);
//			if(!my_app.NATIVE) $.mobile.pageLoading(true);
//			if(my_app.NATIVE) __I_native_event('enmenu');
			return {"msg":MY_ERROR_MESSAGE[my_app.setLang]["1150"], "cb":"__CB__updateList2", "id":"nodata"};
		}
*/

		// pager management ...
		// Init pager system.
		// TODO : for test only 
		//data.pg={"t":"pull", "idx":0, "nb":0}
		if(data.pg){
			__listPagerInit(page, data);
		}else{
			if(my_app.pager.use){
				// reset pager object 
				// raz pager mechanism let only the scroll configuration.
				if(my_app.iscrollPullDiv != null) my_app.resetPullToRefresh();
			}else{
				my_app.pager = {"use":false, "idx":0, "nb":0, "dir":"", "page":"", "type":"", "rss":"", "cat":"", "isx":0, "isy":0};
				// raz pager mechanism let only the scroll configuration.
				if(my_app.iscrollPullDiv != null) my_app.resetPullToRefresh();
			}
		}//end pager management.

        var __tmpL = $("#"+page),
		__idModel = __tmpL.attr('my-list'),
		__wrapperUL = $('#' + page + ' .' + __idModel + '-inner'),
		__idItem = __wrapperUL.attr('my-item');

		if(__existFunc("p_" + __idItem)){
			//update __idItem class element size.
			eval("p_" + __idItem + "(data.pm);");
		}
		
		// Remove the previous content.
		if(__wrapperUL.length){
                          
			if(my_app.pager.use){
				// Check content to remove if pager
              if(!data.pg)  my_app.pager = {"use":false, "idx":0, "nb":0, "dir":"", "page":"", "type":"", "rss":"", "cat":"", "isx":0};
                __listPagerCheckEmpty(__wrapperUL);
				if(my_app.pager.reset){
					$(__wrapperUL).empty();
					my_app.pager.reset = false;
				}
			}else{
				if((data.pm)&&(data.pm.restorable)){
					try{
						if(__wrapperUL[0].children.length>0){
							setTimeout(function __finish_pop(){
								if(!my_app.NATIVE) $.mobile.pageLoading(true);
								//if(my_app.iscroll) my_app.iscroll.refresh();
								if(data.pg){
									//my_app.iscroll.scrollTo(0,0,true);
								}
								if(change){
									$("#" + page).live('pageshow',function(evt, ui){
										$("#" + page).die('pageshow');
										if(my_app.NATIVE) __I_native_event('enmenu');
									});
									if(change == MY_DEF_NO_TRANS){
										$.mobile.changePage("#" + page, MY_DEF_NO_TRANS, false);
									}else{
										$.mobile.changePage("#" + page, change, false);
									}
									$("#"+ page).removeClass("load-img-inprog");
								}else{
									if(my_app.NATIVE) __I_native_event('enmenu');
								}
							},250);
							return ;
						}
					}catch(e){
						$(__wrapperUL).empty();
					}
				}else $(__wrapperUL).empty();
				
			}//End if my_app.pager.use
			
		}else{
			try{
				console.log("[__getSingleListContent2] WARNING  for page "+ page + ", wrapul:" + ' .' + __idModel + '-inner : not found ...');
			}catch(e){}
		}//end remove previous content.

		if(__tmpL.length != 0){
			var __itMod = $("#"+__idItem+"-item");
			if(__itMod.length <= 0){
				try{
					console.log("[__getSingleListContent2] WARNING  for page "+ page + ", model list :" + __idItem +"-item : not found ...");
				}catch(e){}
			}

			// detection overflow
			var oFlowType = $(__itMod).attr('my-oflow');

			var __idClass = __itMod.attr('my-wrap');
			// get the index of the subject of mail.
			var __indexSubMail = __itMod.attr('my-up-mail');
			// get the index of the subject of tel.
			var __indexSubTel = __itMod.attr('my-up-tel');
			//simple share : open a pop-up menu to share on fb, twitter, mail & sms
			var __indexSubSimpleShare = __itMod.attr('my-up-simpleShare');

			// Remove favorite list for the current fid (aid).
			var __cloneFav;
			if(my_app.isFav){
				if(data.fid){
					__cloneFav = jQuery.extend(true, {}, my_app.fav);
					if(__cloneFav[data.fid]){
						delete __cloneFav[data.fid];
						__cloneFav[data.fid] = {};
					}
				}
			}//end if my_app

			// split index
			// sort object to display the most recent ssid in top of the list
			// reverse the list of SSID
			var __sortedDataC=[];
			for(var __x in data.c){
				__sortedDataC.push(__x);
			}

			//JB 2012-11-20 : add function sortNumber in sort to fix sort issue (ex : 0,1,10,2,3,..)
			//fix chrome issue with array
			__sortedDataC.sort(sortNumber).reverse();

			if(data.pm.sort){
				if(data.pm.sort === 'asc') __sortedDataC.sort(sortNumber);
				else __sortedDataC.sort(sortNumber).reverse();
			} 

			// loop on SSID
			for(var __i=0;__i<__sortedDataC.length;__i++){
				ssid = __sortedDataC[__i];
				var __itWrap = $(__itMod).clone();
				__myapp.removeScriptFromClone(__itWrap);
				if((data.c[ssid].link)&&(!emptyObject(data.c[ssid].link))){
					$('li', __itWrap).removeAttr('my-id').removeAttr('idx').removeAttr('guid');
				}else{
					$('li', __itWrap).attr('my-id', data.c[ssid].id).attr('idx', ssid);
					if(data.c[ssid].guid) $('li', __itWrap).attr('guid', data.c[ssid].guid);
				}

				var __lbls = $('div[notnull="true"]',__itWrap);
				if(__lbls.length){
					for (var k=0; k<__lbls.length; k++){
						if(data.c[ssid].id == "") $(__lbls).css('visibility', 'hidden');
						else $(__lbls).css('visibility', 'visible');
					}
				}

				// Manage the case of using overflow for large item.
				var __oflow = $('.my-oflow', __itWrap);
				if(__oflow.length > 0){
					// Management of the end line in case of overflow.
					if((oFlowType == '')||(oFlowType == 'none')){
						$(__oflow).css('white-space', 'normal');
					}else{
						$(__oflow).css('white-space', 'nowrap');
						if(oFlowType == '...'){
							$(".my-endgrad", __itWrap).css('display', 'none');
							var __of_style = $(__oflow).attr("my0f-style");
							__of_style = __of_style.replace(/'/gi,"\"");
							__of_style = $.parseJSON(__of_style);
							var __of_index = parseInt($(__oflow).attr("my0f-index"), 10);
							var __val;
							if(data.pm.pid){
								__val = data.c[ssid].label[__of_index];
							}else{
								__val = data.c[ssid].label[__of_index]["v"];
							}

							var __sizeBlock = my_app.extractFirstNums($(__oflow).css("width"));
							var __sizeVal = my_app.getMaxStrWidthClass(__of_style, __val);
							
							if(__sizeVal>__sizeBlock){
								var __nbChar= __val.length;
								var __toNb = (__nbChar/__sizeVal)*__sizeBlock;
								__toNb = Math.round(__toNb -1 ) -3;
								__val = __val.substr(0,__toNb) + "...";
								data.c[ssid].label[__of_index]["v"] = __val;
							}
						
						}else if(oFlowType == 'grad'){
							$(".my-endgrad", __itWrap).css('display', 'block');
						}
					}
				}
				
				// manage PID of each Item
				if(data.pm.pid){
					if(my_app.isFav){
						if(data.fid){
							if(__cloneFav){
								__cloneFav[data.fid][ssid] = 1;
							}
						}
					}//end if my_app
					
					// Date label mangement
					for (var pid in data.c[ssid].date){
						var __lbls = $('span[pid="'+pid+'"]',__itWrap);
						if(!__lbls.length) {
							try{
								console.log("[__getSingleListContent2] WARNING (page:"+page+") No span date label (model:"+__itWrap.attr('id')+") for pid=" + pid);
							}catch(e){}
						}
						var html = unescapeChar(data.c[ssid].date[pid] + "");
						html = jQuery.trim(html);
						if( (html != "") && (html != "null") ){
							for (var k=0; k<__lbls.length; k++){
								var __d = new Date();
								__lbls[k].innerHTML = __d.formatISO8601(html, my_app.setLang);
								$(__lbls[k]).attr('tstamp', __d.getTime());
							}
						}//end if
					}// end for pid.date

					var __mandOk = true;
					for (var pid in data.c[ssid].label){
						// Check if ssid exist in favorite.
						var __lbls = $('span[pid="'+pid+'"]',__itWrap);
						if(!__lbls.length) {
							try{
								console.log("[__getSingleListContent2] WARNING (page:"+page+") No span label (model:"+__itWrap.attr('id')+") for pid=" + pid);
							}catch(e){}
						}

						var html = unescapeChar(data.c[ssid].label[pid] + "");
						html = jQuery.trim(html);
						if( (html != "") && (html != "null") ){
							for (var k=0; k<__lbls.length; k++){
								__lbls[k].innerHTML = html;
								if(data.c[ssid].css){
									if(data.c[ssid].css[pid]){
										$(__lbls[k]).attr('class', '');
										$(__lbls[k]).addClass(data.c[ssid].css[pid]);
									}
								}
							}

							//blockid
							var __lblbid = $('*[blockid="'+pid+'"]',__itWrap);
							for (var k=0; k<__lblbid.length; k++){
								var __pCSSStyle = $(__lblbid[k]).attr('__pdisp');
								if(__pCSSStyle){
									$(__lblbid[k]).css('display',__pCSSStyle);
								}else{
									__pCSSStyle = $(__lblbid[k]).css('display');
									if(__pCSSStyle){
										$(__lblbid[k]).attr('__pdisp', __pCSSStyle);
									}else{
										$(__lblbid[k]).css('display','block');
									}
								}
							}
						}else{
							//mand
							var __manPid = $(__lbls).attr('mand');
							if(__manPid){
								__mandOk = false;
								break;
							}

							//blockid
							var __lblbid = $('*[blockid="'+pid+'"]',__itWrap);
							for (var k=0; k<__lblbid.length; k++){
								var __pCSSStyle = $(__lblbid[k]).css('display'); 
								if(__pCSSStyle){
									$(__lblbid[k]).attr('__pdisp', __pCSSStyle);
								}
								$(__lblbid[k]).css('display','none');
							}
							__lblbid=null;
						}
						
					}//end for pid (label) ...
					
					// get to next element if pid mandatory is not respected
					if(!__mandOk) continue;
					
				}else{
					// Compatibilité ancienne version
					for (var j=0; j<data.c[ssid].label.length; j++){
						var __lbls = $("."+__idItem+"-l"+j,__itWrap);
						for (var k=0; k<__lbls.length; k++){
							var html = unescapeChar(data.c[ssid].label[j]["v"]);
							__lbls[k].innerHTML = html;
							if(data.c[ssid].label[j]["s"]){
								$(__lbls[k]).attr('class', '');
								$(__lbls[k]).addClass(data.c[ssid].label[j]["s"]);
							}
						}
					}
				}// end manage PID.
				
				if(__indexSubSimpleShare){
					__setSimpleShareLink(__indexSubSimpleShare, data, __idItem, __itWrap, ssid);
				}else{
					try{
						console.log("[__getSingleListContent2] WARNING No simpleShare to do (page : " + page +")");
					}catch(e){}
				}

				
				if(__indexSubMail){
					var __MailParam = jQuery.parseJSON(__indexSubMail);
					var __tzone = $("#test_zone");
					var __tblock = null;
					if(__tzone.length){
						$(__tzone).css("display","block");
						$(__tzone).css("visibility","hidden");
						__tblock = $("#test_block", __tzone);
						if(!__tblock.length) __tblock = null;
					}					
					for(__idmail in __MailParam){					
						var __mail = $("#" + __idmail , __itWrap);
						var __href = $(__mail).attr('mail-content');
						if(!__href){
							__href = $(__mail).attr('href');
						}

						for(__idx in __MailParam[__idmail]){
							var __unhtml;
							if(data.pm.pid){
								__unhtml = html_entity_decode(data.c[ssid].label[__MailParam[__idmail][__idx]]);								
								if(__tblock){
									$(__tblock).html(__unhtml);
									var __str = $(__tblock).html();
									__unhtml = encodeURIComponent(__str);
									$(__tblock).html("");
								}
							}else{
								__unhtml = html_entity_decode(data.c[ssid].label[__MailParam[__idmail][__idx]]["v"]);
							}
							var __r = "%_" + __idx;
							var reg = new RegExp("("+__r+")", "g");
							__href = __href.replace(reg, __unhtml);						
						}
						
						$(__mail).attr('href', __href);
						__mail = null;
					}
					if(__tzone.length){
						__tzone.css("display","none");
						__tzone.css("visibility","visible");
						__tblock = null;
					}
				}// end __indexSubMail
				
				if(__indexSubTel){
					var __MailParam = jQuery.parseJSON(__indexSubTel);
					var __tzone = $("#test_zone");
					var __tblock = null;
					if(__tzone.length){
						$(__tzone).css("display","block");
						$(__tzone).css("visibility","hidden");
						__tblock = $("#test_block", __tzone);
						if(!__tblock.length) __tblock = null;
					}					
					for(__idmail in __MailParam){
						var __mail = $("#" + __idmail , __itWrap);
						var __href = $(__mail).attr('tel-content');
						if(!__href){
							__href = $(__mail).attr('href');
						}

						for(__idx in __MailParam[__idmail]){
							var __unhtml;
							if(data.pm.pid){
								__unhtml = html_entity_decode(data.c[ssid].label[__MailParam[__idmail][__idx]]);								
								if(__tblock){
									$(__tblock).html(__unhtml);
									var __str = $(__tblock).html();
									__unhtml = encodeURIComponent(__str);
									$(__tblock).html("");
								}
							}else{
								__unhtml = html_entity_decode(data.c[ssid].label[__MailParam[__idmail][__idx]]["v"]);
							}
							var __r = "%_" + __idx;
							var reg = new RegExp("("+__r+")", "g");
							__href = __href.replace(reg, __unhtml);
						}
						
						$(__mail).attr('href', __href);
						__mail = null;
					}
					if(__tzone.length){
						__tzone.css("display","none");
						__tzone.css("visibility","visible");
						__tblock = null;
					}
				}//end __indexSubTel
				
				if(idagr != null){
					$('a[action="tel"]').each(function(){
						$(this).attr('agr',idagr);
					});

					$('a[action="share"]').each(function(){
						$(this).attr('agr',idagr);
					});
					
					$('a[action="com"]').each(function(){
						$(this).attr('agr',idagr);
					});
					
					$('a[action="agenda"]').each(function(){
						$(this).attr('agr',idagr);
					});

					$('a[action="link"]').each(function(){
						$(this).attr('agr',idagr);
					});
				}//end idagr
				
				// manage link
				if(data.c[ssid].link){
					for (__link in data.c[ssid].link){
						if(data.c[ssid].link.l){
							var __child = $(__itWrap).children();
							if(__child.length){
								$(__child).wrapInner('<a class="autolnk" href="'+data.c[ssid].link.l+'"></a>');
							}
						}else{
							$('a[pid='+__link+']',__itWrap).each(function(){
								$(this).attr('href',data.c[ssid].link[__link].l);
							});
						}
					}
				}// end manage link

				// manage Image.
				// Image can be lodaded from the server or loaded on the application
				// if 'id' parameter exist, image will be loaded from the server with _mMedia
				// ex :	"img":{"0":{"id":"toto.png", "h":"0000"}},
				// else if 'v' parameter exist, in this case image will loaded from the application
				// ex :	"img":{"0":{"v":"toto.png"}},
				if(data.c[ssid].img){
					var __useCat = (useImg)?((useImg == null)?false:useImg):false;
					if(data.c[ssid].img.length == 0){
						$('img',__itWrap).each(function(){
							$(this).css('display', 'none');
						});
						if(__useCat){
							if(my_app.catImg[ssid]){
								var __lbls = $("."+__idItem+"-img0",__itWrap);
								__lbls.attr('src', my_app.catImg[ssid].src);
								__lbls.css('display', 'block');
							}else{
								if(my_app.catImg['def']){
									var __lbls = $("."+__idItem+"-img0",__itWrap);
									__lbls.attr('src', my_app.catImg['def'].src);
									__lbls.css('display', 'block');
								}
							}
						}
					}else{
						if(data.pm.pid){
							$('img[pid]',__itWrap).each(function(){
								$(this).css('display', 'none');
							});
							for (var pid in data.c[ssid].img){
								var __lbls = $('img[pid="'+pid+'"]',__itWrap);
								if(!__lbls.length){
									try{
										console.log("[__getSingleListContent2] WARNING (page:"+page+") No img (model:"+__itWrap.attr('id')+") for pid=" + pid);
									}catch(e){}
								}else{
									//__lbls.css('display', 'block');
									var _resize = $(__lbls).attr('max_size');
									var __res;
									try{
										if (_resize) __res = jQuery.parseJSON(_resize);
										else __res = {w:0, h:0};
									}catch(e){
										__res = {w:0, h:0};
									}

									if(data.c[ssid].img[pid]["id"]){
										if(jQuery.trim(data.c[ssid].img[pid]["id"])!=""){
											$(__lbls).attr('id', data.c[ssid].img[pid]["id"]);
											var __img = my_app.popImage(data.c[ssid].img[pid]["id"], __res.w, __res.h);
											if( __img != null){
												$(__lbls).attr('src', __img.c);
												$(__lbls).addClass("reloadable-image");
												data.c[ssid].img[pid]["w"] = __img.w;
												data.c[ssid].img[pid]["h"] = __img.h;
											}else{
												$(__lbls).addClass("loadable-image");
												$(__lbls).attr('src', 'img/myapp/ajax-loader.gif');
												$(__lbls).css('margin', '0 auto 0 auto');
												_resize = {"w":32, "h":32};
												$(__lbls).unbind('click');
											}
											__img = __res = null;
											$(__lbls).css('display', 'block');
										}else{
											$(__lbls).css('display', 'none');
										}
									}else{
										if(data.c[ssid].img[pid]["v"]){
											var __imgwrap = $("#__imageWrap",__itWrap);
											if(__imgwrap.length){
												$(__imgwrap).css('background','url(./img/myapp/ajax-loader.gif) no-repeat center center');
												$(__imgwrap).addClass("laod-ext-image");
												$(__imgwrap).attr('__src', data.c[ssid].img[pid]["v"]);
											}else{
												$(__lbls).attr('src', data.c[ssid].img[pid]["v"]);
											}
											$(__lbls).css('display', 'block');
										}else $(__lbls).css('display', 'none');
									}
									if (_resize){
										__resizeImage(__lbls, data.c[ssid].img[pid]["w"], data.c[ssid].img[pid]["h"], _resize);
									}
								}//End if
							}
						}else{
							for (var j=0; j<data.c[ssid].img.length; j++){
								var __lbls = $("."+__idItem+"-img"+j,__itWrap);
								var _resize = $(__lbls).attr('max_size');
								var __res;
								try{
									if (_resize) __res = jQuery.parseJSON(_resize);
									else __res = {w:0, h:0};
								}catch(e){
									__res = {w:0, h:0};
								}
								if(data.c[ssid].img[j]["v"]){
									$(__lbls).attr('src', data.c[ssid].img[j]["v"]);
								}
								if(data.c[ssid].img[j]["id"]){
									$(__lbls).attr('id', data.c[ssid].img[j]["id"]);
									var __img = my_app.popImage(data.c[ssid].img[j]["id"], __res.w, __res.h);
									if( __img != null){
										$(__lbls).attr('src', __img.c);
										$(__lbls).addClass("reloadable-image");
										data.c[ssid].img[j]["w"] = __img.w;
										data.c[ssid].img[j]["h"] = __img.h;
									}else{
										$(__lbls).addClass("loadable-image");
										$(__lbls).attr('src', 'img/myapp/ajax-loader.gif');
										$(__lbls).css('margin', '0 auto 0 auto');
										_resize = {"w":32, "h":32};
										$(__lbls).unbind('click');
									}
									__img = __res = null;
								}
								$(__lbls).css('display', 'block');
								if (_resize){
									__resizeImage(__lbls, data.c[ssid].img[j]["w"], data.c[ssid].img[j]["h"], _resize);
								}
							}
						}//end if pm.pid
					}
				}else{
					if((my_app.catImg)&&(my_app.catImg[ssid])){
						__lbls.attr('src', my_app.catImg[ssid]).css('display', 'block');
					}else{
						if(my_app.defaultImage){
							$('img[pid]',__itWrap).each(function(){
								$(this).attr('src', my_app.defaultImage);
							});
						}
					}
				}// end manage image ...

				// dynamic table management.
				// create a list of information arranged as a table
				// warning : table information must be received as followed.
				// "table":{"pid":"[&quot;info1&quot;, &quot;info2&quot;]"}
				if(data.c[ssid].table){
					for (var pid in data.c[ssid].table){
						var __lbls = $('span[pid="'+pid+'"]',__itWrap), __data;
						try{
							__data = jQuery.parseJSON(unescapeChar(data.c[ssid].table[pid]));
							if(__data != ""){
								__table = __createTable(__data);
								for (var k=0; k<__lbls.length; k++){
									__lbls[k].innerHTML = __table;
								}
								$('*[blockid="'+pid+'"]',__itWrap).css('display','');
							}else{
								$('*[blockid="'+pid+'"]',__itWrap).css('display','none');
							}
						}catch(e){
							$('*[blockid="'+pid+'"]',__itWrap).css('display','none');
						}
						__data = null;
					}
				}else{
					$('span[my-ctype="tablist"]',__itWrap).each(function(){
						$('*[blockid="'+$(this).attr('pid')+'"]',__itWrap).css('display','none');
					});
				}

				if(data.c[ssid].timestamp){
					for (var pid in data.c[ssid].timestamp){
						var __lbls = $('span[pid="'+pid+'"]', __itWrap);
						__lbls.html(my_app.timestampToDate(data.c[ssid].timestamp[pid], 'yyyy-mm-dd hh:mm'));
						__lbls=null;
					}
				}

				__wrapperUL.append(__itWrap.html());
				$(__itWrap).remove();
				__itWrap = null;
				
			}//end for ssid (loop on SSID)

			if(my_app.isFav){
				if(data.fid){
					if(__cloneFav){
						my_app.fav = null;
						my_app.fav = jQuery.extend(true, {}, __cloneFav);
						__I_db_save("favoris", $.toJSON(__cloneFav));
					}
				}
			}
			
			// Final update necessary for pager
			// Add the navigation button just behind the list
			if(my_app.pager.use){
				__listPagerUpdateButton(data, __wrapperUL);
			}
			
			$("#"+ page).addClass("load-img-inprog");
			my_app.loadAllImage();
			
			
			$('#'+page + ' .' + __idModel + '-inner li').wrapAll('<ul class="'+__idClass+'-ul"/>');
			if((change)&&(change!==false)){
				setTimeout(function __finish_pop(){
					if(!my_app.NATIVE) $.mobile.pageLoading(true);
					//if(my_app.iscroll) my_app.iscroll.refresh();
					if(change){
						$("#" + page).live('pageshow',function(evt, ui){
							$("#" + page).die('pageshow');
							if(my_app.NATIVE) __I_native_event('enmenu');
						});
						
						if(change == MY_DEF_NO_TRANS){
							$.mobile.changePage("#" + page, MY_DEF_NO_TRANS, false);
						}else{
							$.mobile.changePage("#" + page, change);
						}
						
						$("#"+ page).removeClass("load-img-inprog");
					}else{
						if(my_app.NATIVE) __I_native_event('enmenu');
					}
				},1000);
			}else{
				try{
					console.log("[__getSingleListContent2] WARNING (page:"+ page +") no change require!");
				}catch(e){}
				setTimeout(function __finish_pop(){
					//if(my_app.iscroll) my_app.iscroll.refresh();
					if(data.pg){
					}else{
						//if(my_app.iscroll) my_app.iscroll.scrollTo(0,0,true);
					}
					if(loading){
						if(!my_app.NATIVE) $.mobile.pageLoading(true);
						if(my_app.NATIVE) __I_native_event('enmenu');
					}
				},750);
			}

			// check if there is a content to display in an accordion
			var __foo = $("#"+page+" li");	// current list
			__foo.each(function(i){
				var thisLi = $(this);
				var bar = $("#ss-menu-content", thisLi); // current content
				var foobar = bar.text(); // content value of bar

				// if there is no content, we hide the accordion button and the div content
				if((foobar.length == 0) | (foobar == undefined)){
					$("#ss-menu-div", thisLi).attr('style', 'display:none;');
					$("#ss-menu-icon", thisLi).attr('style', 'display:none;');
				}
			});	
		}else{
			try{
				console.log("[__getSingleListContent2] Unable to find List type (for : " + page +")");
			}catch(e){}
			// TOTO afficher message erreur 
			if(loading){
				if(!my_app.NATIVE) $.mobile.pageLoading(true);
				if(my_app.NATIVE) __I_native_event('enmenu');
			}
		}
		
		return null;
	}// end __getSingleListContent2

	// ---------------------------------------------------------------------------------------------------------------------------------
	// --- Fonction pour les pagers ...
	// ---------------------------------------------------------------------------------------------------------------------------------
	
	// Init the pager type 
	// REMARK : Protocol return must include "data.pg" attribut in order to enable the pager mechanism.
	// 
	// Default type = MY_PAGER_PULL
	// configuration of the pull 2 refresh will be realize via the "p2r" parameters in the page definition
	// p2p = callback function.
	
	function __listPagerInit(page, data){
		
		if(data.pg.t == MY_PAGER_PLUS){
			// TODO : verifier l'utilité (utilisé uniquement par Veloland)
			if(data.pg.d === "1"){
				$("#"+ page +" #pager-next-bt").css('display', 'none');
			}else{
				$("#"+ page +" #pager-next-bt").css('display', 'block');
			}
		}//end if MY_PAGER_PLUS
		
		// config for pull 2 refresh pager ...
		if(data.pg.t == MY_PAGER_PULL){
			var __p2r  = $("#"+page).attr('p2r');
			if(__p2r != undefined){
				if(my_app.iscrollPullDiv == null) {
					my_app.configurePullToRefresh(page, __p2r);
				}else{
					if(my_app.iscrollParam.p2rCallback !== __p2r){
						my_app.pager.reset = true;
						my_app.resetPullToRefresh();
						my_app.configurePullToRefresh(page, __p2r);
					}
				}
			}else{
				if(my_app.iscrollPullDiv != null) my_app.resetPullToRefresh();
			}
		}//end if MY_PAGER_PULL
		
		if(data.pg.t == MY_PAGER_LR){
			// TODO : verifier l'utilité (pas utilisé)
			$("#"+ page +" #pager-next-bt").css('display', 'block');
			switch (data.pg.d) {
				case "1":
					$("#"+page+" #pager-left").css('display', 'block');
					$("#"+page+" #pager-right").css('display', 'none');
				break;
				case "3":
					$("#"+page+" #pager-left").css('display', 'none');
					$("#"+page+" #pager-right").css('display', 'block');
				break;
				default:
					$("#"+page+" #pager-right").css('display', 'block');
					$("#"+page+" #pager-left").css('display', 'block');
				break;
			}
		}//end if MY_PAGER_LR
		
		$("#"+page).attr('pager', '1');
		my_app.pager.use = true;
		my_app.pager.type = data.pg.t;
		my_app.pager.idx = parseInt(data.pg.i, 10);
		my_app.pager.nb = parseInt(data.pg.nb, 10);
		
		my_app.pager.dir = data.pg.d;
		my_app.pager.page = page;
		my_app.pager.rss = data.pg.rss;
		my_app.pager.cat = data.pg.cat;
	}//end __listPagerInit
	
	function __pagerReset(page, data){
		// config for pull 2 refresh pager ...
		if(data.pg.t == MY_PAGER_PULL){
			my_app.resetPullToRefresh();
		}//end if MY_PAGER_PULL
	}
	
	// Check if it is necessary to remove the previous content
	function __listPagerCheckEmpty(__wrapperUL){
		try{
			console.log("[__listPagerCheckEmpty] type : "+my_app.pager.type);
		}catch(e){}
		if(my_app.pager.type == MY_PAGER_PLUS){
			// remove the 'plus' button at the end of the list
			$("#pager-plus-button", __wrapperUL).remove();
			if(my_app.iscroll){
				my_app.pager.isx = my_app.iscroll.x;
				my_app.pager.isy = my_app.iscroll.y;
			}
			if(my_app.pager.idx == 0) $(__wrapperUL).empty();
		}else if(my_app.pager.type == MY_PAGER_PULL){
			// remove the 'pull up' message at the end of the list
			$("#pullUp", __wrapperUL).remove();
		}else if(my_app.pager.type == MY_PAGER_LR){
			// TODO mettre à jour la méthode utilisée
			$(__wrapperUL).empty();
		}else{
			$(__wrapperUL).empty();
		}
	}//end __listPagerCheckEmpty
	
	
	// last update for pager
	function __listPagerUpdateButton(data, __wrapperUL){
		if(my_app.pager.type == MY_PAGER_PLUS){
			// TODO : verifié l'utilité utilisé uniquement pour Veloland
			// Add at the end of the list the boutton 'plus' used to display more element. 
			if(my_app.pager.dir != "1"){
				var _nplusbut = $("#pager-plus-button").clone();
				$("#pager-next-bt",_nplusbut).css('display', 'block');
				
				$("#lbl_bt_plus", _nplusbut).html(MY_SYS_LABEL[my_app.setLang]['bt_plus']);
				__wrapperUL.append($(_nplusbut).html());
				
				$("#pager-next-bt",__wrapperUL).bind('mouseup', function(e){
					$(evt.currentTarget).toggleClass('plus-pager-bt-on');
				});					
				
				$("#pager-next-bt",__wrapperUL).bind('click', function(e){
					$(evt.currentTarget).toggleClass('plus-pager-bt-on');
					var __url;
						my_app.pager.nb = parseInt(data.pg.nb, 10);
						my_app.pager.page = page;
						my_app.pager.type = data.pg.t;
						my_app.pager.rss = data.pg.rss;
						var __uri = "";
						if(my_app.pager.rss != ""){
							__uri = __uri  + "&id=" + my_app.pager.rss;
						}
						my_app.pager.idx = my_app.pager.idx + my_app.pager.nb;
						__uri = __uri  + "&pageridx=" + my_app.pager.idx + "&cat=" + my_app.pager.cat;
						__url = "/_mRSSGet_2.php?t=catlist" + __uri;
						my_app.updateList2(page,__url, null, false);
				});					
			}
		}
		
		if(my_app.pager.type == MY_PAGER_PULL){
			__wrapperUL.append(my_app.pullNavBlock);
			my_app.iscrollPullDiv = $("#pullUp", __wrapperUL);
		}		
	}//end __listPagerUpdateButton

	// ---------------------------------------------------------------------------------------------------------------------------------
	// ---------------------------------------------------------------------------------------------------------------------------------
	// ---------------------------------------------------------------------------------------------------------------------------------
	
	/*
     * @see my_app.updatePage
	 */
	my_app.createPageFromContent = function(data, page, Change, Toolbar, idAgr){
		toolbar = (Toolbar)?Toolbar:null;
		change = (Change == null)?'none':Change;
		idagr = (idAgr)?idAgr:null;

		//update aid of page
		if(idagr){
			$('#'+page).attr('aid', idagr);
		}

		if(idagr != null){
			my_app.registerAction(idagr, ACT_VIEW_AGR);
		}

		if(data){
			if((data.pm)&&(data.pm.guid)){
				__deleteFromCache("__curentPage");
				__deleteFromCache("__curentPageID");
				var __Resume = __loadCacheContent("__currentResume");
				if(__Resume != null){
					data.resume = __Resume;
					data.resume.guid = data.pm.guid;
					// vide localstore temp
					// enregistre la page dans le localstore temporaire
					var __dt = $.toJSON(data);
					__updateListContent("__curentPage", __dt);
					__updateListContent("__curentPageID", data.pm.guid);
					__dt = null;
				}
			}
		}

		__getSingleContent(data, page, null, '', idagr);
		$.mobile.changePage("#" + page, change, false, false, {"title":data.title});
		if(my_app.NATIVE){
			if(toolbar != null) {
			    if (toolbar != 'unbind')
				__I_native_event('toolbar:'+ toolbar);
			    $("#" + page).bind('pagebeforehide', function(evt, args){
				__I_native_event('toolbar:'+ 'unbind');
			    });
			}
		}
	};
	
	/*
	 * @see my_app.updatePage
	 */
	function __getSingleContent(data, page, Nocontent, noctmsg, idAgr){
		nocontent = (Nocontent == null)?false:Nocontent;
		idagr = (idAgr)?idAgr:null;
		
		if(nocontent){
			noctmsg = (noctmsg)?noctmsg:(MY_ERROR_MESSAGE[my_app.setLang]["1100"]);
			__displayNoContent(page, noctmsg);
			return;
		}
		
		// EG - 24.07.12 Ajout evenement de changement de page sur click dans le menu. 
		if (__myapp.sim) __myapp.content_changeItem(idagr);
		
		try{
			if(data.title){
				if(my_app.hasEvent($("#"+page), "pageloaded")){
				}else{
					$("#"+page).bind("pageloaded", function(){
						__updateHeadTitle(page, data.title);
					});
				}
			}
		}catch(err){}
		
		var idItem = $("#"+page).attr('my-model');
		if(idItem == undefined) console.log("[__getSingleContent] WARNING No 'my-model' found (page : " + page +")");
		var __tmpL = $("#"+page);
		var __itMod = $("#"+idItem+"-item", __tmpL);
		
		// Load page inner and append it in the page wrapper
		var __pageInner = $("#my_"+idItem).clone();
		__myapp.removeScriptFromClone(__pageInner);
		var __wrapPage = $(".my-"+idItem+"-inner");
		if(__wrapPage.length) {
			__wrapPage.empty();
			__wrapPage.append(__pageInner.html());
		}

		var __indexSubShare = __itMod.attr('my-up-share');
		if(__indexSubShare == undefined) console.log("[__getSingleContent] WARNING No 'my-up-share' found (page : " + page +")");
		var __indexSubMail = __itMod.attr('my-up-mail');
		if(__indexSubMail == undefined) console.log("[__getSingleContent] WARNING No 'my-up-mail' found (page : " + page +")");
		var __MailText = __itMod.attr('my_mail_text');
		if(__MailText == undefined) console.log("[__getSingleContent] WARNING No 'my_mail_text' found (page : " + page +")");
		
		var __mailInTXT = false;
		if(__MailText){
			__mailInTXT = (__MailText == "1")?true:false;
		}

		//simple share : open a pop-up menu to share on fb, twitter, mail & sms
		var __indexSubSimpleShare = __itMod.attr('my-up-simpleShare');
		// split index
		
		if(__indexSubSimpleShare){
			__setSimpleShareLink(__indexSubSimpleShare, data, idItem, __itMod);
		}else{
			console.log("[__getSingleContent] WARNING No simpleShare to do (page : " + page +")");
		}

		//agenda 
		var __indexSubAgenda = __itMod.attr('my-up-agenda');
		if(data){
			// split index 
			if(__indexSubAgenda){
				//old process : see veloland
				if(data.ag){
					if(data.ag.dis){
						$("#" + idItem + "_agenda", __itMod).css('display', 'none');
					}else{
						var __agenda = $("#" + idItem + "_agenda", __itMod);
						$(__agenda).attr('href', 'myapp:calendar:%_2:%_0:%_1:%_3');

						var __href = $(__agenda).attr('href');
						if(__href.length){
							var reg = new RegExp("(%_0)", "g");
							__href = __href.replace(reg,data.ag.ds);

							if(data.ag.de){
								reg = new RegExp("(%_1)", "g");
								__href = __href.replace(reg,data.ag.de);
							}else{
								reg = new RegExp("(%_1)", "g");
								__href = __href.replace(reg,"");
							}

							var __val;
							if(data.ag.l){
								reg = new RegExp("(%_3)", "g");
								__val = __encodeCharForNative(data.ag.l);
								__href = __href.replace(reg,__val);
							}else{
								reg = new RegExp("(%_3)", "g");
								__href = __href.replace(reg,"");
							}

							reg = new RegExp("(%_2)", "g");
							var __val = __encodeCharForNative(data.ag.t);
							__href = __href.replace(reg,__val);

							$("#" + idItem + "_agenda", __itMod).css('display', 'block');

							$(__agenda).attr('href', __href);
							__agenda = null;
						}else{
							console.log("[__getSingleContent] WARNING No " + idItem + "_agenda found (page : " + page +")");
						}
					}
				}else{		
					$("#" + idItem + "_agenda", __itMod).css('display','none');
				}

				//new process
				if(data.pm.pid){
					var __agenda_params=$.parseJSON(unescapeChar(__indexSubAgenda));
					__agenda_params=__agenda_params[idItem + "_agenda"];

					if(__agenda_params !== undefined){
						var __agenda = $("#" + idItem + "_agenda", __itMod),
						__agenda_href='myapp://calendar';

						//TITLE
						if(__agenda_params['0']){
							__agenda_href+=':'+encodeURIComponent(unescapeChar(data.label[__agenda_params['0']]));
						}else{
							__agenda_href+=':';
						}
						//START DATE
						if(__agenda_params['1']){
							__agenda_href+=':'+encodeURIComponent(data.timestamp[__agenda_params['1']]);
						}else{
							__agenda_href+=':';
						}
						//END DATE
						if(__agenda_params['2']){
							__agenda_href+=':'+encodeURIComponent(data.timestamp[__agenda_params['2']]);
						}else{
							__agenda_href+=':';
						}
						//LOCATION STRING
						if(__agenda_params['3']){
							__agenda_href+=':'+encodeURIComponent(unescapeChar(data.label[__agenda_params['3']]));
						}else{
							__agenda_href+=':';
						}
						//LOCATION URL(http://maps...)
						if(__agenda_params['4']){
							__agenda_href+=':'+encodeURIComponent(unescapeChar(data.label[__agenda_params['4']]));
						}else{
							__agenda_href+=':';
						}

						__agenda.attr('href', __agenda_href).css('display','block');

						__agenda_href=__agenda=null;
					}
					__agenda_params=null;
				}
			}else{
				console.log("[__getSingleContent] WARNING No agenda to do (page : " + page +")");
			}

			if(data.pm.pid){
				for (var pid in data.label){

					//reset pid
					$('span[pid="'+pid+'"]',__tmpL).empty();

					var __html = data.label[pid];
					if(__html.trim() == ""){
						$('*[blockid="'+pid+'"]',__tmpL).css('display','none');
					}else{
						$('*[blockid="'+pid+'"]',__tmpL).css('display','');
						var __lbls = $('span[pid="'+pid+'"]',__tmpL);
						for (var k=0; k<__lbls.length; k++){
							if(__myapp.imgParamURL != ""){
								__html = __html.replace(/_mMedia.php\?/gi, '_mMedia.php?'+__myapp.imgParamURL);
							}
							// console.log(unescapeChar(__html));
							__lbls[k].innerHTML = unescapeChar(__html);
						}
					}
					__html = null;
				}
			}else{
				for (var j=0; j<data.c.label.length; j++){
					var __lbls;
					__lbls = $('span[pid="'+j+'"]',__tmpL);
					if(!__lbls.length){
						__lbls = $("."+idItem+"-l"+j,__tmpL);
					}
					for (var k=0; k<__lbls.length; k++){
						var __html = data.c.label[j];
						if(__myapp.imgParamURL != ""){
							__html = __html.replace(/_mMedia.php\?/gi, '_mMedia.php?'+__myapp.imgParamURL);
						}
						console.log(unescapeChar(__html));
						__lbls[k].innerHTML = unescapeChar(__html);
						__html = null;
					}
				}
			}
		}

		// creation of the share event.
		if(__indexSubShare){
			try{
				if(__myapp.existFunc("createPageShare")){
					var __fn = window['createPageShare'];
					var __res = __fn(data);
					
					__indexSubShare = unescapeChar(__indexSubShare);
					var __ShareParam = jQuery.parseJSON(__indexSubShare);
					for(__idshare in __ShareParam){				
						var __share = $("#" + __idshare , __itMod);
						var __href = $(__share).attr('share-content');
						var reg = new RegExp("(%EVT)", "g");
						__href = __href.replace(reg,__res);
						$(__share).attr('evt_share', __res);
						__share = null;
					}
				}
			}catch(e){
				console.log("ERR [__getSingleContent] err in page share function : "+e.message);
			}
		}//end __indexSubShare 
		
		/*
		 * Example :
		 * 
		 * my-up-mail='{"page-1018_mail_0":{"0":0, "1":1, "2":2, "3":13}} to declared in item div definition ex : page-1018-item
		 * mailto:?subject=Véhicule neuf chez Garage du 12 &body= %_0 %_1 %_2 pour seulement %_3 euros<br
		 * 
		 * {"0":0, "1":1, "2":2, "3":13} 
		 * Means %_0 will be replace by pid 0
		 * Means %_1 will be replace by pid 1
		 * Means %_2 will be replace by pid 2 
		 * Means %_3 will be replace by pid 13 
		 */
		if(__indexSubMail){
			__indexSubMail = unescapeChar(__indexSubMail);
			var __MailParam = jQuery.parseJSON(__indexSubMail),
			__tzone = $("#test_zone"),
			__tblock = null;
			if(__tzone.length){
				$(__tzone).css("display","block");
				$(__tzone).css("visibility","hidden");
				var __tblock = $("#test_block", __tzone);
				if(!__tblock.length) __tblock = null;
			}	
			for(__idmail in __MailParam){
				var __mail = $("#" + __idmail , __itMod),
				__href = $(__mail).attr('mail-content');
				if(!__href){
					__href = $(__mail).attr('href');
				}

				for(__idx in __MailParam[__idmail]){
					var __r = "%_" + __idx,
					reg = new RegExp("("+__r+")", "g");
					if(data){
						if(data.pm.pid){
							__val = data.label[__MailParam[__idmail][__idx]];
							if(__tblock){
								__val = unescapeChar(__val);
								$(__tblock).html(__val);
								var __str ;
								if(__mailInTXT) __str = $(__tblock).text();
								else __str = $(__tblock).html();
								__val = encodeURIComponent(__str);
								$(__tblock).html("");
							}
							__href = __href.replace(reg,__val);
						}else{
							__href = __href.replace(reg,data.c.label[__MailParam[__idmail][__idx]]["v"]);
						}
					}
				}
				
				$(__mail).attr('href', __href);
				__mail = null;
			}
			
			if(__tzone.length){
				__tzone.css("display","none");
				__tzone.css("visibility","visible");
				__tblock = null;
			}
		}else{
			console.log("[__getSingleContent] WARNING No mail to do (page : " + page +")");
		}

		// auto create phone button with tel data ...
		// data : "tel":{"[pid]":"[number]","[pid]":"[number]"}
		if(data && data.tel){
			for (__pid in data.tel){
				$('a[pid='+__pid+']',__itMod).each(function(){
					$(this).attr('href', 'tel:'+ data.tel[__pid]);
				});
			}
		}//end data.tel

		// auto create link on pid anchor
		// data : "a":{"[pid]":"[url]","[pid]":"[url]"}
		if(data && data.a){
			for (__pid in data.a){
				$('a[pid='+__pid+']',__itMod).each(function(){
					$(this).attr('href', data.a[__pid]);
				});
			}
		}//end data.a
		
		//STATS
		if(idagr != null){
			$('a[action="tel"]').each(function(){
				$(this).attr('agr',idagr);
			});

			$('a[action="share"]').each(function(){
				$(this).attr('agr',idagr);
			});
			
			$('a[action="com"]').each(function(){
				$(this).attr('agr',idagr);
			});
			
			$('a[action="agenda"]').each(function(){
				$(this).attr('agr',idagr);
			});

			$('a[action="link"]').each(function(){
				$(this).attr('agr',idagr);
			});
		}

		//native navigator management (page) in fixed header. 
		if(data && data.pm.pp && data.pm.np){
			__myapp.nav.pp=data.pm.pp;
			__myapp.nav.np=data.pm.np;
	
			if(data.pm.pp==0){
	    		$('#navBar-left', '#'+page).attr("style", "display:none");
	    	}else{
	    		$('#navBar-left', '#'+page).attr("style", "display:inline-block");
	    	}
	
	    	if(data.pm.np==0){
	    		$('#navBar-right', '#'+page).attr("style", "display:none");
	    	}else{
	    		$('#navBar-right', '#'+page).attr("style", "display:inline-block");
	    	}
		}

		// Custom navigation management (used with RSS ) external function in index.html ...
		if(data && data.pm.nav){
			// check for global function
			try{
				if(__myapp.existFunc("__myupdateNavButton")){
					__myupdateNavButton(__tmpL,data.pm.nav.p, data.pm.nav.n);
				}
			}catch(e){
				console.log("ERR [__getSingleContent] err in custom navigation : "+e.message);
			}
		}else{
			try{
				if(__myapp.existFunc("__myupdateNavButton")){
					__myupdateNavButton(__tmpL);
				}
			}catch(e){
				console.log("ERR [__getSingleContent] err in custom navigation : "+e.message);
			}
		}

		//IMAGE
		if(data){
			if(data.pm.pid){
				if(data.img){
					for (var pid in data.img){
						var _resize;
						var __lbls = $('img[pid="'+pid+'"]',__tmpL);
						if(!__lbls.length){
							//JB : 2012 - 08 - 30 : add #wrapper in selector
							$('#wrapper img', __tmpL).each(function(){
								$(this).css('display', 'none');
							});	
						}else{
							for (var k=0; k<__lbls.length; k++){
								$(__lbls).css('display', 'block');
								_resize = $(__lbls).attr('max_size');
								var __res;
								try{
									if (_resize) __res = jQuery.parseJSON(_resize);
									else __res = {w:0, h:0};
								}catch(e){
									__res = {w:0, h:0};
								}

								// manage Image.
								// Image can be lodaded from the server or loaded on the application
								// if 'id' parameter exist, image will be loaded from the server with _mMedia
								// ex :	"img":{"0":{"id":"toto.png", "h":"0000"}},
								// else if 'v' parameter exist, in this case image will loaded from the application
								// ex :	"img":{"0":{"v":"toto.png"}},
								if(data.img[pid]["id"]){
									if(jQuery.trim(data.img[pid]["id"])!=""){
										$(__lbls).attr('id', data.img[pid]["id"]);
										var __img = my_app.popImage(data.img[pid]["id"], __res.w, __res.h);
										if( __img != null){
											$(__lbls).attr('src', __img.c);
											$(__lbls).addClass("reloadable-image");
											data.img[pid]["w"] = __img.w;
											data.img[pid]["h"] = __img.h;
										}else{
											$(__lbls).addClass("loadable-image");
											$(__lbls).attr('src', 'img/myapp/ajax-loader.gif');
											$(__lbls).css('margin', '0 auto 0 auto');
											_resize = {"w":32, "h":32};
											$(__lbls).unbind('click');
										}
										__img = __res = null;
										$(__lbls).css('display', 'block');
										if (_resize){
											__resizeImage(__lbls, data.img[pid]["w"], data.img[pid]["h"], _resize);
										}
									}else{
										$(__lbls).css('display', 'none');
									}
								}else{
									if(data.img[pid]["v"]){
										var __imgwrap = $("#__imageWrap",__tmpL);
										if(__imgwrap.length){
											$(__imgwrap).css('background','url(./img/myapp/ajax-loader.gif) no-repeat center center');
											$(__imgwrap).addClass("laod-ext-image");
											$(__imgwrap).attr('__src', data.img[pid]["v"]);
										}else{
											$(__lbls).attr('src', data.img[pid]["v"]);
										}
										$(__lbls).css('display', 'block');
									}else $(__lbls).css('display', 'none');
								}//end if data.img[pid]["id"]
							
							}
						}

						//JB : 2012 - 09 - 11 : add preview process
						var __preview=__lbls.attr('albPreview');
						if( __preview && __preview==1 ){
							$.ajax({
								url:BASE_URL+"/_mMedia.php?diap=list&album="+MY_DIAP_PREFIX+idAgr,
								success:function(data){
									if(typeof data == 'string'){
										data = $.parseJSON(data);
									}

									if(data && data[MY_DIAP_PREFIX+idAgr]){
										if(data[MY_DIAP_PREFIX+idAgr].hasOwnProperty('length') && data[MY_DIAP_PREFIX+idAgr].length>0){
											this.my.img.css({'float':'', margin:''});
											var self=this, __imgW=self.my.img.parent(), __previewHTML='<div id="albPreview">', __nbI=0;

											//affectation de la fonction permettant l'ouverture du diaporama
											__imgW.unbind('click').bind('click', function(e){
												var __originatingTarget;
												if(e) __originatingTarget = $(e.target);
												if(__originatingTarget && __originatingTarget.is('[albpreview]')){
												}else{
													$(self.my.img).trigger('click');
												}
												__originatingTarget=null;
											});
											//creation des balises p(pour le crop) et des images
											for(var __x in data[MY_DIAP_PREFIX+idAgr]){
												if(data[MY_DIAP_PREFIX+idAgr].hasOwnProperty(__x)){
													if(__nbI<2){
														__nbI++;
														__previewHTML+='<p style="height:1px;"><img src="" id="'+data[MY_DIAP_PREFIX+idAgr][__x]+'" albName="'+MY_DIAP_PREFIX+idAgr+'" /></p>';//maxsize=\'{"zoom":0, "w":150, "h":"", "bk":0}\'
													}else{
														break;
													}
												}
											}
											__previewHTML+='<div style="font-size:10px;text-align:center;">'+my_app.LANG[my_app.setLang].__l0280+'</div></div>';
											//insertion du html
											$('#albPreview').remove();
											__imgW.append(__previewHTML);
											//chargement des images
											__nbI=0;
											$('img[albName]', __imgW).each(function(){
												if(__nbI == 0){
													my_app.loadB64Image($(this), null, function(){
														var __imgW=self.my.img.parent(), __img_w, __img_css_w, __img_css_mx, __img_h, __i=0, __imgWlh=20, __p=$('p', '#albPreview');
														//calcul des dimensions/positions des balises p
														__img_css_w=self.my.img.css('width');
														__img_css_mx=self.my.img.css('max-width');
														if( __img_css_mx && __img_css_mx.indexOf('%') > -1 ){
															__img_w=__imgW.width()*(100-parseInt(__img_css_mx, 10))/100;
														}else{
															__img_w=__imgW.width()-self.my.img.width()-20;//20(arbitrary space)
														}
														__img_h=(__imgW.height()/(__p.length))-__imgWlh;
														//affectation du style pour les balises p
														__p.css({border:'2px solid white', 'float':'right',overflow:'hidden', 'margin-bottom':'5px', height:''});
														$('p img', '#albPreview').css({'max-width':__img_w+'px'}).each(function(){
															this.onload=function(){
																$(this).css({'margin-bottom':(__img_h-this.height)+'px'});
															};
														});

														__img_css_w=__img_css_mx=__p=__imgWlh=__i=__img_w=__imgW=null;
													});
												}else{
													my_app.loadB64Image($(this));
												}
												__nbI++;
											});
											__nbI=__imgW=__previewHTML=null;
										}else{
											this.my.img.css({'float':'none', margin:'auto'});
											$('#albPreview').remove();
										}
									}else{
										this.my.img.css({'float':'none', margin:'auto'});
										$('#albPreview').remove();
									}
								},
								error:function(err){

								},
								my:{
									img:__lbls
								}
							});
						}
						__preview=null;

					}//end for
				}
			}else{
				for (var j=0; j<data.c.img.length; j++){
					var __lbls = $("."+idItem+"-img"+j,__tmpL);
					for (var k=0; k<__lbls.length; k++){
						__lbls.attr('src', data.c.img[j]);
					}
				}
			}
		}

		// dynamic table management.
		// create a list of information arranged as a table
		// warning : table information must be received as followed.
		// "table":{"pid":"[&quot;info1&quot;, &quot;info2&quot;]"}
		if(data && data.pm.pid){
			if(data.table){
				for (var pid in data.table){
					var __lbls = $('span[pid="'+pid+'"]',__tmpL);
					var __data;
					try{
						__data = jQuery.parseJSON(unescapeChar(data.table[pid]));
						if(__data != ""){
							__table = __createTable(__data);
							for (var k=0; k<__lbls.length; k++){
								__lbls[k].innerHTML = __table;
							}
							$('*[blockid="'+pid+'"]',__tmpL).css('display','');
						}else{
							$('*[blockid="'+pid+'"]',__tmpL).css('display','none');
						}
					}catch(e){
						$('*[blockid="'+pid+'"]',__tmpL).css('display','none');
					}
					__data = null;
				}
			}else{
				$('span[my-ctype="tablist"]', __tmpL).each(function(){
					$('*[blockid="'+$(this).attr('pid')+'"]', __tmpL).css('display','none');
				});
			}

			/*
			* 	extended table management.
			* 	Use to create a visible table layout with header and content. 
			Content must be receive as followed.
			"0":{
			"cols":2 , 
			"head":["Header1","Header2"], 
			"cont":[["Row1-Col1", "Row1-Col2"], ["Row2-Col1", "Row2-Col2"], ["Row3-Col1", "Row3-Col2"]]
			},
			*/
			if(data.table_ex){
				for (var pid in data.table_ex){
					var __lbls = $('span[pid="'+pid+'"]',__tmpL),
					__head,
					__cont;

					try{
						__head = data.table_ex[pid].head;
						__cont = data.table_ex[pid].cont;
						// check if content is string of object ...
						if(typeof __head == "string"){
							var __tmp = unescapeChar(__head);
							eval('__head = ' + __tmp);
							__tmp = null;
						}
						if(typeof __cont == "string"){
							var __tmp = unescapeChar(__cont);
							eval('__cont = ' + __tmp);
							__tmp = null;
						}
						__table = __createExTable(data.table_ex[pid].cols, __head, __cont);
						for (var k=0; k<__lbls.length; k++){
							__lbls[k].innerHTML = __table;
						}
						$('*[blockid="'+pid+'"]',__tmpL).css('display','');
					}catch(e){
						$('*[blockid="'+pid+'"]',__tmpL).css('display','none');
					}
					
					__head = __cont = null;
				}//end for.
			}

			//accordion_menu management
			if(data.accordion_menu){
				for(var pid in data.accordion_menu){
					var __lbls = $('span[pid="'+pid+'"]',__tmpL),
					__head,
					__cont,
					__wrapper,
					__model,
					__itMod;

					try{
						__head = data.accordion_menu[pid].head;
						__cont = data.accordion_menu[pid].cont;
						__wrapper=$('span[pid="'+pid+'"][my-item]',__tmpL).first();
						__model=__wrapper.attr('my-item');
						__itMod=$("#"+__model+"-item");

						// check if content is string of object ...
						if(typeof __head == "string" && __head!=""){
							var __tmp = unescapeChar(__head);
							eval('__head = ' + __tmp);
							__tmp = null;
						}else{
							console.error("[my_list] accordion_menu : header error");
						}

						if(typeof __cont == "string"){
							var __tmp = unescapeChar(__cont);
							eval('__cont = ' + __tmp);
							__tmp = null;
						}else{
							console.error("[my_list] accordion_menu : cont error");
						}

						__createAccordionMenu(data.accordion_menu[pid].cols, __head, __cont, __wrapper, __itMod);
					}catch(e){
						$('*[blockid="'+pid+'"]',__tmpL).css('display','none');
					}

					__itMod = __model = __wrapper = __head = __cont = null;
				}
			}

			//timestamp management
			if(data.timestamp){
				for (var pid in data.timestamp){
					var __lbls = $('span[pid="'+pid+'"]',__tmpL);
					__lbls.html(my_app.timestampToDate(data.timestamp[pid], 'yyyy-mm-dd hh:mm'));
					__lbls=null;
				}
			}

			//type phone management
			if(data.phone){
				for(var pid in data.phone){
					__createPhone($('a[pid="'+pid+'"]',__tmpL), data.phone[pid]);
				}
			}

			//type email management
			if(data.email){
				for(var pid in data.email){
					__createEmail($('a[pid="'+pid+'"]',__tmpL), data.email[pid]);
				}
			}

			//type address management
			if(data.address){
				for(var pid in data.address){
					__createAddress($('[pid="'+pid+'"]',__tmpL), data.address[pid]);
				}
			}

			//type contact management
			if(data.contact){
				for(var pid in data.contact){
					__createContact($('a[pid="'+pid+'"]',__tmpL), data.contact[pid]);
				}
			}

			//type hidden management
			if(data.hidden){
				for(var pid in data.hidden){
					$('input[type=hidden][pid="'+pid+'"]', __tmpL).val(data.hidden[pid]);
				}
			}
		}

		$("#"+ page).addClass("load-img-inprog");
		my_app.loadAllImage();
		
		setTimeout(function(){
			if(my_app.iscroll){
				my_app.iscroll.refresh();
				console.log("[__getSingleContent] Refresh scroller delay 500...");
			}
		}, 500);
	}//End __getSingleContent

	/*
	 * Used to URI encode string with possibility to remove previously the special HTML char ...
	 */
	function __encodeCharForNative(str, htmlEntity){
		htmlE = (htmlEntity == null)?false:htmlEntity;
		if(htmlE){
			var __tzone = $("#test_zone");
			if(__tzone.length){
				$(__tzone).css("display","block");
				$(__tzone).css("visibility","hidden");
				var __tblock = $("#test_block", __tzone);
				$(__tblock).html(str);
				var __str = $(__tblock).html();
				__val = encodeURIComponent(unescapeChar(__str));
				//__val = unescapeChar(__str);
				$(__tblock).html("");
				__tzone.css("display","none");
				__tzone.css("visibility","visible");
				return __val;
			}else{
				return encodeURIComponent(unescapeChar(str));
			}
		}else{
			return encodeURIComponent(unescapeChar(str));
		}
	}//end __encodeCharForNative

	/*
	 * 
	 */
	function __displayNoContent(page, noctmsg){
		// management of the no content retrun by server.
		var __tmpL = $("#"+page);
		var __idModel = __tmpL.attr('my-list');
		var __wrapperUL = $('#' + page + ' .' + __idModel + '-inner');	
		console.log("[__displayNoContent] enter in ... ("+__idModel+")");
		if(__wrapperUL.length){
			$(__wrapperUL).empty();

			//updateTitle
			if(my_app.hasEvent($("#"+page), "pageloaded")){
			}else{
				var __title=$('.my-head-titleLabel', '#'+page).text();
				$("#"+page).bind("pageloaded", function(){
					__updateHeadTitle(page, __title);
					__title=null;
				});
			}

			var __ncItem = $('#my-no_content');
			if(__ncItem.length){
				
				// update content label with the "NO_CONTENT_LABEL" definition
				var __ref = "";
				if(NO_CONTENT_LABEL[page]){
					__ref = page;
				}else{
					__ref = "def";
				}
				// replace span pid by value
				for (var pid in NO_CONTENT_LABEL[__ref]){
					$('span[pid="'+pid+'"]',__ncItem).each(function(){
						$(this).html('');
						$(this).html(my_app.LANG[my_app.setLang][NO_CONTENT_LABEL[__ref][pid]]);
					});
				}
				
				if(my_app.localization.address.tel){
					var __tel;
					__tel = my_app.localization.address.tel[""];
					if(__tel) $('#my-no_content-tel_num').attr('href','tel:' + __tel);
					else{
						 for (var tel in my_app.localization.address.tel){
							 __tel =  my_app.localization.address.tel[tel];
							 break;
						 }
						 $('#my-no_content-tel_num').attr('href','tel:' + __tel);
					}
					if(__tel){
						$('.my-no_content_tel').each(function(){       
							$(this).css('display','block');
						});
					}else{
						$('.my-no_content_tel').each(function(){       
							$(this).css('display','none');
						});
					}
				}else{
					$('.my-no_content_tel').each(function(){       
						$(this).css('display','none');
					});
				}
				__wrapperUL.append($(__ncItem).html());
			}else{
				console.log("[__displayNoContent] id my-no_content not found ...");
				__I_create_dialog(MY_ERROR_MESSAGE[my_app.setLang]["1150"],"__CB_dispNoContent", "err");
			}
		}else{
			console.log("[__displayNoContent] wrapul not found ...");
            __I_create_dialog(MY_ERROR_MESSAGE[my_app.setLang]["1150"],"__CB_dispNoContent", "err");
		}
			
		__tmpL = __idModel = __wrapperUL = null;
	}//end__displayNoContent

	/*
		REsize a container for an image.
	*/
	function __resizeImage(__img, iw, ih, resize){
		var __image=$(__img);

		if(__image.length){
			var imgP = null;
			try{
				if (typeof resize == 'object'){
					imgP = resize;
				}else{
					imgP = jQuery.parseJSON(resize);
				}
			}catch(e){
				imgP = null;
				if(imgP == null){
					__getlistContentErr(undefined, "3000", false, null, null);
					return;
				}
			}

			// reinit size ...
			__image.css('width', '').css('height', '');

			if(imgP){
				if(imgP.unit){
					if(imgP.unit==="%"){
						//get w and h properties as percent value and get pixels equivalent
						if(imgP.w){
							imgP.w=my_app.W*imgP.w/100;
						}
						if(imgP.h){
							imgP.h=my_app.H*imgP.h/100;
						}
					}
				}


				if((iw == undefined) && (ih == undefined)){
					__image.css('width', imgP.w + 'px').css('height', imgP.h + 'px');
				}else if((iw > imgP.w) && (ih > imgP.h)){
					var wd = Math.abs(iw - imgP.w),
					hd = Math.abs(ih - imgP.h);

					if(wd > hd){
						var _rh = Math.round((imgP.w/iw)*ih);
						if(_rh > imgP.h){
							__image.css('height', imgP.h + 'px');
						}else{
							__image.css('width', imgP.w + 'px');
						}
					}else{
						var _rw = Math.round((imgP.h/ih)*iw);
						if(_rw > imgP.w){
							__image.css('width', imgP.w + 'px');
						}else{
							__image.css('height', imgP.h + 'px');
						}
						__image.css('height', imgP.h + 'px');
					}
				}else if(iw > imgP.w){
					__image.css('width', imgP.w + 'px');
				}else if(ih > imgP.h){
					__image.css('height', imgP.h + 'px');
				}else if((iw == imgP.w) && (ih == imgP.h)){
					__image.css('width', imgP.w + 'px').css('height', imgP.h + 'px');
				}
			}
		}
		
	}

	/*
	 * Create a table with 2 column, no css layout is applied on this table.
	 * @data simple array that contain the all the data (ex : ["info1","info2","info3"])
	 * 
	 * @see __getSingleContent
	 */
	function __createTable(data){
		var res = "<table>";
		//__nbFlow = Math.floor(data.length / 2);
		for (var j=0; j< data.length; j=j+2){
			res += "<tr>";
			res += "<td>"+((data[j])?((data[j+1])?(data[j]+","):(data[j])):"")+"</td>";
			res += "<td>"+((data[j+1])?(data[j+1]+","):"")+"</td>";
			res += "</tr>";
		}		
		res +=  "</table>";
		return res;
	};

	function __createExTable(cols, headers, data){
		var res = '<table class="exttable">';
		//first loop for hearders.
		res += '<tr class="extheader">';
		for (var i = 0; i< cols; i++){
			res += '<td class="extcolheader">'+((headers[i])?headers[i]:'')+'</td>';
		}
		res += '</tr>';
		
		//first loop for content.
		/*
		for (var j=0; j< data.length; j = (j+cols)){
			res += '<tr class="extrow">';
			for (var i = 0; i< cols; i++){
				res += '<td class="extcol">'+((data[(j+i)])?data[(j+i)]:'')+'</td>';
			}
			res += '</tr>';
		}
		*/
		
		for (var j=0; j< data.length; j++){
			res += '<tr class="extrow">';
			for (var i = 0; i< cols; i++){
				res += '<td class="extcol">'+((data[j][i])?data[j][i]:'')+'</td>';
			}
			res += '</tr>';
		}
		res +=  '</table>';
		return res;
	};

	/*
	Create a page from an array (return by accordion_menu type, similar as table_ex)
	This page contains category and its invisible contents which by displayed by a click
	Content use list-item-model for its display
	!Important : pid of list-item-model used must be like this 0,1,2,3...
	*/
	function __createAccordionMenu(cols, header, data, wrapper, itMod){
		var __arrAccMenu={},
		__last=0,
		__html="",
		__i,
		__x,
		__y,
		__z,
		__clone,
		__field;

		wrapper.empty();

		for(__i=0;__i<data.length;__i++){
			if(data[__i].length==1){
				__last++;
				__arrAccMenu[__last]={
					category:__i,
					fields:[]
				};
			}else{
				if(__arrAccMenu.hasOwnProperty(__last)===false){
					__arrAccMenu[__last]={
						fields:[]
					};
				}

				__arrAccMenu[__last].fields.push(__i);
			}
		}
		__i=null;

		//create clone
		__clone=$("li", itMod).clone();
		__myapp.removeScriptFromClone(__clone);
		//browse each rows
		for(__x in __arrAccMenu){
			if(__arrAccMenu[__x].hasOwnProperty('category')){
				__html+='<div id="accMenu_catHead_'+__x+'" class="accMenu_catHead">'+data[__arrAccMenu[__x].category][0]+'</div><div id="accMenu_cat_'+__x+'" class="accMenu_cat" style="display:none;">';
			}else{
				__html+='<div id="accMenu_nocat_'+__x+'" class="accMenu_nocat_'+__x+'">';
			}

			for(__y=0;__y<__arrAccMenu[__x].fields.length;__y++){
				__field=data[__arrAccMenu[__x].fields[__y]];
				//fill datas in clone
				for(__z=0;__z<__field.length;__z++){
					$("span[pid="+__z+"]" ,__clone).text(__field[__z]);
					//blockid
					if(__field[__z]===null || $.trim(__field[__z])===""){
						$("*[blockid="+__z+"]" ,__clone).css('display', 'none');
					}else{
						$("*[blockid="+__z+"]" ,__clone).css('display', '');
					}
				}
				//append clone html
				__html+=__clone.html();
				__field=__z=null;
			}
			__y=null;
			__html+='</div>';
			
		}
		wrapper.html(__html);
		__clone=__x=__html=null;
	}

	/**
	* set phone button
	* @elm : (DOMElement || JQUERY OBJECT) element to set phone
	* @data : (string) phone number
	*/
	function __createPhone(elm, data){
		elm.css('display', (data ? '' : 'none'));
		if(elm) elm.attr('href', 'tel:'+encodeURIComponent(data));
	}

	/**
	* set email button
	* @elm : (DOMElement || JQUERY OBJECT) element to set email
	* @data : (string) email number
	*/
	function __createEmail(elm, data){
		elm.css('display', (data ? '' : 'none'));
		if(elm) elm.attr('href', 'mailto:'+encodeURIComponent(data));
	}

	/**
	* set address button
	* @elm : (DOMElement || JQUERY OBJECT) element to set address
	* @data : (object) address datas (JSON String)
	*/
	function __createAddress(elm, data){
		if(typeof data == "string"){
			data=$.parseJSON(data);
		}

		if(elm){
			var __str='';
			if(data) __str=data.addr+' '+data.ccode+'-'+data.zip+' '+data.city;
			if(elm[0] && elm[0].nodeName=='A'){
				if(data) elm.attr('href', '#').unbind('click').bind('click', function(){
					__I_native_event('geoloc:'+encodeURIComponent(data.lng)+','+encodeURIComponent(data.lat)+':1::'+encodeURIComponent(__str));
				});
			}else{
				if(data) elm.text(__str);
			}
			__str=null;
		}
	}

	/**
	* set contact button
	* @elm : (DOMElement || JQUERY OBJECT) element to set contact
	* @data : (object) contact datas (JSON String)
	*		tel/mail : (object)
	*			-text : (string)
	*			-val : (string)
	*/
	function __createContact(elm, data){
		var __str='';

		if(typeof data == "string"){
			data=$.parseJSON(data);
		}

		if(data){
			for(var __x in data){
				if(data.hasOwnProperty(__x)){
					if(__x == 'tel'){
						__str+=encodeURIComponent(data[__x].text)+'=tel'+encodeURIComponent(':'+data[__x].val)+',';
					}else if(__x == 'mail'){
						__str+=encodeURIComponent(data[__x].text)+'=mailto'+encodeURIComponent(':'+data[__x].val)+',';
					}else{
						__str+=encodeURIComponent(data[__x].text)+'='+encodeURIComponent(data[__x].val)+',';
					}
				}
			}
			__x=null;
			if(__str.length>0) __str=__str.substring(0, __str.length-1);
		}

		if(elm && data) elm.attr('href', '#').unbind('click').bind('click', function(){__I_native_event("share:"+__str);});
	}

	function urlencode(str) {
		return escape(str.replace(/%/g, '%25').replace(/\+/g, '%2B')).replace(/%25/g, '%');
	};
	
	// ----------------------------------------------------------------------------------------------------------------
	// END Misc private functions  ------------------------------------------------------------------------------------
	// ----------------------------------------------------------------------------------------------------------------


	
// ################################################################################################################
// Error handler ---------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------

	/*
	 * TODO : Check if used.
	 */
	my_app.getlistContentErr = function(err){
		__getlistContentErr(err);
	};
	
	/*
	 * Display an error message but verifies before this message was not already displayed.
	 */
	function __getlistContentErr(err, MsgId, Force, callback, cb_id, page){
		var __checkDisplayMesage = true;
		
		__cb = (callback)?callback:null; 
		__cbid = (cb_id)?cb_id:""; 
		__page = (page)?page:null; 
		
		__force = (Force == null)?false:Force; 
		__msg = (MsgId)?MsgId:"1000";
		
		console.log("[__getlistContentErr] ("+my_app.comErrMsgDisplay+")");
		if(!__force){
			if(my_app.comErrMsgDisplay != null){
				var d = new Date();
				var __tmpDate = d.getTime();
				if((__tmpDate - my_app.comErrMsgDisplay) > my_app.delayBet2ErrorMsg){
					__checkDisplayMesage = true;
					my_app.comErrMsgDisplay = __tmpDate;
				}else{
					var d = new Date();
					my_app.comErrMsgDisplay = d.getTime();
					__checkDisplayMesage = false;
				}
			}else{
				var d = new Date();
				my_app.comErrMsgDisplay = d.getTime();
				__checkDisplayMesage = true;
			}
		}else{
			__checkDisplayMesage = true;
		}
		
		if(__checkDisplayMesage){
			if(!my_app.NATIVE) $.mobile.pageLoading(true);
			if(my_app.NATIVE) __I_native_event('enmenu');
			if((err)&&(err.statusText)) {
				if(__page == null){
					__I_create_dialog(MY_ERROR_MESSAGE[my_app.setLang][__msg] + "( code:"+err.statusText + ")", __cb,__cbid, __page, null, "error");
				}else{
					__I_create_dialog(MY_ERROR_MESSAGE[my_app.setLang][__msg] + "( code:"+err.statusText + ")", __cb,__cbid, null, null, "error");
				}
			}else{
				__I_create_dialog(MY_ERROR_MESSAGE[my_app.setLang][__msg], __cb,__cbid);
				//__myapp.alert(err);
			}
		}else{
			console.log("[__getlistContentErr] Com Error message already displayed ...");
		}
	};//end if __getlistContentErr

	
	function __addErrorMessage(msgID, page){
		var __curD = (new Date()).getTime();
		if(my_app.comErrStack == null) my_app.comErrStack = {};
		if(my_app.comErrStack[page]){
		}else{
			my_app.comErrStack[page] = {};
		}
		my_app.comErrStack[page].id = __curD; 
		
	}//end __addErrorMessage
	
	function __cleanErrorMessage(){
		var __curD = (new Date()).getTime();
		
	}//End __cleanErrorMessage
	
	
// ----------------------------------------------------------------------------------------------------------------
// Deprecated function --------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------

	/*
	 * @deprecated.
	Function to update a list by specifying the item model ref use in the list wrapper
		@page : reference of the page sid to update
		@idItem : reference of the item model to use
		@url : url to execute to get the content
		@title : hearder title of the page (optional)
		@change : stipulate a page change (optional)
	*/
	my_app.updateListWithModel = function(page, idItem, listId, url, title, change){
		if(my_app.NATIVE) __I_native_event('dismenu');
		if(!my_app.NATIVE) $.mobile.pageLoading();
	
		/* Manage Title Size */
		var __page = $("#"+page);
		var __idModel = __page.attr('my-list');
		var __wrapperUL = $('#' + page + ' .' + __idModel + '-inner');		
		var __idItem = __wrapperUL.attr('my-item');
	
		var __url = BASE_URL + url;
		__myapp.getObjectFrom(__url,function(data){
			my_app.comErrMsgDisplay = null;
			if(data.up == 1){
				data.title = title;
				if((data.pm)&&(data.pm.bk)){
					if(data.pm.bk == 1) __updateListContent("#" + page, data);
					if(data.pm.bk == -1000) __deleteFromCache("#" + page);
				}
				__getSingleListContent(data, page, idItem);
			}
			if(!my_app.NATIVE) $.mobile.pageLoading(true);
			if(change) {
				$("#" + page).live('pageshow',function(evt, ui){
					$("#" + page).die('pageshow');
					if(my_app.NATIVE) __I_native_event('enmenu');
				});
				$.mobile.changePage("#" + page, MY_DEFAULT_TRANSITION);
			}else{
				if(my_app.NATIVE) __I_native_event('enmenu');
			}
		},function (err){
			var data = __loadCacheContent("#" + page);
			if(data !=null){
				__getSingleListContent(data, page, idItem);
				if(!my_app.NATIVE) $.mobile.pageLoading(true);
				if(change) {
					$("#" + page).live('pageshow',function(evt, ui){
						$("#" + page).die('pageshow');
						if(my_app.NATIVE) __I_native_event('enmenu');
					});
					$.mobile.changePage("#" + page, MY_DEFAULT_TRANSITION);
				}else{
					if(my_app.NATIVE) __I_native_event('enmenu');
				}
			}else __getlistContentErr(err);
		});
		return true;
	};// end updateListWithModel

	/*
		@deprecated 
		@see my_app.updateListWithModel
	*/
	function __getSingleListContent(data, page, idItem){
		if(data.title){
			$("#"+page).bind("pageloaded", function(){
				__updateHeadTitle(page, data.title);
			});
		}
	
		if(__existFunc("p_" + idItem)){
			//update idItem class element size.
			eval("p_" + idItem + "(data.pm);");
		}
	    var __tmpL = $("#"+page);
		var idWrapper = __tmpL.attr('my-list');
		var __tmpUL = $('#' + page + ' .' + idWrapper + '-inner');
		// Remove the previous content.
		if(__tmpUL.length > 0)$(__tmpUL).empty();
	
		if(__tmpL.length != 0){
			var __itModel = $("#"+idItem+"-item");
			var __idClass = __itModel.attr('my-wrap');
			for(ssid in data.c){
				var __itWrap=$(__itModel).clone();
				__myapp.removeScriptFromClone(__itWrap);
			//for (var i=0; i<data.c.length; i++){
				$('li', __itWrap).attr('my-id', ssid);
				for (var j=0; j<data.c[ssid].label.length; j++){
					var __lbls = $("."+idItem+"-l"+j,__itWrap);
					for (var k=0; k<__lbls.length; k++){
						__lbls[k].innerHTML = data.c[ssid].label[j]["v"];
						if(data.c[ssid].label[j]["s"])
							{
								$(__lbls[k]).attr('class', '');
								$(__lbls[k]).addClass(data.c[ssid].label[j]["s"]);
							}
					}
				}
				if(data.c[ssid].img)
					{
					for (var j=0; j<data.c[ssid].img.length; j++){
						var __lbls = $("."+idItem+"-img"+j,__itWrap);
						__lbls.attr('src', data.c[ssid].img[j]["v"]);
					}
					}
				__tmpUL.append(__itWrap.html());
				$(__itWrap).remove();
				__itWrap=null;
			}
			$("li", __tmpUL).wrapAll('<ul class="'+__idClass+'-ul"/>');
		}else{
			console.log("Unable to find List type=" + idList);
		}
	}//End __getSingleListContent
	
	
	/*
		@deprecated
	*/
	my_app.createVideo = function(elem){
		console.log("[createVideo deprecated] enter in...");
		console.log("[createVideo] deprecated - url : " + $(elem).attr('url'));
		var __url = $(elem).attr('url');
		if(__url){
			var icontent = '<object data="'+my_app.Base64.decode(__url)+'" width="110" height="70" type="application/x-shockwave-flash"></object>';
			$(elem).contents().find('body').eq(0).append(icontent);
		}
	};
	
	/*
		@deprecated
	*/
	function __deleteListContent(index){
		console.log("[__deleteListContent deprecated] enter in...");
		if(__I_db_exist(index)){
			__I_db_delete(index);
			return true;
		}
		else return false;
	};
	
	
	/*
		@deprecated
	*/
	function __getlistContent(data){
		console.log("[__getlistContent deprecated] enter in...");
		// Get a copy of the list param.
		__contentParam = __tmplistParam;

		if(!$.isEmptyObject(data)){			
			console.log("[__getlistContent deprecated] Get Content ...");
			for (var i in data){
				delete __listContent[i];
				__listContent[i] = data[i];
			}
			__updateListContent(__contentParam, __listContent);
			// Initialize the list elems
			__initList();
			for (var i in __listContent){
				if(__listContent[i].length > 0) __updateList2(i);
			}

		}else{
			console.log("[__getlistContent deprecated] Receive no content...");
			__updateListContent(__contentParam, null);
		}
		__tmplistParam = null;
	};
	
	/*
		Init the list parameters.
		call : by __my.initPages().
		
		@deprecated
	*/
	function __initList() {
		console.log("[__initList deprecated] enter in...");
		var __lists = $(".my-list");
		if(__lists){
			for ( var i = 0; i < __lists.length; i++ ) {
				var __lwrap = $("#my-list-wrap", __lists[i]);
				if(__lwrap){
					var __idcss = $(__lwrap).attr('my-lmod');
					// define in my_params
					__myapp.initInsideListElem(__idcss, __contentParam[__idcss]);
				}
			}
		}
	}; //initListInsideElem
	
	/*
		Private method - Update dynamicaly the list content.
		Get the content of the list inside __listContent object.
		
		@deprecated
	*/
	function __updateList2(idList){
		console.log("[__updateList2 deprecated] enter in...");
        var __tmpL = $("#"+idList);	

		var __tmpUL = $("ul", __tmpL);
		if(__tmpL){
			var __itWrap = $("#"+idList+"-item-def", __tmpL);
			for (var i=0; i<__listContent[idList].length; i++){
				for (var j=0; j<__listContent[idList][i].length; j++){
					var __lbls = $("#"+idList+"-l"+j,__itWrap);
					for (var k=0; k<__lbls.length; k++){
						__lbls[k].innerHTML = __listContent[idList][i][j];
					}
				}
				__tmpUL.append(__itWrap.html());
			}
		}else{
			console.log("[__updateList2 deprecated] Unable to find List type=" + idList);
		}
	};
	
	/*
	 * @deprecated Not used.
	 */ 
	my_app.getlistParamErr = function(err){
		__getlistParamErr(err);
	};

	/*
	 * @deprecated Not used.
	 */ 
	function __getlistParamErr(err){
		if(!my_app.NATIVE) $.mobile.pageLoading(true);
		if(my_app.NATIVE) __I_native_event('enmenu');
		if(err.statusText) {
			alert(MY_ERROR_MESSAGE[my_app.setLang]["1000"] + "( code:"+err.statusText + ")");
		}else __myapp.alert(err);
	};

	// ################################################################################################################
	// Function for initial ccontent update protocol ------------------------------------------------------------------
	// ----------------------------------------------------------------------------------------------------------------	

	/*
	 * @deprecated 
	 */

	function __validData(data, type){
		var __valid = true;
		// check data conform
		var __type = (type)?type:"force";
		if(data){
			if(__type == 'list'){
				try{
					if(__typeObject(data.c) != 'object') __valid &= false;
					if(__valid){
						for (var id in data.c){
							if(__typeObject(data.c[id]) != 'object') __valid &= false;
							break;
						}
						if(__valid){
							if(__typeObject(data.c[id].label) != 'object') __valid &= false;
						}
					}
				}catch(e){
					__valid = false;
				}
				return __valid;
			}//end list

			if(__type == 'page'){
				return __valid;
			}
			
			if(__type == 'force') return true;
		}else{
			return false;
		}
		return false;
	}//end __validData

	
		/*
		 * @deprecated 
		 * overwrite the my_process checkServerForListUpdate method.
		 * bacground list update process.
		 * 
		 * @see my_param.js
		 */
		//my_app.checkServerForListUpdate = function() {
		my_app.getInitialContent = function(){
			var __url = BASE_URL + "/_mCont_3.php?";
			if($.isEmptyObject(__contentParam)){
				__url += "up=1";
			}else{
					var __hl= "{";
					for (var i in __contentParam.c){
						__hl += "\"" + i + "\":\"" + __contentParam.c[i].pm.h +"\",";
					}
					__hl = __hl.slice(0, -1) + "}";
					__url += "up=0&h=" + __hl;
			}
			__myapp.getObjectFrom(__url, this.getContentParam,__getlistParamErr);
			return true;
		};

		/*
		 * @deprecated (à verifier dans my_params.js de farsi)
		 */
		my_app.getContentParam = function (data){
			if(!$.isEmptyObject(data)){
				if(data.up == 1){
					// save the initial content.
					if((data.pm)&&(data.pm.bk)){
						if(data.pm.bk == 1) __updateListContent("initCont", data);
					}
					// Parse data and update application.
					for (var sid in data.c){
						var __sp = $('*[sid="'+sid+'"]');
						for (var i=0; i<__sp.length; i++){
							switch ($(__sp[i]).attr("my-role")) {
								// Overloaded part 
								// Update of the Style parameters of List items.
								case "list":
									__updateList(__sp[i], sid, data.c[sid], true);
									break;
								case "page":
									break;
								case "simple":
									break;
							}
						}
					}
				}else{
					console.log("[LIST] Receive server answer: no update ...");
				}
				// Get a copy of the list param.
				__tmplistParam = data;
			}else{
				console.log("[LIST] Receive no param ...");
				// TODO : Treat this case launch a timer process to check the update.
			}
		};

		/*
		 * @deprecated
		 */
		function __updateList(cont, sid, data, layout){
			if(layout){
				var item = $(cont).attr("my-item");
				// update layout resizing.
				var __itemdef = $(item + "-item");
				if(__existFunc("p_" + item)){
					//update item class element size.
					eval("p_" + item + "(data.pm);");
				}
			}
			
			// populate list
			if(__existvar("__"+sid+"C")){
				// update following the hard code defintion.
				_prePopulateStaticList(cont, item, sid, data.l);
			}else{
				// update following the hard code defintion.
				_prePopulateDynList(cont, item, data.l);
			}
		};

		/*
		 * @deprecated
		 */
		function _prePopulateDynList(wrapul, item, data){
			var __selLang = "";
			var __itMod = $('#' + item + "-item");
			var __idClass = item;

			for(ssid in data){
				var __itWrap = $(__itMod).clone();
				__myapp.removeScriptFromClone(__itWrap);
				__selLang = my_app.setLang;
				$('li', __itWrap).attr('my-id', ssid);
				if(data[ssid].p) $('li', __itWrap).attr('my-page', data[ssid].p);
				var __lbls;
				// content Label overwrite.
				for (var j=0; j<data[ssid].l.length; j++){
					__lbls = $("."+item+"-l"+j, __itWrap);
					for (var k=0; k<__lbls.length; k++){
						__lbls[k].innerHTML = data[ssid].l[j];
					}
					__lbls = $("."+item+"-img"+j, __itWrap);
					for (var k=0; k<__lbls.length; k++){
						$(__lbls[k]).attr('src', data[ssid].img[j]);
					}
				}
				__lbls = null;
				$(wrapul).append(__itWrap.html());
				$(__itWrap).remove();
				__itWrap = null;
			}
			
			$("li", wrapul).wrapAll('<ul class="'+__idClass+'-ul"/>');
			return true;
		};
		
		/*
		 * @deprecated
		 */
		function _prePopulateStaticList(wrapul, item, sid, data){
			var __selLang = "";
			var __popList = false;
			eval("__popList = __"+sid+"C;");
			var __subCont;
			try{
				eval("__subCont = __"+sid+"_SMVal[\""+ my_app.setLang +"\"];");
			}catch(err){
				console.log("ERR [_prePopulateList] Doesn't have __"+sid+"_SMVal parameters.");
			}
			var __itWrap = $('#' + item + "-item");
			var __idClass = item;
			
			for(ssid in data){
				// lang selection
				//try{
				//	__popList[ssid].label[my_app.setLang];
				//}catch(err){
				//}
				
				if(__popList[ssid].label[my_app.setLang]){
					__selLang = my_app.setLang;
				}else{
					console.log("[_prePopulateStaticList] Lang not available ("+my_app.setLang+")!");
					for(key in __popList[ssid].label){
						__selLang = key;
						break;
					}
				}

				$('li', __itWrap).attr('my-id', ssid);
				var __lbls;
				// content Label overwrite.
				for (var j=0; j<data[ssid].l.length; j++){
					__lbls = $("."+item+"-l"+j, __itWrap);
					for (var k=0; k<__lbls.length; k++){
						__lbls[k].innerHTML = data[ssid].l[j];
					}
					__lbls = $("."+item+"-img"+j, __itWrap);
					for (var k=0; k<__lbls.length; k++){
						__lbls[k].attr('src', data[ssid].img[j]);
					}
				}
				__lbls = null;

				// static Label overwrite.
				for (var j=0; j<__popList[ssid].label[__selLang].length; j++){
					__lbls = $("."+item+"-sl"+j, __itWrap);
					if(isNaN(__popList[ssid].label[__selLang][j])){
						for (var k=0; k<__lbls.length; k++){
							__lbls[k].innerHTML = __popList[ssid].label[__selLang][j];
						}
					}else if(__subCont[j] != undefined){
						for (var k=0; k<__lbls.length; k++){
							__lbls[k].innerHTML = __subCont[j][0];
						}
					}else{
						console.log("Error static content not exist ...");
					}
				}
				__lbls = null;
				// static Image overwrite.
				for (var j=0; j<__popList[ssid].img.length; j++){
					__lbls = $("."+ item + "-simg"+j,__itWrap);
					__lbls.attr('src', __popList[ssid].img[j]);
				}
				$(wrapul).append(__itWrap.html());
				delete __popList[ssid];
			}
			
			for(ssid in __popList){
				var __i = 0;
				var cont = true;
				do{
					__lbls = $("."+item+"-l"+__i, __itWrap);
					if(__lbls.length > 0){
						for (var k=0; k<__lbls.length; k++){
							__lbls[k].innerHTML = "";
						}
						__i++;
					}else{
						cont = false;
					}
				}while(cont)
				
				$('li', __itWrap).attr('my-id', ssid);
				
				// lang selection
				if(__popList[ssid].label[my_app.setLang]){
					__selLang = my_app.setLang;
				}else{
					console.log("[staticList] Lang not available !");
					for(key in __popList[ssid].label){
						__selLang = key;
						break;
					}
				}
				
				// static Label overwrite.
				for (var j=0; j<__popList[ssid].label[__selLang].length; j++){
					__lbls = $("."+item+"-sl"+j, __itWrap);
					if(isNaN(__popList[ssid].label[__selLang][j])){
						for (var k=0; k<__lbls.length; k++){
							__lbls[k].innerHTML = __popList[ssid].label[__selLang][j];
						}
					}else if(__subCont[j] != undefined){
						for (var k=0; k<__lbls.length; k++){
							__lbls[k].innerHTML = __subCont[j][1];
						}
					}else{
						console.log("Error static content not exist ...");
					}
				}
				__lbls = null;
				// static Image overwrite.
				for (var j=0; j<__popList[ssid].img.length; j++){
					__lbls = $("."+ item + "-simg"+j,__itWrap);
					__lbls.attr('src', __popList[ssid].img[j]);
				}
				$(wrapul).append(__itWrap.html());
			}
			
			$("li", wrapul).wrapAll('<ul class="'+__idClass+'-ul"/>');
			return true;
		};
		
		// ----------------------------------------------------------------------------------------------------------------
		// END Function for initial ccontent update protocol --------------------------------------------------------------
		// ----------------------------------------------------------------------------------------------------------------
	
	
	
	return my_app;
})(myapp, jQuery);
