/*
 * Myapphone my_mobile.js
 * http://www.myapphone.com
 * 
 * Inspired from   
 * jQuery Mobile v@VERSION
 * http://jquerymobile.com/
 *
 * Copyright 2010, jQuery Project
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 */

(function( $, win, myapp ) {
		
	$.mobile = {};
	var __this = this;
	
	var $html = $( "html" ),
		$loader = $('<div class="ui-loader ui-body-a ui-corner-all">'+
			'<span class="ui-icon ui-icon-loading spin"></span>'+
			'<h1>'+ $.mobile.loadingMessage +'</h1>'+
		'</div>'),
		$pageContainer;
	
	$.extend( $.mobile, {
		defaultActive: 'my-splash',
		activeClass: 'my-page-active',
		active: null,
		activeID: "",
		loadingMessage: "Chargement",
		transitions: ['slide', 'fade']
	});
	
	$.extend( $.support, {
		orientation: "orientation" in window,
		touch: "ontouchend" in document,
		cssTransitions: "WebKitTransitionEvent" in window
	});
	
	// FOR test only.
	$.mobile.test = function(){
		alert("test");
	};
	
	// turn on/off page loading message.
	function pageLoading( done ) {
/*		
		if ( done ) {
			$html.removeClass( "ui-loading" );
		} else {
		
			if( $.mobile.loadingMessage ){
				$loader.appendTo($pageContainer).css({top: $(window).scrollTop() + 75});
			}	
			$html.addClass( "ui-loading" );
		}
*/
	};
	
	$.extend( $.mobile, {
		pageLoading: pageLoading
	});
	
	
	$.mobile.changePage = function (to, transition, back, changeHash, chgData){

		if (!back && myapp.NATIVE && myapp.native_device === "android") {
			// set back action to the native layer (used in Android apps)
			var __lnk = $(to +" #lnk_acc");
			if (__lnk && (__lnk.css('visibility') == 'visible')) {
				var __backaction = __lnk.attr('href');
				if (__backaction && (__backaction !== "#")) __I_native_event('backaction:'+encodeURIComponent(__backaction));
			}
		}

		if(transition === true) transition = "none";
		
		var to = $(to),
		from = $.mobile.active;

		function executeEffect(chgData) {
			// Collapse the keyboard
		    $(':focus').blur();
			
			__trigger(from, 'pagebeforehide', {nextPage: {nextPage: $(to).attr("id")}}, chgData);
			__trigger(to, 'pagebeforeshow', {prevPage: {nextPage: $(from).attr("id")}}, chgData);

			// call back function once animation / transition ended
			__this.loadComplete = function(){
				__trigger(from, 'pagehide', {nextPage: $(to).attr("id")}, chgData);
				__trigger(to, 'pageshow', {prevPage: $(from).attr("id")}, chgData);
				
				$.mobile.active = to;
				$.mobile.activeID = $(to).attr("id");
				$(to).focus();
			};//end loadComplete
			
			// if browser don't support transition call, none effect.
			if(!$.support.cssTransitions) transition = 'none';
			
			if(transition && (transition !== 'none')){
				// animate in / out
				// TODO EG : change check device only by device and version. 
				if(myapp.native_device === 'android'){
					if(transition === 'slide')__effectSlideTransition(to, from, back, chgData);
					if(transition === 'fade')__effectFadeTransition(to, from, chgData);
				}else{
					__effectAnimation(to, from, back, transition, chgData);
				}
			}else{
				if(from){
					from.removeClass($.mobile.activeClass);
					from.attr('active', '0');
				}

				// none effect ...
				to.addClass( $.mobile.activeClass );
				// send pageloded event to "to"
				to.attr('active', '1');
				__trigger(to, 'pageloaded', null, chgData);
				
				
				__this.loadComplete();
			}
		};

		try{
			// EG - 27.07.12 on élimine la transition si on va à la même page.
			if(to.selector === from.selector){
				// JB - 2012-10-22
				if(myapp.NATIVE) __I_native_event('enmenu');
				return;
			}else{
				chgData = chgData || {};

				var idAgr=to.attr('aid');
				if(idAgr){
					myapp.registerAction(idAgr, ACT_VIEW_AGR);
				}
				idAgr = null;

				executeEffect(chgData);
			}
		}catch(e){
			if(console.error) console.error(e);
			else if(console.log) console.log(e);
		}
	};//end $.mobile.changePage
	
	/*
	 * support for slide transition
	 */
	function __effectSlideTransition(to, from, back, chgData){
		// callback - remove classes, etc
		$(to).one('webkitTransitionEnd', function(){__CB_transition(to, from);}); //end webkitTransitionEnd
		
		to.css("webkitTransform", "translate3d(" + (back ? "-100%" : "100%") + ",0px,0px)");
        from.css("webkitTransform", "translate3d(0px,0px,0px)");
        
		to.addClass( $.mobile.activeClass);
		__trigger(to, 'pageloaded', null, chgData);

        setTimeout(function() {
            var css = {"webkitTransitionDuration": "750ms", "webkitTransitionTimingFunction": "ease-in-out"};
            to.css(css);
            from.css(css);
            
            to.css("webkitTransform","translate3d(0px,0px,0px)");
            from.css("webkitTransform", "translate3d(" + (back ? "100%" : "-100%") + ",0px,0px)");
        }, 50);
	}//end __effectSlideTransition
	
	/*
	 * support for fade transition.
	 */
	function __effectFadeTransition(to, from, chgData){
		// callback - remove classes, etc
		$(to).one('webkitTransitionEnd', function(){__CB_transition(to, from);}); //end webkitTransitionEnd
		
		from.css({"opacity":"1", "z-index":"10"});
		to.css({"opacity":"0", "z-index":"0"});
		to.addClass( $.mobile.activeClass);
		__trigger(to, 'pageloaded', null, chgData);

        setTimeout(function() {
            var css = {"-webkit-transition": "opacity 1s linear"};
            to.css(css);
            //from.css(css);
            
    		to.css({"opacity":"1", "z-index":"10"});
        }, 50);
	}// end __effectFadeTransition
	
	function __CB_transition(to, from){
        var css = {"webkitTransitionDuration": "", "webkitTransitionTimingFunction": "", "webkitTransform": "", "-webkit-transition":""};
        to.css(css);
        from.css(css);
        
        from.removeClass($.mobile.activeClass);
		from.attr('active', '0');
		// set active reset previous
		to.attr('active', '1');
		__this.loadComplete();
	}//End __CB_transition
	
	/*
	 * Support for animation (only in iPhone currently)
	 */
	function __effectAnimation(to, from, back, transition, chgData){
		// callback - remove classes, etc
		$(to).one('webkitAnimationEnd', function(){__CB_animation(to, from);}); //end webkitAnimationEnd
		
		from.addClass( transition + " out " + ( back ? "reverse" : "" ));
		to.addClass( $.mobile.activeClass + " " + transition + " in " + ( back ? "reverse" : "" ) );
		__trigger(to, 'pageloaded', null, chgData);
	}//end __effectAnimation
	
	function __CB_animation(to, from){
		// css definition are declared in common/styles/my_main.css
		from.add( to ).removeClass(" out in reverse " + $.mobile.transitions.join(' ') );
        from.removeClass($.mobile.activeClass);
        
		// set active reset previous
		to.attr('active', '1');
		from.attr('active', '0');
		__this.loadComplete();
	}//End __CB_animation
	
	
	
	// ------------------------------------------------------------------------------------------------------------------------
	// Useful function ...
	/*
	 * target : targeted page.
	 * type : type of event
	 * evtData : simple object data embedeed within the Event Object.
	 * addData : additional data sended to the callback event function.
	 */
	function __trigger(target, type, evtData, addData){
		evt = $.Event(type);
		evt.type = type;
		if(evtData != null) evt.evData = evtData;
		$(target).trigger(evt, addData);
	}//end __trigger
	
	
	function initPage(){
		// reset active page
		$('[my-role="listw"]').attr("active", "0");
		$('[my-role="page"]').attr("active", "0");
		
		// check for defaut ...
		$.mobile.active = $( "." +  $.mobile.activeClass);
		if(!$.mobile.active.length){
			//set defaut to active
			var __def = $("#"+$.mobile.defaultActive);
			if(__def.length){
				$(__def).addClass($.mobile.activeClass);
				$(__def).attr("active", "1");
				$.mobile.active = __def; 
			}else $.mobile.active = null;
		}else{
			$($.mobile.active).attr("active", "1");
		}
		
		$pageContainer = $($.mobile.active).parent();
		
		// get ActiveID page 
		setTimeout(function(){
			if($.mobile.active != null){
				$.mobile.activeID = $($.mobile.active).attr("id");
			}
		}, 25);
	}//end initPage
	
	// Init page. 
	win.onload = initPage;
	
})( jQuery, this, myapp );
