/**
 * Copyright (c) 2011 myapphone.com, http://myapphone.com/ Version 1.0.0 - Last
 * updated: -
 * 
 * Main management object.
 * 
 * TODO EG - 07.08.12 : Ajout d'un protocole de configuration.
 * La configuration permet de recevoir des informations provenant du serveur qui ne sont pas 
 * actualisée souvent (1 fois par mois ...) 
 * - Ces informations sont générées depuis le serveur et encapsulées dans un objet JSON.
 * - Cet objet est sauvegardé dans l'application, et chargé à chaque démarrage.
 * - la Methode checkForMessage() est chargée de verifier les mises à jour de cet objet en tache de fond.
 * 
 * 
 */

// --------------------------------------------------------------------------------
// --------------------------------------------------------------------------------
// -- Global Constantes
var MY_OK = 0;
var MY_GPS_NO_POSITION = 10;
var MY_GPS_POSITION = 11;
var MY_GPS_ERROR = 12;
var MY_GPS_OFF = 13;

var MY_ERROR = 1000;
var MY_GPS_PERMISSION_DENIED = 1001;
var MY_GPS_POSITION_UNAVAILABLE = 1002;
var MY_GPS_TIMEOUT = 1003;
var MY_GPS_UNKNOW_ERROR = 1004;

var MY_PAGER_LR = "lr"; 	// left/right button to navigate.
var MY_PAGER_PLUS = "plus";	// "More" button a the end of each page.
var MY_PAGER_PULL = "pull";	// Pull 2 refresh mechanism.

var MY_DEFAULT_TRANSITION = "none";	// Default transition effect.
var MY_DEF_NO_TRANS = "none";			// Default no transition effect.

var DAY_MS = 86400000; // days in ms

var MAX_PAGE_STORE = 20; // max number of page storables in the device

var MY_PAGER_PULL = "pull";

var MY_SYS_LABEL = {
	"fr" : {
		"pullDownLabel" : [ 'Tirer vers le bas pour raffraichir ...', 'Relacher pour rafraichir ...', 'Chargement...' ],
		"pullUpLabel" : [ 'Tirer vers le haut pour plus d\'annonces ...', 'Relacher pour rafraichir ...', 'Chargement...' ],
		"bt_plus" : "Plus d'annonces..."
	},
	"en" : {
		"pullDownLabel" : [ 'Pull down to refresh...', 'Release to refresh...', 'Loading...' ],
		"pullUpLabel" : [ 'Pull up to refresh...', 'Release to refresh...', 'Loading...' ],
		"bt_plus" : "More ads..."
	},
	"it" : {
		"pullDownLabel" : [ 'Ricevere per attualizzare...', 'Aggiornare per attualizzare…', 'Caricamento...' ],
		"pullUpLabel" : [ 'Inviare per attualizzare...', 'Aggiornare per attualizzare…', 'Caricamento...' ],
		"bt_plus" : "Info suppl...."
	}
};

var NO_CONTENT_LABEL = {
	"def" : {
		"0" : "__l0106",
		"1" : "__l0107",
		"2" : "__l0108",
		"3" : "__l0049"
	}
};

var BASE_URL = "https://www.myapp.net/pub/proc/"

var MY_ERROR_MESSAGE = {
	"en" : {
		"500" : "Loading ...",
		"1000" : "An error occured!\n",
		"1001" : "User did not share geolocation data!",
		"1002" : "Could not detect current position!",
		"1003" : "Retrieving position timed out!",
		"1004" : "Unknown error!",
		"1005" : "Server timeout!",
		"1006" : "The server is not responding!\nDisplaying the contents of the cache.",
		"1050" : "There is not content to display.<br/>Please try later !",
		"1100" : "No update available!\nPlease retry later.",
		"1150" : "Server not responding! \nPlease retry later.",
		"1500" : "Init RSS failed! \nPlease retry later.",
		"2000" : "No video available at this time!\nPlease retry later.",
		"2001" : "Error during the loading of the diaporama!\nPlease retry later.",
		"2100" : "Pull up to load more...",
		"2101" : "Release to refresh...",
		"3000" : "A connection problem prevented an image to be downloaded correctly!",
		"3001" : "These functions will be activated in the application that will be published in AppStore and Google Play.",
		"3002" : "Some fields are bad/not entered.",
		"3003" : "Please choose a/some date(s)."
	},
	"fr" : {
		"500" : "Chargement ...",
		"1000" : "Une erreur est survenue lors de la connexion avec le service !\n",
		"1001" : "Impossible de détecter votre position!\n(Acces refusé!)",
		"1002" : "Impossible de détecter votre position!\n(Pas de position!)",
		"1003" : "Impossible de détecter votre position!\n(Délai d'attente dépassé!)",
		"1004" : "Impossible de détecter votre position!\n(Une erreur inconnue est survenue!)",
		"1005" : "Le serveur n'a pas répondu assez rapidement!",
		"1006" : "Le contenu n'a pas pu être téléchargé!\nAffichage des contenus du cache.",
		"1050" : "Il n'y a pas de contenu à afficher.<br/>Ressayez plus tard !",
		"1100" : "Pas de nouveau contenu!\nVeuillez réessayer ultérieurement.",
		"1150" : "Contenu indisponible\n pour le moment! \nVeuillez réessayer ultérieurement.",
		"1500" : "Impossible d'initialiser le flux RSS! \nVeuillez réessayer ultérieurement.",
		"2000" : "Pas de vidéo disponible pour l'instant!\nVeuillez réessayer ultérieurement.",
		"2001" : "Impossible de télécharger le diaporama!\nVeuillez réessayer ultérieurement.",
		"2100" : "Tirez vers le haut pour plus de contenu ...",
		"2101" : "Relachez pour rafraichir ...",
		"3000" : "Un problème de connexion a empêché une image de se charger correctement !",
		"3001" : "Ces boutons seront activés dans l'application qui sera publiée dans l'AppStore et Google Play.",
		"3002" : "Des champs sont mal/non saisis.",
		"3003" : "Veuillez choisir une/des date(s)."
	},
	"it":{
		"500" : "Caricamento ...",
		"1000" : "Si è verificato un errore!\n",
		"1001" : "L’utente non ha condiviso i dati di geolocalizzazione!",
		"1002" : "Impossibile rilevare l’attuale posizione!",
		"1003" : "Possibiltà di recupero scaduta!",
		"1004" : "Errore sconosciuto!",
		"1005" : "Timeout del server!",
		"1006" : "Il server non risponde!\nVisualizzazione del contenuto nascosto.",
		"1050" : "Non ci sono contenuti da visualizzare.<br/>Si prega di riprovare più tardi !",
		"1100" : "Nessun aggiornamento disponibile!\nSi prega di riprovare più tardi.",
		"1150" : "Il server non risponde! \nSi prega di riprovare più tardi.",
		"1500" : "Init RSS fallito! \nSi prega di riprovare più tardi.",
		"2000" : "Nessun video disponibile al momento!\nSi prega di riprovare più tardi.",
		"2001" : "Errore durante il caricamento del diaporama!\nSi prega di riprovare più tardi.",
		"2100" : "Inviare per scaricare maggiormente...",
		"2101" : "Aggiornare per attualizzare...",
		"3000" : "Un problema di connessione ha impedito di scaricare correttamente l’immagine!",
		"3001" : "Queste funzioni saranno attivate nel programma che sarà visualizzato in AppStore e Google Play.",
		"3002" : "Alcuni campi sono errati/incompleti.",
		"3003" : "Seleziona una/più data(e)."
	}
};

var ACT_VIEW_AGR = 1; // view an agrregation...

var ACT_TEL_AGR = 256; // make a call on agrregation
var ACT_COM_AGR = 512; // send mail on agrregation
var ACT_SHR_AGR = 1024; // share agrregation...
var ACT_CAL_AGR = 2048; // add to calendar agrregation...
var ACT_WRT_COM = 4096; // write a comment on a note.
var ACT_LNK_COM = 8192; // click on an external link

var ACT_SET = -1000; // tell and action is set in the action back-up.
var ACT_NOT_FOUND = -1; // tell and action is not found for the agregation.

var MY_DIAP_PREFIX = '%%%%_';

// -----------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------
// Declaration of the callback functions for dialogs box ...

/*
 * Callback function for native dialobox
 * 
 * @see reloadImage
 */
function __CB_reloadImage(id, sel) {
	if (id === "err") {
		if (myapp.NATIVE)
			__I_native_event('enmenu');
	}
}

/*
 * Callback function for native dialobox
 * 
 * @see checkForMessage
 */
function __CB_checkForMessage(id, sel, prms) {
	// get message params
	var __msg_prms;
	// TODO : voir si l'on decoder la variable prms
	eval("__msg_prms = " + prms);

	if (id === 'prompt') {
		// on envoi la selection au serveur.
		myapp.selFromPrompt(__msg_prms.id, sel, __msg_prms.nonce);
	}else if(id === 'dial'){
		myapp.selFromPrompt(__msg_prms.id, -1, __msg_prms.nonce);
	}
}// end __CB_checkForMessage

function __debug_objToString(o){
	var __res = "";
	for(var p in evt){
		__res += p+":"+evt[p]+"\n";
	}
	return __res;
}

// --------------------------------------------------------------------------------
// --------------------------------------------------------------------------------
// -- Useful functions.

String.prototype.endsWith = function(str) {
	return (this.match(str + "$") == str);
};

String.prototype.startsWith = function(str) {
	return (this.match("^" + str) == str);
};

String.prototype.trim = function() {
	return this.replace(/^\s+|\s+$/g, "");
};

// for action and statistic management
Array.prototype.getRepItemId = function(rep, item, action) {
	for (i = 0; i < this.length; i++) {
		if ((this[i].rep === rep) && (this[i].item === item)) {
			if ((this[i].action & action) == 0)
				return i;
			else
				return ACT_SET;
		}
	}
	return ACT_NOT_FOUND;
};

// format date following ISO8601.
Date.prototype.formatISO8601 = function (str, lang) {
	if( str == null || str == undefined ) return ''; 
	var __lang = (lang == null)?"en":lang;
    var regexp = "([0-9]{4})(-([0-9]{2})(-([0-9]{2})" +
        "(T([0-9]{2}):([0-9]{2}):([0-9]{2}))))";
    var d = str.match(new RegExp(regexp));
    
    var offset = 0;
    var date = new Date(d[1], 0, 1);
    if (d[3]) { date.setMonth(d[3] - 1); }
    if (d[5]) { date.setDate(d[5]); }
    this.setTime(Number(date));
    
    switch (__lang) {
	    case "fr":
	    case "it":
	    case "es":
	    	return d[5] + "/" + d[3] + "/" + d[1];
	    break;
	    default: 
	    	return d[3] + "/" + d[5] + "/" + d[1];
	    break;
	}//End switch
};

function sortNumber(a,b){
	return a - b;
}

/**
 * function to count the properties of an object.
 * 
 * @param obj
 * @returns {Number}
 */
function COUNTPROP(obj) {
	var count = 0;
	for ( var prop in obj) {
		if (obj.hasOwnProperty(prop))
			++count;
	}
	return count;
}

function emptyObject(obj) {
	return $.isEmptyObject(obj);
}

// -----------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------

var myapp = (function($, window) {

	// --------------------------------------------------------------------------------
	// private properties.
	var __my = {};

	// ref. to initial window object.
	var __window = window;

	// ref. to the internal css style declaration see <head>.
	var __inSheetCSS = null;

	/*
	 * Configuration parameters for different screen size. index of table is
	 * __my.screenType
	 */
	var __relParam = [];
	__relParam["1"] = { // iphone 3
		bf : 16, // main body font size
		mh : 60, // height of the menu bar
		mico : 30
	// icon height of the menu bar icon
	};
	__relParam["2"] = { // iPhone 4.
		bf : 32, // main body font size
		mh : 120, // height of the menu bar
		mico : 60
	};
	__relParam["3"] = { // only for test.
		bf : 16, // main body font size
		mh : 60, // height of the menu bar
		mico : 20
	};

	// Initialisation of main size parameters.
	var __winh = window.innerHeight, __winw = window.innerWidth;

	// application customizable options
	// Not yet used ...
	var __options = null;

	// Background images array (see. my_params.js) ...
	var __bckImg = null;

	// Stipulate the doc is loaded
	var __docLoad = false;
	var __splashOk = false;

	var __loadProcess = [];
	var __langProcess = [];
	var __idCurrentMenu = "";
	var __idCurrentBack = "";

	// --------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------
	// Useful fonctions
	var Base64 = {
		// private property
		_keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

		// public method for encoding
		encode : function(input) {
			var output = "";
			var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
			var i = 0;

			input = this._utf8_encode(input);

			while (i < input.length) {

				chr1 = input.charCodeAt(i++);
				chr2 = input.charCodeAt(i++);
				chr3 = input.charCodeAt(i++);

				enc1 = chr1 >> 2;
				enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
				enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
				enc4 = chr3 & 63;

				if (isNaN(chr2)) {
					enc3 = enc4 = 64;
				} else if (isNaN(chr3)) {
					enc4 = 64;
				}

				output = output + this._keyStr.charAt(enc1)
						+ this._keyStr.charAt(enc2) + this._keyStr.charAt(enc3)
						+ this._keyStr.charAt(enc4);

			}

			return output;
		},

		// public method for decoding
		decode : function(input) {
			var output = "";
			var chr1, chr2, chr3;
			var enc1, enc2, enc3, enc4;
			var i = 0;

			input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

			while (i < input.length) {

				enc1 = this._keyStr.indexOf(input.charAt(i++));
				enc2 = this._keyStr.indexOf(input.charAt(i++));
				enc3 = this._keyStr.indexOf(input.charAt(i++));
				enc4 = this._keyStr.indexOf(input.charAt(i++));

				chr1 = (enc1 << 2) | (enc2 >> 4);
				chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
				chr3 = ((enc3 & 3) << 6) | enc4;

				output = output + String.fromCharCode(chr1);

				if (enc3 != 64) {
					output = output + String.fromCharCode(chr2);
				}
				if (enc4 != 64) {
					output = output + String.fromCharCode(chr3);
				}

			}
			output = this._utf8_decode(output);

			return output;

		},

		// private method for UTF-8 encoding
		_utf8_encode : function(string) {
			string = string.replace(/\r\n/g, "\n");
			var utftext = "";

			for ( var n = 0; n < string.length; n++) {

				var c = string.charCodeAt(n);

				if (c < 128) {
					utftext += String.fromCharCode(c);
				} else if ((c > 127) && (c < 2048)) {
					utftext += String.fromCharCode((c >> 6) | 192);
					utftext += String.fromCharCode((c & 63) | 128);
				} else {
					utftext += String.fromCharCode((c >> 12) | 224);
					utftext += String.fromCharCode(((c >> 6) & 63) | 128);
					utftext += String.fromCharCode((c & 63) | 128);
				}

			}

			return utftext;
		},

		// private method for UTF-8 decoding
		_utf8_decode : function(utftext) {
			var string = "";
			var i = 0;
			var c = c1 = c2 = 0;

			while (i < utftext.length) {

				c = utftext.charCodeAt(i);

				if (c < 128) {
					string += String.fromCharCode(c);
					i++;
				} else if ((c > 191) && (c < 224)) {
					c2 = utftext.charCodeAt(i + 1);
					string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
					i += 2;
				} else {
					c2 = utftext.charCodeAt(i + 1);
					c3 = utftext.charCodeAt(i + 2);
					string += String.fromCharCode(((c & 15) << 12)
							| ((c2 & 63) << 6) | (c3 & 63));
					i += 3;
				}

			}
			return string;
		}
	};// end Base64

	// --------------------------------------------------------------------------------
	// Public properties.
	__my.AppID = ""; // application ID must be use in each communication with
						// the server
	__my.setLang = "en"; // default lang.
	__my.LANG = {}; // array of label of the default lang.
	__my.supportedLANG={"fr":1, "en":1};//default supported lang (can be override in my_params) (JB:2012-11-07)
	__my.UDID = ""; // unique identifier of the device
	__my.PIN = ""; // Push identifier.

	// native function
	__my.NATIVE = false; // Check if we are native or web
	__my.nat_end_splash = "fade"; // native end splash
	__my.native_device = "unknw"; // native device
	__my.native_version = "0"; // native device version
	__my.splash_auto_end = false; // native device
	__my.sup_canvas_anim = false; // Support canvas animation

	__my.MENU = null; // Menu table.
	__my.splashImgSrc = ""; // source of the splash image.
	__my.homeImgSrc = ""; // source of the home image.

	// Image params.
	__my.catImg = null; // array of category images.
	__my.imgCacheDuration = 1; // Life time of cache Image default 1 day.
	__my.pageCacheDuration = 1; // Life time of cache default 1 day.

	__my.checkForMsgs = true; // Check for server message.

	__my.menuReload = false; // Allow reload when click on menu (need to
							// implement the reclick event)

	// pager management ...
	__my.pager = {
		"reset" : false,
		"use" : false,
		"idx" : 0,
		"nb" : 5,
		"dir" : "",
		"page" : "",
		"type" : "",
		"rss" : "",
		"cat" : "",
		"isx" : 0,
		"isy" : 0
	};

	// navigator with prev page and next page : pp("previous page"), np("next
	// page")
	__my.nav = {
		"use" : false,
		"pp" : 0,
		"np" : 0
	};

	// favoris management
	__my.fav = {};

	// check if we are in the fav. menu or not
	__my.isFav = false;
	__my.favUrlFilter = "";
	__my.favCurrent = "";
	// id of the current page
	__my.currentPage = "";
	// id of the current agregation
	__my.currentAgr = "0";

	// overwrite of the my home ID,
	// allow the replacement of "my-home" by an other one
	__my.homeOverwrite = "1";

	// cache of the current title ...
	__my.currentTitle = "";

	__my.iscroll = null; // curent iscroll object.
	__my.iscrollParam = {
		scrollbarClass : 'myScrollbar',
		hScrollbar : false,
		vScrollbar : true,
		hScroll : false,
		vScroll : true
	};
	__my.iscrollPullDiv = null;
	__my.iscrollPullPage = 0;
	__my.pullNavBlock = '<div id="pullUp"><span class="pullUpIcon"></span><span class="pullUpLabel">'
			+ MY_ERROR_MESSAGE[__my.setLang]["2100"] + '</span></div>';
	__my.iscrollWindow = {
		"w" : 0,
		"h" : 0
	};

	__my.imgParamURL = "";

	// save Action list ...
	__my.actionList = {};
	__my.actDate = 0;
	__my.actNonce = 0;

	/*
	 * __my.usepager = false; // use pager for the current list. __my.pageridx =
	 * 0; // first index of the current pager. __my.pagernb = 5; // number of
	 * page item. __my.pagerPage = ""; // id of the page used by the pager.
	 */

	__my.statFreq = 30000; // stat frequence to send data to server in
							// millisec.

	__my.screenType = "1"; // __relParam[] index - Type of display default =
							// "1" iPhone3. (see. __screenType),

	__my.localization = {
		"status" : MY_GPS_NO_POSITION,
		"error" : MY_OK,
		"longitude" : "",
		"latitude" : "",
		"ownlong" : "",
		"ownlat" : "",
		"address" : {
			"name" : "",
			"street" : "",
			"city" : "",
			"code" : "",
			"tel" : {},
			"mail" : {}
		}
	}; // Current position of the user.

	__my.localization.address = {
		"name" : "",
		"street" : "",
		"code" : "",
		"city" : "",
		"tel" : "",
		"mail" : ""
	}; // Address informations.

	// Defintion of the customized map.
	__my.custoMap = null;

	// save of the calibration parameters
	__my.preCalc = null;

	__my.mainCOMID = { // Main communication ID.
		"phone" : "",
		"email" : ""
	};

	__my.config = {
		"init" : false,
		"lang" : __my.setLang,
		"pl_en" : true,
		"pl_radius" : "1000",
		"pl_url" : "",
		"push" : true,
		"loc" : false,
		"udid" : "",
		"pin" : "",
		"mail" : ""
	};

	/*
	 * Default system configuration
	 */
	__my.default_sys = {
		"zoom" : 0.8
	};

	__my.sys = {
		"app" : __my.AppID,
		"lang" : __my.setLang,
		"nat" : __my.NATIVE,
		"dev" : __my.native_device,
		"ver" : __my.native_version,
		"sw" : __winw,
		"sh" : __winh,
		"img" : {
			"b64" : 1
		},
		"mem" : 0,
		"u":__my.UDID
	};

	__my.Base64 = Base64;

	// check if we use or not the simulator.
	__my.sim = false;

	// RSS plugin ..

	// check if the content is linked to a RSS flow
	// automaticaly update when loaded my_rss.js script file
	__my.rss = false;
	
	// deprecated
	__my.useFlow = false; // Use rss flow.
	__my.useLangFlow = false; // Use different rss flow depending on the sel.
								// lang.

	// --------------------------------------------------------------------------------
	// Private methods and initialisation

	// Module constructor.
	(function __init() {
		__my.W = __winw;
		__my.H = __winh;
		__my.isLang = false;

		__I_db_init();

		// Initialisation of the user config.
		if (__I_db_exist("user-config")) {
			__my.config = $.evalJSON(__I_db_read("user-config"));
			__my.setLang = __my.config.lang;
		}else{
			//detect lang
			var __lang=(window.navigator.userLanguage || window.navigator.language).substring(0,2);
			if( __my.supportedLANG.hasOwnProperty(__lang) && __my.supportedLANG[__lang]==1 ) __my.setLang = __my.config.lang=__lang;
			__lang=null;
		}

		// Initialisation of the favoris data base.
		if (__I_db_exist("favoris")) {
			__my.fav = $.evalJSON(__I_db_read("favoris"));
		}

		// Initialisation of the global ajax configuration parameter
		$.ajaxSetup({
			headers : {
				'Authorization' : 'Basic ' + Base64.encode('test:e68fpm291')
			},
			timeout : 25000
		});

		// Get a reference to the internal style declaration, inside the <head>
		// of index.html
		if (document.styleSheets) {
			for ( var i = 0; i < document.styleSheets.length; i++) {
				var __elem = document.styleSheets[i];
				if (__elem.ownerNode.nodeName == 'STYLE') {
					__inSheetCSS = __elem;
					break;
				}
			}
		}

		// Initialisation of the screen size depending parameters
		// Expecially for Android and Blacberry (same OS but for differente
		// screen size device compliant)
		__my.screenType = __screenType(__winw, __winh);

		// get host version os , configure special param.
		var isIphone = (/iPhone/gi).test(navigator.userAgent);
		var isIpOS4 = (/iPhone OS 4_0/gi).test(navigator.userAgent);
		var isIpOS5 = (/iPhone OS 5_0/gi).test(navigator.userAgent);

		if (isIphone)
			__my.native_device = "iphone";

		if (isIpOS5)
			__my.sup_canvas_anim = true;

		$(document).ready(function(){
			__initHandler();
			//fix for ios7
			if(myapp.native_device=="iphone"){
				$('head').append('<style>.my-header{width:320px!important;}</style>');
			}
		});
	}()); // end constructor

	/*
	 * Method call to init static menu instead of declaration in my_param.js
	 */
	__my.initStaticMenu = function() {
		// Initialisation of the appid
		__my.AppID = $("my_params").attr('mobileid');
		console.log("[initStaticMenu] get AppID :" + __my.AppID);
		if ((__my.AppID) && (__my.AppID != ""))
			__my.updateSetup();

		// creation of the static menu
		var __ps = $("my_params");
		if (__ps.length) {
			__my.myMenu = {};
			$("menu", __ps).each(function() {
				var __idx = $(this).attr('idx');
				__my.myMenu[__idx] = {};
				var __cont = $(this).text();
				eval('__my.myMenu["' + __idx + '"] = ' + __cont);
				console.log("[initStaticMenu] init static menu :" + __idx);
			});
		} else {
			console.log("[initStaticMenu] my_params not found :");
		}
	};// end initStaticMenu

	/*
	 * Method call to init static menu instead of declaration in my_param.js
	 */
	__my.initFavMenu = function(page) {
		var __data = {};
		for (agid in __my.fav) {
			var __res = __getItemFromMenu(agid);
			if (__res != null) {
				var __agid = String(agid);
				__data[__agid] = __res;
			}
		}// end for
		if (COUNTPROP(__data) > 0)
			__my.staticList(__data, page);
		else
			__my.createListFromContent(null, page);
	};// end initFavMenu

	function __getItemFromMenu(id) {
		for (idpage in __my.myMenu) {
			for (idit in __my.myMenu[idpage]) {
				if (__my.myMenu[idpage][idit].id == id) {
					return __my.myMenu[idpage][idit];
				}
			}
		}// end for
		return null;
	}// end __getItemFromMenu

	// Internal event declaration.
	/*
	 * var __myEventTest = {type:"RSS", desc:"Internal Object"};
	 * $(__myEventTest).bind("rss", function(event, name){
	 * alert(this.desc+":"+name); }); 
	 * $(__myEventTest).trigger("rss", ["... Event data"]);
	 */

	/*
	 * Private method - Use to eveluate the category of the current device.
	 */
	function __screenType(w, h) {
		// UserAgent used to detect which is the device type (android,
		// blackberry, iPhone)
		if ((w >= 640) & (h >= 960)) {
			var __rules={
				"body":"font-size: " + __relParam["2"].bf + "px;",
				".my-page .my-footer ":"height: "+ __relParam["2"].mh + "px;"
			};
			if(__inSheetCSS.addRule !== undefined){
				var __i=0;
				for(var __x in __rules){
					__inSheetCSS.addRule(__x, __rules[__x], __i);
					__i++;
				}
				__i=__x=null;
			}else if(__inSheetCSS.insertRule !== undefined){
				var __i=0;
				for(var __x in __rules){
					__inSheetCSS.insertRule(__x + "{" + __rules[__x] + "}", __i);
					__i++;
				}
				__i=__x=null;
			}
			return "2";
		} else {
			var __rules={
				"body":"font-size: " + __relParam["1"].bf + "px;",
				".my-page .my-footer ":"height: "+ __relParam["1"].mh + "px;"
			};
			if(__inSheetCSS.addRule !== undefined){
				var __i=0;
				for(var __x in __rules){
					__inSheetCSS.addRule(__x, __rules[__x], __i);
					__i++;
				}
				__i=__x=null;
			}else if(__inSheetCSS.insertRule !== undefined){
				var __i=0;
				for(var __x in __rules){
					__inSheetCSS.insertRule(__x + "{" + __rules[__x] + "}", __i);
					__i++;
				}
				__i=__x=null;
			}
			return "1";
		}

		var __uA = navigator.userAgent;
		// Depending on the size of the screen and userAgent calcule the
		// application category.
		// This category is the index of __relParam[] which store the parameters
		// depending on the size screen.

		return "1";
	}// end __screenType

	/*
	 * Method call by the native layer during the start of the application, just
	 * before launch the webview. Before call this method the native layer set
	 * the __my.UDID, __my.PIN variable.
	 */
	__my.updatePIN = function() {
		// update config
		if (__I_db_exist("user-config")) {
			__my.config = $.evalJSON(__I_db_read("user-config"));
		}
		if (__my.config.pin != __my.PIN) {
			__my.savePIN();
		}
		__my.config.udid = __my.UDID;
		__my.config.pin = __my.PIN;
		__my.saveConfig();
	};// end updatePIN

	__my.savePIN = function() {
		// register pid and udid
		var __url = BASE_URL + "/_mStats.php?reg=1&apt=gcm&dev=" + __my.native_device
				+ "&ver=" + __my.native_version + "&p=" + __my.PIN + "&u="
				+ __my.UDID;
		console.log("PUSHSTAT : maj stat, regid : " + __my.PIN);
		__my.getObjectFrom(__url, __my.pinSaved, __my.pinErr);
	};

	// Call back function on stat return
	__my.pinSaved = function(data) {
		if (data) {
			__my.updateSetup();
			console.log("[pinSaved] pin saved ...");
		} else {
			console.log("[pinSaved] Bad data server format ...");
			setTimeout('__my.savePIN', 30000);
		}
	};
	// Call back function on stat return
	__my.pinErr = function(err) {
		setTimeout('__my.savePIN', 30000);
	};
	
	__my.notifyZoneUpdate = function(zone, rid) {
		var __url = __my.config.pl_url + "&zone=" + ((zone) ? 1 : 0);
		if (rid) __url += "&r="+rid;
		console.log("PUSHSTAT :  Zone update, url : " + __url);
		__my.getObjectFrom(__url, __my.notifyZoneSuccess, __my.notifyZoneErr);
	};
	
	__my.notifyZoneSuccess = function (data) {
		console.log("PUSHSTAT : [notifyZoneUpdate] success, data : " + data);
	};

	__my.notifyZoneErr = function (err) {
		console.log("PUSHSTAT : [notifyZoneUpdate] error : " + err.message);
	};

	__my.updateSetup = function() {
		__my.sys = {
			"app" : __my.AppID,
			"lang" : __my.setLang,
			"nat" : __my.NATIVE,
			"dev" : __my.native_device,
			"ver" : __my.native_version,
			"sw" : __winw,
			"sh" : __winh,
			"img" : {
				"b64" : 1
			},
			"mem" : 0,
			"app_version" : __my.app_version,
			"prtcl_version" : __my.prtcl_version,
			"u":__my.UDID
		};

		$.ajaxSetup({
			headers : {
				'my_sys' : $.toJSON(__my.sys)
			}
		});

		__my.imgParamURL = "aid=" + __my.AppID + "&";
	};

	// ----------------------------------------------------------------------------------
	// ----------------------------------------------------------------------------------
	// -- function to sort list

	__my.convertListObjectToArray = function(Obj) {
		var __arr = [];
		for ( var it in Obj) {
			__arr.push(Obj[it]);
		}
		return __arr;
	};// end convertListObjectToArray

	__my.convertArrayToListObject = function(Arr) {
		var __obj = {};
		for ( var i = 0; i < Arr.length; i++) {
			var idx = (i + "");
			__obj[idx] = Arr[i];
		}
		return __obj;
	};// end convertArrayToListObject

	__my.getTmpArray = function(page) {
		var __tmp = __my.getTmpCache(page);
		if (__tmp != null)
			return __tmp['arr'];
		else
			return null;
	};// end getTmpArray

	// ----------------------------------------------------------------------------------
	// ----------------------------------------------------------------------------------
	// -- GPS localization function

	/*
	 * function posLongLat(map, lg, lt){ if(__my.preCalc == null) __my.preCalc =
	 * {}; if(__my.preCalc[map] == undefined){ __my.preCalc[map] = {};
	 * __my.preCalc[map].dx = (__my.custoMap[map].cal.p2.x.lg -
	 * __my.custoMap[map].cal.p1.x.lg )/(__my.custoMap[map].cal.p2.x.p -
	 * __my.custoMap[map].cal.p1.x.p); __my.preCalc[map].dy =
	 * (__my.custoMap[map].cal.p2.y.lt - __my.custoMap[map].cal.p1.y.lt
	 * )/(__my.custoMap[map].cal.p2.y.p - __my.custoMap[map].cal.p1.y.p);
	 * __my.preCalc[map].lgO = __my.custoMap[map].cal.p1.x.lg -(
	 * __my.custoMap[map].cal.p1.x.p * __my.preCalc[map].dx);
	 * __my.preCalc[map].ltO = __my.custoMap[map].cal.p1.y.lt -(
	 * __my.custoMap[map].cal.p1.y.p * __my.preCalc[map].dy); } // new position
	 * nx = Math.round((lg - __my.preCalc[map].lgO)/__my.preCalc[map].dx); ny =
	 * Math.round((lt - __my.preCalc[map].ltO)/__my.preCalc[map].dy);
	 * 
	 * return {"px":nx, "py":ny}; }//end posLongLat
	 */

	/*
	 * __my.scrollCenter = function(fx, fy, imgW, imgH){ cx =
	 * (Math.round(__my.iscrollWindow.w/2)) - fx; cy =
	 * (Math.round(__my.iscrollWindow.h/2)) - fy;
	 * 
	 * if(imgW) cx = cx - (Math.round(imgW/2)); if(imgH) cy = cy -
	 * (Math.round(imgH/2));
	 * 
	 * cx = (cx > 0)?0:cx; cy = (cy > 0)?0:cy;
	 * 
	 * __my.iscroll.scrollTo(cx, cy, 500); }//end scrollCenter
	 */

	/*
	 * Callback Function to find the current lat and long position of user and
	 * displaying the google map.
	 */
	function __showGoogleMap() {
		var __imgW = __imgH = 500;
		var __availH = 200;
		// Max height available for the image. (reel height 183);
		// __my.localization.latitude = "49.0773097";
		// __my.localization.longitude = "6.1073041";
		// lien direct vers site google
		// http://maps.google.com/maps?q=49.0773097%2C6.1073041

		var image_url = "http://maps.google.com/maps/api/staticmap?sensor=true&center="
				+ __my.localization.latitude
				+ ","
				+ __my.localization.longitude
				+ "&zoom=14&size="
				+ __imgW
				+ "x"
				+ __imgH
				+ "&sensor=true&markers=color:blue|label:*|"
				+ __my.localization.latitude
				+ ','
				+ __my.localization.longitude
				+ "&markers=icon:http://chart.apis.google.com/chart?chst=d_map_pin_icon%26chld=flag%257C1CA729|"
				+ __my.localization.ownlat + ',' + __my.localization.ownlong;

		var __meters = __distMeter(__my.localization.latitude,
				__my.localization.longitude, __my.localization.ownlat,
				__my.localization.ownlong);
		$('#my-loc #loc-lbldist').html(__meters);
		var __hwrap = (__my.H - __availH);
		var __wwrap = $('#my-loc #wrapper_block').css('height', __hwrap)
				.width();
		$('#my-loc #my-map-img').css('height', __imgH).css('width', __imgW);

		// center the image
		var __x = Math.round((__imgW / 2) - (__wwrap / 2));
		var __y = Math.round((__imgW / 2) - (__hwrap / 2));

		var __page = $('#my-loc');
		var __img = $('#my-map-img', __page);
		if (__img)
			__img[0].src = image_url;
		// __updateiScroll($('#my-loc #my-body'), "#scroller_block", null, null,
		// false);
		__updateiScroll($('#my-loc #my-body'), "#scroller_block", null, null);
		__my.iscroll.scrollTo(-Math.abs(__x), -Math.abs(__x), 500);
	}// end __showGoogleMap

	function __distMeter(lat_a, lon_a, lat_b, lon_b) {
		a = Math.PI / 180;
		lat1 = lat_a * a;
		lat2 = lat_b * a;
		lon1 = lon_a * a;
		lon2 = lon_b * a;
		t1 = Math.sin(lat1) * Math.sin(lat2);
		t2 = Math.cos(lat1) * Math.cos(lat2);
		t3 = Math.cos(lon1 - lon2);
		t4 = t2 * t3;
		t5 = t1 + t4;
		rad_dist = Math.atan(-t5 / Math.sqrt(-t5 * t5 + 1)) + 2 * Math.atan(1);
		var __distM = Math
				.round((rad_dist * 3437.74677 * 1.1508) * 1.6093470878864446 * 1000);
		if (__distM > 1000)
			return Math.round(__distM / 1000) + " km";
		else
			return __distM + " m";
	}

	// TODO implement the callback method for
	__my.checkLocation = function(callback) {
		if (__my.sim) {
			__my.sim_geoloc(callback);
		}else{
			__my.localization.status = MY_GPS_NO_POSITION;
			__my.localization.error = MY_OK;
			__I_native_event('getgps:' + callback);
		}
		
		/*
		 * 
		 * if(!__I_initGPS()){ myapp.localization.status = MY_GPS_OFF; return
		 * MY_ERROR_MESSAGE[__my.setLang][__my.localization.error]; }else{
		 * return true; };
		 */
	};

	__my.GPSError = function() {

	};

	__my.getPosGoogle = function() {
		if (myapp.localization.status == MY_GPS_POSITION) {
			if ((__my.localization.latitude != "")
					&& (__my.localization.longitude != "")) {
				return "http://maps.google.com/maps?q="
						+ __my.localization.latitude + "%2C"
						+ __my.localization.longitude;
			} else {
				return null;
			}
		} else {
			return null;
		}
		;
	};
             
	__my.getPOI = function() {
		var __url = "/_mCont_3.php?pint=1";
		__url = BASE_URL + __url;
		$.ajax({url : __url}).success(function(data) {
			try{
				var __jsondata = $.toJSON(data);
				if (__jsondata) __I_native_event('geolocpoi:'+encodeURIComponent(__jsondata));
			}catch(e) {};
		});
	}

	// ----------------------------------------------------------------------------------
	// ----------------------------------------------------------------------------------
	// -- String manipulation functions

	/*
	 * Private method - Exctract number from a String. (ex. "min 23px"=23)
	 */
	__my.extractFirstNums = function(str) {
		if (str) {
			var __res = str.match(/\d+/g);
			if ((__res) && (__res.length > 0))
				return parseInt(__res[0], 10);
			else
				return 0;
		} else
			return 0;
	};

	__my.extractFirstFloat = function(str) {
		if (str) {
			var __res = str.match(/\d[\.,]\d/g);
			if ((__res) && (__res.length > 0))
				return parseFloat(__res[0]);
			else
				return 0;
		} else
			return 0;
	};

	// ----------------------------------------------------------------------------------
	// ----------------------------------------------------------------------------------
	// -- Element manipulation functions

	/*
	 * Private method - Set the height of an Object or a selector.
	 */
	function __setElemSize(sel, width, height) {
		if (typeof sel == 'object') {
			if (width)
				sel.style.width = width + 'px';
			if (height)
				sel.style.height = height + 'px';
		} else {
			var __s = $(sel);
			if (__s) {
				for ( var i = 0; i < __s.length; i++) {
					if (__s[i]) {
						if (width)
							__s[i].style.width = width + 'px';
						if (height)
							__s[i].style.height = height + 'px';
					}
				}
			}
			__s = null;
		}
	}// End __setElemSize

	/*
	 * Private method - Set the width of the current <body>
	 */
	function __initHandler() {
		$('body').css('width', __my.W);
	}

	/*
	 * Private method - get the focus to caller.
	 */
	function __getFocus() {
		$(this).focus();
	}
	
	/*
	 * Used to remove <script> from a clone element 
	 * Used to avoid script re-execution after a clone of an element in the DOM.   
	 */
	__my.removeScriptFromClone = function(jqueryElem){
		__i = 0;
		while (__i != -1){
			if(jqueryElem[__i]){
				if(jqueryElem[__i].nodeName.toLowerCase() === "script") jqueryElem.splice(__i, 1);
				else{
					removeChildScriptRecurse(jqueryElem[__i])
					__i = __i + 1;
				}
			}else __i = -1;
		}//end while.
	}//end removeScriptFromClone

	
	// Suppression recursive des noeuds "script" dans le DOM ...
	function removeChildScriptRecurse(node){
		var prev;
		for (var child = node.lastChild; child; child = prev) {
		    prev = child.previousSibling;
		    if (child.nodeName.toLowerCase() === "script") {
		        node.removeChild(child);
		        continue;
		    } 
		    removeChildScriptRecurse(child);
		}
	}//end removeChildRecurse
	
	/*
	 * Get the width of a <div> block with a String inside depending on the
	 * applied style and the length of the String. clss : rule class name (ex:
	 * "myclass") str : String to use for the calculation.
	 */
	__my.getMaxStrWidthClass = function(clss, str, incss) {
		var __tzone = $("#test_zone");
		$(__tzone).css("display", "block");
		var __tblock = $("#test_block", __tzone);
		if (__tblock.length) {
			$(__tblock).html(str);
			for ( var i = 0; i < clss.length; i++) {
				$(__tblock).addClass(clss[i]);
			}
			if (incss)
				$(__tblock).attr("style", incss);

			// get the with of the styled block.
			var __w = __tblock[0].offsetWidth;
			for ( var i = 0; i < clss.length; i++) {
				__tblock.removeClass(clss[i]);
			}
			__tblock.html("");
			__tzone.css("display", "none");

			if (incss)
				$("#test_block", __tzone).removeAttr("style");
			__tblock = __tzone = null;
			return __w;
		} else {
			return 0;
		}
	}; // End getMaxStrWidthClass

	/*
	 * Reformat all the span label that have a reformat parameter to 1 in the
	 * concerned page. @page : page id of the concerned page. @Comp :
	 * compensation size (size to be deduce from the calculate size) @style :
	 * possibility to add customized style
	 */
	__my.reformatLabel = function(page, Comp, style) {
		var __lbls = $('#' + page + ' span[reformat="1"]');
		for ( var k = 0; k < __lbls.length; k++) {
			$(__lbls[k]).css('display', 'block');
			$(__lbls[k]).css('visibility', 'hidden');
			var __pclass = $(__lbls[k]).attr('class');
			var __appclass = $(__lbls[k]).attr('refclass');
			var __dest = $('#' + page + ' .__' + __pclass);
			$(__dest).css('display', 'none');

			var __cls;
			if (__appclass) {
				eval("__cls = " + __appclass + ";");
			} else
				__cls = [];
			var __lbl = $(__lbls[k]).text();
			__lbl = reduceLabel(page, __pclass, __lbl, __cls, Comp, style);
			$(__lbls[k]).css('display', 'none');
			$(__dest).html(__lbl);
			$(__dest).css('display', 'block');
		}// end for
	}// end reformatLabel

	/*
	 * page : page id of the concerned page. labelwrapClass : Class of the block
	 * that contain the label to reformat. label : label to display. labelClass :
	 * array of all the classes applied to the current label. ex :
	 * ["headerTable", "my-head-titleLabel"]. Comp : compensation size (size to
	 * be deduce from the calculate size) style : possibility to add customized
	 * style
	 */

	function reduceLabel(page, labelwrapClass, label, labelClass, Comp, style) {
		var comp = (Comp) ? Comp : 0;
		var __headerBlock = $("#" + page + " ." + labelwrapClass);
		if (__headerBlock.length) {
			var __sizeBlock = __headerBlock[0].offsetWidth - comp;
			var __sizeTitle = __my
					.getMaxStrWidthClass(labelClass, label, style);
			if (__sizeTitle > __sizeBlock) {
				var __nbChar = label.length;
				var __toNb = (__nbChar / __sizeTitle) * __sizeBlock;
				__toNb = Math.round(__toNb - 1) - 5;
				label = label.substr(0, __toNb) + "...";
			}
			return label;
		}
	}// end reduceLabel

	// ----------------------------------------------------------------------------------
	// ----------------------------------------------------------------------------------
	// -- Favoris functions

	__my.checkFavButtonFromPage = function(evt) {
		var __e = $(evt.currentTarget);
		__e = $('#fav', __e);
		if (__my.fav[__my.currentAgr]) {
			if (__my.fav[__my.currentAgr][__my.currentPage]) {
				$("img", __e).attr("src", "./img/myapp/btn_favorisON.png");
			} else {
				$("img", __e).attr("src", "./img/myapp/btn_favoris.png");
			}
		} else {
			$("img", __e).attr("src", "./img/myapp/btn_favoris.png");
		}
	}// end checkFavButtonFromPage

	__my.updateFav = function(evt, id, fav) {
		__updateFav(evt);
	};

	// @param id id of page to add in favorites
	function __updateFav(evt) {
		// toggle favoris on the local save.
		var __e = $(evt.currentTarget);

		if (__my.fav[__my.currentAgr]) {
			if (__my.fav[__my.currentAgr][__my.currentPage]) {
				delete __my.fav[__my.currentAgr][__my.currentPage];
				if (COUNTPROP(__my.fav[__my.currentAgr]) == 0)
					delete __my.fav[__my.currentAgr];
				$("img", __e).attr("src", "./img/myapp/btn_favoris.png");
			} else {
				__my.fav[__my.currentAgr][__my.currentPage] = 1;
				$("img", __e).attr("src", "./img/myapp/btn_favorisON.png");
			}
		} else {
			__my.fav[__my.currentAgr] = {};
			__my.fav[__my.currentAgr][__my.currentPage] = 1;
			$("img", __e).attr("src", "./img/myapp/btn_favorisON.png");
		}

		// save favoris in the localstore.
		__I_db_save("favoris", $.toJSON(__my.fav));
	}// end __updateFav

	// @param id id of the aggregation used to evaluate filter.
	function __getFavFilter(id) {
		if (__my.fav[id]) {
			if (COUNTPROP(__my.fav[id]) == 0)
				return "";
			else {
				var __res = ""
				for (idit in __my.fav[id]) {
					__res += idit + ",";
				}
				__res = __res.substring(0, (__res.length - 1));
				return __res;
			}
		} else
			return "";
	}// end __getFavFilter

	// ----------------------------------------------------------------------------------
	// ----------------------------------------------------------------------------------
	// -- Lang function

	__my.setCurrentLang = function(Page) {
		__changeLang(__my.setLang, Page);
	};

	__my.changeLang = function(lang) {
		lang = (lang) ? lang : __my.setLang;
		__changeLang(lang);
	};

	__my.selectLang = function(e) {
		var __tg = e.currentTarget;
		__my.config.lang = __my.setLang = __tg.lang;
		__my.saveConfig();
		__my.updateSetup();
		__my.setCurrentLang();
	};

	/*
	 * Return the label register in the definition of a static menu
	 */
	__my.getMyMenuLabel = function(page, id, Pid) {
		pid = (Pid) ? Pid : 0;
		var __label="";
		try{
			__label = __my.myMenu[page][id]["label"][__my.setLang][pid];
		}catch(e){
			console.error("Caught Exception : ");
			console.error(e);
		}
		return __label;
	};

	__my.setNativeLang = function(lang) {
		try {
			__my.config.lang = __my.setLang = lang;
			__changeLang(lang);
			__my.saveConfig();
			__my.updateSetup();
			__my.execLangProcess();
			$.mobile.changePage("#my-splash", MY_DEF_NO_TRANS, false);
		} catch (err) {
			console.log("ERR [__my.setNativeLang]" + err.message);
		}
	}

	__my.initLang = function() {
		var __s = $("#my-lang #my-back-img"), __splash;
		if (__s && __s[0]) {
			__splash = __s[0];
			__splash.style.width = __my.W;
			__splash.style.height = __my.H;

			// Get the background image of the splash screen.
			// Image link is stored in __bckImg[]
			// index is given by the "my-bi" attribut in the <img> HTML
			// definition
			setBackImage(__s, __my.W, __my.H);
			__s = null;
		}
		__splash = null;
	}; // End initLang

	function __changeLang(lang, Page) {
		__my.setLang = lang;
		__my.config.lang = lang;
		__my.saveConfig();
		__my.updateSetup();

		page = (Page == null) ? null : Page;
		if (__my.LANG) {

			//update span[lid]
			if (page != null) {
				__lid = $("#" + page + " span[lid]");
			} else {
				__lid = $("span[lid]");
			}
			if (__lid.length) {
				for (i = 0; i < __lid.length; i++) {
					var __id = $(__lid[i]).attr('lid');
					var __lng = __my.LANG[lang][__id];
					$(__lid[i]).html(__lng);
				}

			} else {
				for ( var __lbl in __my.LANG[lang]) {
					var __span;

					if (page != null) {
						__span = $("#" + page + " ." + __lbl);
					} else {
						__span = $("." + __lbl);
					}

					if (__span.length) {
						for ( var k = 0; k < __span.length; k++) {
							__span[k].innerHTML = __my.LANG[lang][__lbl];
						}
					}
				}// end for

			}// end __lid.length

			__my.pullNavBlock = '<div id="pullUp"><span class="pullUpIcon"></span><span class="pullUpLabel">' + MY_ERROR_MESSAGE[__my.setLang]["2100"] + '</span></div>';

			//update static list
			if(__my.myMenu){
				for(var __page in __my.myMenu){
					//process used in dylog_hotel
					if( __page == "my-home" ){
						if(typeof my_home_load == "function"){
							my_home_load();
						}
					}

					__my.staticList(__my.myMenu[__page], __page);
				}
			}

			//refresh footer menu
			if(__my.sim){
				__my.refreshMenuLabels();
			}
		}// end if LANG ...
	}

	__my.translate = function (lid){
		if(__my.LANG[__my.setLang]){
			if(__my.LANG[__my.setLang][lid]){
				return __my.LANG[__my.setLang][lid];
			}
		}
		return lid;
	};

	__my.addLangProcess = function(proc) {
		__langProcess.push(proc);
	};

	/*
	 * Use to launch all the process after lang selection.
	 * 
	 * @see __my.setNativeLang
	 */
	__my.execLangProcess = function() {
		while (__langProcess.length > 0) {
			var __proc = __langProcess.pop();
			eval(__proc);
		}
		// Exec. pre-loading for RSS
		//if (__my.useFlow && __my.useLangFlow) __my.preloadFlow();
		if(__my.rss) __my.preloadFlow();
	}

	/*
	 */
	__my.formatDate = function(date) {
		var __dt = new Date(date);
		switch (__my.setLang) {
		case "fr":
		case "be":
			return __dt.getDate() + '/' + (__dt.getMonth() + 1) + '/'
					+ __dt.getFullYear();
		default:
			return (__dt.getMonth() + 1) + '/' + __dt.getDate() + '/'
					+ __dt.getFullYear();
		}
	};

	__my.parseDate=function(input, format) {
	  format = format || 'yyyy-mm-dd'; // default format
	  var parts = input.match(/(\d+)/g), 
	      i = 0, fmt = {};
	  // extract date-part indexes from the format
	  format.replace(/(yyyy|dd|mm)/g, function(part) { fmt[part] = i++; });

	  return new Date(parts[fmt['yyyy']], parts[fmt['mm']]-1, parts[fmt['dd']]);
	};

	__my.timestampToDate=function(timestamp, format){
		if(isNaN(timestamp)){
			console.error("my_process - timestampToDate : timestamp not a number");
			return timestamp;
		}else{
			var __date=new Date(timestamp*1000);

			switch(format){
				case "yyyy-mm-dd hh:mm":
				__date=__date.getFullYear()+"-"+__my.add0((__date.getMonth()+1))+"-"+__my.add0(__date.getDate())+" "+__my.add0(__date.getHours())+":"+__my.add0(__date.getMinutes());
				break;

				case "yyyy-mm-dd hh:mm:ss":
				__date=__date.getFullYear()+"-"+__my.add0((__date.getMonth()+1))+"-"+__my.add0(__date.getDate())+" "+__my.add0(__date.getHours())+":"+__my.add0(__date.getMinutes())+":"+__my.add0(__date.getSeconds());
				break;

				default:
				__date=__date.getFullYear()+"-"+__my.add0((__date.getMonth()+1))+"-"+__my.add0(__date.getDate());
			}

			__date=__date.split(" ");
			__date[0]=__my.formatDateISO(__date[0]);
			__date=__date.join(" ");

			return __date;
		}
	};

	__my.formatDateISO=function(date){
		var __dateArray;
		switch(__my.setLang){
			case 'fr':
				__dateArray=date.split("-");
				return __dateArray[2]+"/"+__dateArray[1]+"/"+__dateArray[0];
			break;
			default : 
				__dateArray=date.split("-");
				return __dateArray[1]+"/"+__dateArray[2]+"/"+__dateArray[0];
		}
	};

	__my.add0=function(str){
		if( ( 0 <= parseInt(str, 10)) && (parseInt(str, 10) < 10) ){
			return "0"+str;
		}else{
			return str;
		}
	};


	// ----------------------------------------------------------------------------------
	// ----------------------------------------------------------------------------------
	// -- Layout functions

	/*
	 * Set the back image of a element
	 */
	function setBackImage(elem, W, H) {
		if (elem) {
			var __id = elem.attr('my-bi');
			if (__id && __bckImg[__id]) {
				elem.attr('src', __bckImg[__id].src);
				var __rW = W / __bckImg[__id].w;
				var __rH = H / __bckImg[__id].h;
				if ((__bckImg[__id].fw) || (__rH > __rW)) {
					elem.attr('width', W);
					return parseInt(__bckImg[__id].tp * __rW);
				} else {
					elem.attr('height', H);
					if (__bckImg[__id].c) {
						var __nw = parseInt((W - (__bckImg[__id].w * __rH)) / 2);
						elem.css('left', __nw + "px");
					}
					return parseInt(__bckImg[__id].tp * __rH);
				}
			} else {
				console.log("[setBackImage] no definition for " + __id);
			}
		}
	}// End setBackImage

	/*
	 * Used to set the __bckImg array.
	 */
	__my.initBckImg = function(imgs) {
		if (__bckImg == null)
			__bckImg = imgs;
	};

	/*
	 * Used to set the __bckImg array.
	 */
	__my.initBack = function(bck) {
		if (bck == null)
			__idCurrentBack = bck;
	};

	/*
	 * Create or update a css width rule inside the <head> style defintion. clss :
	 * css class reference (ex: ".myclass") w : width to create or update in the
	 * class reference rules.
	 */
	__my.updateCSSRules = function(clss, w, upStyle) {
		var __targetRule = null, __notin = true;
		do {
			var __inCssRules = (__inSheetCSS.cssRules) ? __inSheetCSS.cssRules
					: __inSheetCSS.rules;
			for (i = 0; i < __inCssRules.length; i++) {
				if (__inCssRules[i].selectorText.toLowerCase() == clss) {
					__targetRule = __inCssRules[i];
					break;
				}
			}
			if (__targetRule) {
				__notin = false;
				__targetRule.style.width = w + "px";
			} else {
				if (__inSheetCSS.addRule) {
					__inSheetCSS.addRule(clss, null, 0);
				} else {
					__inSheetCSS.insertRule(clss + '{}', 0);
				}
			}
		} while (__notin);
		if (upStyle) {
			$(clss).css("width", w + "px")
		}
	}; // updateCSSRules

	// ----------------------------------------------------------------------------------
	// ----------------------------------------------------------------------------------
	// -- Dialog functions

	/*
	 * Display a simple dialog message box.
	 */
	__my.alert = function(message) {
		var __s = $('#my-simple-diag #my-diag-cont')[0];
		if (__s)
			__s.innerHTML = message;
		$.mobile.changePage("#my-simple-diag", "fade");
	};

	// ----------------------------------------------------------------------------------
	// ----------------------------------------------------------------------------------
	// -- Content functions
	function __changeAccount(e) {
		switch (e.currentTarget.name) {
		case "mail":
			__my.config.mail = e.currentTarget.value;
			break;
		case "push":
			__my.config.push = e.currentTarget.checked;
			break;
		case "loc":
			__my.config.loc = e.currentTarget.checked;
			break;
		}
		__my.saveConfig();
	}

	/*
	 * Funtion use to get the list content if there is an update of the content.
	 * This function will be overwrite if my_list.js is loaded that mean the
	 * current application contain page (see my_list.js getInitialContent()).
	 * Else (if this application doesn't use list) this function return true and
	 * do nothing.
	 */
	__my.getInitialContent = function() {
	}

	__my.updateList = function(page, idItem, url) {
		return true;
	}

	__my.updateAccount = function(evt, ui) {
		$.get(BASE_URL + '/__mUser.php').success(function(data) {
			__my.alert(data);
			// __I_create_dialog(data);
		})
	}

	__my.updateActivePage = function(page) {
		var __prev = null;
		$('.my_active').each(function() {
			$(this).removeClass('my_active');
			__prev = $(this).attr('id');
		});
		$(page).addClass('my_active');
		var __lnk = $("#lnk_acc", page);
		if (__lnk.length)
			__lnk.attr('href', 'javascript:myapp.clickBack("' + __prev + '");');
	}

	// ----------------------------------------------------------------------------------
	// ----------------------------------------------------------------------------------
	// -- Pager functions with iscroll

	// check if page require pull to refresh action
	/*
	 * Initialize event for pull 2 refresh.
	 * 
	 * @see my_list.__listPagerInit()
	 */
	__my.configurePullToRefresh = function(page, callback) {
		console.log("[configurePullToRefresh] enter in ...");
		__PullDivOffset = 0;
		var __tzone = $("#test_zone");
		if (__tzone.length) {
			$(__tzone).css("display", "block");
			$(__tzone).css("visibility", "hidden");
			var __tblock = $("#test_block", __tzone);
			$(__tblock).html(__my.pullNavBlock);
			var __tmppull = $("#pullUp", __tzone);
			__PullDivOffset = __tmppull[0].offsetHeight;
			// reset test_zone
			$(__tblock).html("");
			__tzone.css("display", "none");
			__tzone.css("visibility", "visible");
			__tmppull = null;
		}

		if (__PullDivOffset != 0) {
			__my.iscrollPullPage = 1;
			__my.iscrollParam = {
				p2rCallback : callback,
				scrollbarClass : 'myScrollbar',
				hScroll : false,
				vScroll : true,
				hScrollbar : false,
				vScrollbar : true,
				onRefresh : function() {
					
					if ((__my.iscrollPullDiv)&&(__my.iscrollPullDiv[0].className.match('loading'))) {
						__my.iscrollPullDiv[0].className = '';
						__my.iscrollPullDiv[0].querySelector('.pullUpLabel').innerHTML = MY_ERROR_MESSAGE[__my.setLang]["2100"];
					}
				},
				onScrollMove : function() {
					// change message
					if(__my.iscrollPullDiv){
						if (this.y < (this.maxScrollY - 50)
								&& !__my.iscrollPullDiv[0].className.match('flip')) {
							__my.iscrollPullDiv[0].className = 'flip';
							__my.iscrollPullDiv[0].querySelector('.pullUpLabel').innerHTML = MY_ERROR_MESSAGE[__my.setLang]["2101"];
							this.maxScrollY = this.maxScrollY;
						} else if (this.y > (this.maxScrollY + 5)
								&& __my.iscrollPullDiv[0].className.match('flip')) {
							__my.iscrollPullDiv[0].className = '';
							__my.iscrollPullDiv[0].querySelector('.pullUpLabel').innerHTML = MY_ERROR_MESSAGE[__my.setLang]["2100"];
							this.maxScrollY = __PullDivOffset;
						}
					}
				},
				onScrollEnd : function() {
					if ((__my.iscrollPullDiv)&&(__my.iscrollPullDiv[0].className.match('flip'))) {
						__my.iscrollPullDiv[0].className = 'loading';
						__my.iscrollPullDiv[0].querySelector('.pullUpLabel').innerHTML = MY_ERROR_MESSAGE[__my.setLang]["500"];
						if (callback) {
							var __fn = window[callback];
							__fn();
						} else {
							__my.defaultPullToRefreshAction(page);
						}
					}
				}
			};
		} else {
			console.log("[__configurePullToRefresh] unable to find height of pull2refresh console ...");
		}
	}// __configurePullToRefresh

	__my.disablePullToRefresh = function() {
		__my.iscrollParamSave = __my.iscrollParam;
		__my.iscrollParam = {
		    p2rCallback : "",
		    scrollbarClass : 'myScrollbar',
			hScroll : false,
			vScroll : true,
		    hScrollbar : false,
		    vScrollbar : true,
		    onRefresh : null,
		    onScrollMove : null,
		    onScrollEnd : null
		};
	}

	__my.enablePullToRefresh = function() {
		__my.iscrollParam = __my.iscrollParamSave
	}
	

	
	__my.resetPullToRefresh = function(){
		console.log("[resetPullToRefresh] enter in ...");
		if(__my.iscrollPullDiv != null){
			__my.iscrollParam = {
					p2rCallback : "",
					scrollbarClass : 'myScrollbar',
					hScroll : false,
					vScroll : true,
					hScrollbar : false,
					vScrollbar : true,
					onRefresh : null,
					onScrollMove : null,
					onScrollEnd : null
			};
			__my.iscrollPullDiv = null;
			__my.iscrollPullPage = 0;
		}
	}//end resetPullToRefresh

	__my.defaultPullToRefreshAction = function(page) {
		// launch update list on the current page
		console.log("[defaultPullToRefreshAction] enter in ... ("
				+ __my.iscrollPullPage + ")");
		// inc page for request ...
		__my.iscrollPullPage++;

		setTimeout(function() {
			if (__my.iscroll) {
				__my.iscroll.refresh();
			}
		}, 200);
	}// end __defaultPullToRefreshAction

	// ----------------------------------------------------------------------------------
	// ----------------------------------------------------------------------------------
	// -- Scroll function

	__my.scrollHeight = function(page) {
		var __wrapScroll = $("#" + page + " #wrapper");
		if (__wrapScroll.length) {
			// alert($(__wrapScroll).style.height)
		} else {
			return false;
		}
	}

	/*
	 * Function to update the iscroll and wrapper parameters.
	 */
	function __updateiScroll(bodyScroll, scrollID, widthScroll, heightScroll) {
		console.log("[__updateiScroll] set size (" + widthScroll + ":" + heightScroll + ")");
		if ((widthScroll != null) || (heightScroll != null)) {
			var __wrapper=$("#wrapper", bodyScroll),
			__wrapScroll;
			
			//IOS 7 fix
			if(__wrapper.length>1){
				__wrapScroll = $('#wrapper', 'div[aid='+$(bodyScroll).parent('div[aid]').attr('aid')+']')[0];
			}else{
				__wrapScroll = __wrapper[0];
			}

			if (__wrapScroll) {
				__setElemSize(__wrapScroll, widthScroll, heightScroll);
			} else {
				return false;
			}
		}

		if (__my.iscroll != null) {
			//var __ID = __my.iscroll.ID;
			__my.iscroll.destroy(false);
			//__my.iscroll = null;
			delete __my.iscroll;
			//console.log("Request destroy ... "+ __ID +":"+__my.iscroll+":"+__mainThis.myapp.iscroll);
		}

		// TODO : inutile pris en charge dans my_list.__getSingleListContent2()
		/*
		 * if(pager == true){ __my.pager.use = true; }else{ __my.pager =
		 * {"use":false, "idx":0, "nb":5, "page":"", "type":""}; }
		 */
		__my.iscroll = new iScroll(__wrapScroll, __my.iscrollParam);
		__my.iscrollWindow = {
			"w" : widthScroll,
			"h" : heightScroll
		};

		__wrapScroll = null;
		__scroller = null;
	}// end __updateiScroll

	// --------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------
	// Error management functions ...

	__my.ajax_error = function(err, textStatus, errorThrown){
		switch(textStatus){
			case "parsererror":
			case "timeout":
			case "abort":
			case "error":
			default:
			__I_create_dialog(MY_ERROR_MESSAGE[__my.setLang]["1000"]);
		}
	};

	// --------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------
	// Public methods

	/*
	 * Use to set the __options object. Not yet used ...
	 */
	__my.initOptions = function(opts) {
		if (__options == null)
			__options = opts;
	};

	__my.addLoadProcess = function(proc) {
		__loadProcess.push(proc);
	}

	// Execute process once page loading.
	__my.execLoadProcess = function() {
		// Remove previous cache.
		setTimeout(__my.refactorTmpCache, 200);
		setTimeout(__my.refactorCache, 200);

		// register action listener
		setTimeout(__my.bindAction, 100);

		// clean database and launch the rest of the load process
		setTimeout(__cleanDBImages, 100);
	}

	// Execute process once page loading.
	// @deprecated, replaced by flow management process !
	function __cleanDBImages() {
		__my.refactorCacheImage();
		// Refactor cache images.
		setTimeout(__contLoadProcess, 100);
	}

	function __contLoadProcess() {
		while (__loadProcess.length > 0) {
			var __proc = __loadProcess.pop();
			eval(__proc);
		}
	}

	/*
	 * Save user config
	 */
	__my.saveConfig = function() {
		if (__my.config != null) {
			// update geolocURL
			__my.config.pl_url = BASE_URL + "/_mGeo.php?"
					+ "u=" + __my.config.udid + "&d="
					+ __my.native_device;
			__I_db_save("user-config", $.toJSON(__my.config));
		}
	}

	/*
	 * Set __docLoad to tell doc loading is ended.
	 */
	__my.setdocLoad = function(load) {
		__docLoad = load;

		// for test only simulate an update of PIN and UDID
		if (__my.sim) {
			__my.updatePIN();
		}
	}

	// --------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------
	// Functions for backround Flow management RSS

	var __FlowPage = [];
	// tell that the end splash process must be release (else end splash process
	// will be blocked)
	__my.flow_end_splash = false;

	// Execute process once page loading.
	__my.preloadFlow = function() {
		console.log("[Flow] launch preload process.");
		var __proc = __FlowPage.pop();
		if(__proc){
			if ((!__my.flow_end_splash) && (__proc[1])) {
				__my.flow_end_splash = true;
			}
			eval(__proc[0]);
		}
		/*
			while (__FlowPage.length > 0) {
				var __proc = __FlowPage.pop();
				if ((!__my.flow_end_splash) && (__proc[1])) {
					__my.flow_end_splash = true;
				}
				eval(__proc[0]);
			}
		*/
	};

	/*
	 * @proc process to be execute as string
	 * @endsplash tell the related process must release the endsplash process.
	 */
	__my.addFlowPage = function(proc, endsplash) {
		endsplash = (endsplash == null) ? false : endsplash;
		var __proc;
		if (endsplash) {
			__my.forceEndSplash = false;
			__proc = [ proc, endsplash ];
			try{
				console.warn("[Flow] add flow with endsplash. (" + proc + ") - Warning : process with staticList doesn't manage forceEndSplash !");
			}catch(e){}
		} else{
			__proc = [ proc ];
			console.log("[Flow] add flow. (" + proc + ")");
		}
		// test si le process existe ...
		var __exist = false;
        for (var i=0 ; i < __FlowPage.length ; i++) {
        	__tmp = __FlowPage[i];
        	if(__tmp[0] === proc){
        		__exist = true;
        		break;
        	}
        }//end for ...
		if(!__exist) __FlowPage.push(__proc);
	}

	/*
	 * Process launch to terminate the background loading
	 */
	__my.FlowBackGroundEndSplash = function() {
		console.log("[Flow] Force End Splash ...");
		__my.flow_end_splash = false;
		__my.forceEndSplash = true;
		__my.endSplash();
	}
	
	__my.myEventEnd = {type:"evt_list_load"};
	
	$(__my.myEventEnd).bind("end_load", function(evt, name){
		var __proc = __FlowPage.pop();
		if(__proc){
			if ((!__my.flow_end_splash) && (__proc[1])) {
				__my.flow_end_splash = true;
			}
			eval(__proc[0]);
		}
	});
	
	// ----------------------------------------------------------------
	// useful function for back management

	/*
	 * Update the link of the back button.
	 */
	__my.updateBackLink = function(evt, ui) {
		var __prev_id = ui.prevPage[0].id;
		console.log("[updateBackLink] :" + __prev_id);
		if ((__prev_id != 'my-simple-diag') && (__prev_id != 'my-account')) {
			var __lnk = $("#lnk_acc", evt.currentTarget);
			__lnk.attr('href', 'javascript:myapp.clickBack("' + __prev_id + '");');
		}
	}

	__my.setBackLink = function(page, link, native_evt, backTransition) {
        var __lnk = $("#" + page + " #lnk_acc");
        if (__my.NATIVE && (native_evt != null)) {
            var __back_evt_name = native_evt['name'];
            var __back_evt_params = native_evt['params'];
            var __back_native_evt = __back_evt_name;
            for (var i=0 ; i < __back_evt_params.length ; i++) {
                __back_native_evt += ':' + __back_evt_params[i];
            }
			if(backTransition){
				__lnk.attr('href', 'javascript:__I_native_event("'+__back_native_evt+'");myapp.clickBack("' + page + '","'
                        + link + '", "'+backTransition+'");');
			}else{
             	__lnk.attr('href', 'javascript:__I_native_event("'+__back_native_evt+'");myapp.clickBack("' + page + '","'
                        + link + '");');
			}
        }
        else {
            if (link != null) {
				if(backTransition){
                	__lnk.attr('href', 'javascript:myapp.clickBack("' + page + '","'
                        + link + '", "'+backTransition+'");');
				}else{
					__lnk.attr('href', 'javascript:myapp.clickBack("' + page + '","'
                        + link + '");');
				}
                __lnk.attr('style', 'visibility:visible;');
            } else {
                __lnk.attr('style', 'visibility:hidden;');
            }
        }
	}

	/*
	 * Click Event on back button ...
	 */
	__my.clickBack = function(page, topage, backTransition) {
		backTransition=((backTransition==null) || (backTransition==undefined)) ? MY_DEFAULT_TRANSITION : backTransition;
		if (__my.NATIVE)
			__I_native_event('dismenu:popbackaction');
		$('#' + topage).live('pageshow', function(evt, ui) {
			$('#' + topage).die('pageshow');
			if (__my.NATIVE)
				__I_native_event('enmenu');
		});
		$('#' + page).trigger('pagebeforeback', []);
		$.mobile.changePage('#' + topage, backTransition, true);

		// EG - 24.07.12 Ajout evenement de changement de page sur click dans le menu. 
		if (__my.sim){
			if(topage === 'my-gallery') return;

			var __aid = $("#"+topage).attr('aid');
			var __static = $("#"+topage).attr('my-next');
			if((__static)&&(__static == 'static-list')){
				if(__aid) __my.content_changePage(__aid, 'static_menu');
			}else{
				if(__aid) __my.content_changePage(__aid, 'group_elem');
			}
		}

		//selectmenu
		if(myapp.NATIVE){
			var __i=0, __isMenuItem=false;
			for(var __x in __my.MENU){
				if(__my.MENU.hasOwnProperty(__x)){
					if(__my.MENU[__x].href === topage){
						__isMenuItem=true;
						break;
					}else{
						__i++;
					}
				}
			}

			if(__isMenuItem) __I_native_event("selectmenu:"+__i);
			__isMenuItem=__i=__x=null;
		}
	}

	// ----------------------------------------------------------------
	// cache management ...
	__my.cacheImage = {};

	__my.pushImage = function(id, content, w, h, hash) {
		if (content != null) {
			if (__I_db_exist("list-img")) {
				__my.cacheImage = $.evalJSON(__I_db_read("list-img"));
			} else {
				__my.cacheImage = {};
			}

			var __imID;
			if ((w == 0) && (h == 0))
				__imID = id;
			else
				__imID = w + "_" + h + id;

			var __date = new Date();
			__my.cacheImage[__imID] = __date.getTime();
			var __tmp = $.toJSON(__my.cacheImage);
			__I_db_save("list-img", __tmp);

			__I_db_save(__imID, content);
			__I_db_save(__imID + "_s", $.toJSON({
				"w" : w,
				"h" : h,
				"hash" : "" + hash + ""
			}));
			__date = null;
		}
	}// end __my.pushImage

	// get a stored image in the database
	__my.popImage = function(id, w, h, onlyhash) {
		var __imID;
		if ((w == 0) && (h == 0))
			__imID = id;
		else
			__imID = w + "_" + h + id;

		if (__I_db_exist(__imID)) {
			onlyhash = (onlyhash == null) ? false : onlyhash;
			try {
				var __res = {};
				var __size = $.evalJSON(__I_db_read(__imID + "_s"));
				if (!onlyhash) {
					__res["c"] = __I_db_read(__imID);
					__res["w"] = __size.w;
					__res["h"] = __size.h;
				}
				__res["hash"] = __size.hash;

				return __res;
			} catch (err) {
				console.log("ERR [__my.popImage]" + err.message);
			}
		} else
			return null;
	}// end __my.popImage

	// update the cache of images.
	__my.refactorCacheImage = function() {
		if (__I_db_exist("list-img")) {
			try {
				__my.cacheImage = $.evalJSON(__I_db_read("list-img"));
				var __date = (new Date()).getTime()
						- (__my.imgCacheDuration * DAY_MS);
				for (id in __my.cacheImage) {
					if (__my.cacheImage[id] < __date) {
						__I_db_delete(id);
						__I_db_delete(id + "_s");
						delete __my.cacheImage[id];
					}
				}
			} catch (err) {
				console.log("ERR [__my.refactorCacheImage]" + err.message);
			}

			if (COUNTPROP(__my.cacheImage) == 0) {
				__I_db_delete("list-img");
			}
		}
	}// end __my.refactorCacheImage

	// ----------------------------------------------------------------
	// useful function for Image

	/*
	 * 
	 * max_size={"zoom":1, "w":90, "h":90, "bk":0} Zoom = 0, nothing happens
	 * when click on the image Zoom = 1, click on the image open the
	 * corresponding album
	 */
	__my.reloadImage = function(img){
		var __par = $(img).attr('max_size'),
		__zoom = false;
		if (__par) {
			try {
				__par = $.evalJSON(__par);
				if (__par.zoom)
					__zoom = (__par.zoom);
			} catch (err) {
				console.log("ERR [__my.reloadImage]" + err.message);
			}
		}
		if (__zoom) {
			// console.log('TODO : Zoomable feature ...');
			var __agr = $(img).attr('id'), __cat;
			try {
				if( (__zoom == 1) || (__zoom == "alb") ){
					var pos = __agr.lastIndexOf('.', __agr.length);
					__agr = __agr.substring(0, pos);
					__cat = MY_DIAP_PREFIX + __agr;

					if (__my.sim){
						try{
							console.log("Chargement de l'album :" + __cat);
						}catch(e){}
					} else {
						if (__my.NATIVE)
						__I_native_event('dismenu');
						if (!__my.NATIVE)
						$.mobile.pageLoading();
						window.location = "myapp://gallery:alb="
						+ encodeURIComponent(__cat);
					}
				}else if(__zoom == "img"){
					__cat = __agr;

					if (__my.sim) {
						console.log("Chargement de l'image :" + __cat);
					} else {
						if (__my.NATIVE)
						__I_native_event('dismenu');
						if (!__my.NATIVE)
						$.mobile.pageLoading();
						window.location = "myapp://gallery:img="
						+ encodeURIComponent(__cat);
					}
				}
			} catch (err) {
				console.log("ERR [__my.reloadImage] Error on diap :"
						+ err.message);
				if (!__my.NATIVE)
					$.mobile.pageLoading(true);
				__I_create_dialog(MY_ERROR_MESSAGE[__my.setLang]["2000"],
						"__CB_reloadImage", "err");
				// alert(MY_ERROR_MESSAGE[__my.setLang]["2000"]);
				// if(__my.NATIVE) __I_native_event('enmenu');
			}
		} else {
			__my.backReloadImage(img, __par);
		}
	};

	// ----------------------------------------------------------------
	// useful function for Menu Bar
	/*
	 * Update the icon of a menu.
	 * 
	 * @deprecated not yet use.
	 */
	__my.updateMenuItem = function(evt) {
		var __prevImg = $('#m_img_on');
		if (__prevImg.length != 0) {
			var __src = __prevImg.attr('src');
			if (__src.match('on')) {
				__src = __src.replace(/on/, 'off');
			}
			__prevImg.attr('src', __src);
			__prevImg.attr('id', "m_img_off");
		}

		var __img = $(".m-menu-icon", evt.currentTarget);
		__src = __img.attr('src');
		if (__src.match('off')) {
			__src = __src.replace(/off/, 'on');
		}
		__img.attr('src', __src);
		__img.attr('id', "m_img_on");
		__src = __prevImg = __img = null;
	}
	
	/*
	 * Manage custom event on button 
	 * Allow click on Menu not related to a page
	 */
	var __myEventClickExternal = {type:"event_menu", own:window};
	 
	$(__myEventClickExternal).bind("native_menu", function(evt, name){
		if(window['__myCustomMenuEvent']){
			var __fn = window['__myCustomMenuEvent'];
			__fn(name);
		}
	});
	 
	/*
	 * Click Event on menu ...
	 */
	__my.clickMenu = function(topage, effect) {

		if (__my.sim){
			if (__my.sim_clickMenu()) return;
			// EG - 26.07.12 click sur le bouton geolocaliser.
			if (topage === 'my-natif-geoloc') topage = 'my-geoloc';  
		}

		if(topage.startsWith("__my_menu")){
			$(__myEventClickExternal).trigger("native_menu", [topage]);
			return;
		}

		var __change = true;
		var __cur = $(".my-page-active");
		var __curPage = $(__cur).attr('id');
		// force to quit the favorite menu.
		__my.isFav = false;

		$('*[active="1"]').each(function() {
			if ($(this).attr('id') == topage) {
				__change = false;
			}
		});

		// check for shortcutMenu
		console.log("[clickMenu] to page :" + topage + "(" + __change + ":" + __curPage + ")");
		if ((__change) && (__my.myMenu && __my.myMenu[topage])) {
			if ((__my.myMenu[topage].nb) && (__my.myMenu[topage].nb == 1)) {
				var __idx = -1;
				for ( var i in __my.myMenu[topage]) {
					// get the first elem with en=true parameters
					if (__my.myMenu[topage][i]["en"] != undefined) {
						if (__my.myMenu[topage][i]["en"] === true) {
							__idx = i;
							break
						}
					} else {
						__idx = i;
						break
					}
				}// end for

				if (__idx !== -1) {
					// get the destination page
					__change = !(__my.myMenu[topage][__idx]["to"] == __curPage);
				}
			}
		}

		// var __cur = $(".my_active");
		/*
		 * if(__cur.length){ for ( var j = 0; j < __cur.length ; j++ ) { var
		 * __id = $(__cur).attr('id'); if(__id == topage){ __change = false;
		 * break; } } }
		 */
		console.log("[clickMenu] to page :" + topage + "(" + __change + ")");
		if (__change) {
			
			$('#' + topage).live('pageshow', function(evt, ui) {
				$('#' + topage).die('pageshow');
				if (__my.NATIVE) __I_native_event('pageshow');
			});

			if (__curPage) $('#' + __curPage).trigger('changefrommenu', []);
			$('#' + topage).trigger('pagetobedisplay', []);
			// sim
			if (__my.sim) {
				// EG - 24.07.12 Ajout evenement de changement de page sur click dans le menu. 
				var __aid = $("#"+topage).attr('aid');
				var __static = $("#"+topage).attr('my-next');
				if((__static)&&(__static == 'static-list')){
					if(__aid) __my.content_changePage(__aid, 'static_menu');
				}else{
					if(__aid) __my.content_changePage(__aid, 'group');
				}
			}
		} else {
			$('#' + topage).trigger('reclick', null);
		}

		//selectmenu : JB - 2012.12.11
		if(myapp.NATIVE){
			var __i=0, __isMenuItem=false;
			for(var __x in __my.MENU){
				if(__my.MENU.hasOwnProperty(__x)){
					if(__my.MENU[__x].href === topage){
						__isMenuItem=true;
						break;
					}else{
						__i++;
					}
				}
			}

			if(__isMenuItem) __I_native_event("selectmenu:"+__i);
			__isMenuItem=__i=__x=null;
		}
	}

	/*
	 * Create all the menu bar (for simulator)
	 */
	__my.createMenu = function(page, seq, selected, evt) {
		if (__my.NATIVE)
			return;

		console.log("[SIM - createMenu : "+page+"] ...");
		var __footerBar = $('#' + page + ' #my-footer');
		if (__footerBar.css('display') == 'none') {
			var __mItem = $('#my-menu-item');
			var __footWrap = $('.menu-bar-row', __footerBar);

			var __p = parseInt(100 / seq.length), __pc = 0;

			for ( var j = 0; j < seq.length - 1; j++) {
				if (__my.MENU[seq[j]]) {
					__pc = __pc + __p;
					$('.menu-bar-col', __mItem).attr("id", seq[j]);

					if (selected != seq[j]) {
						$('.menu-bar-col', __mItem).attr("sel", "0");
						$('a', __mItem).attr(
								'href',
								'javascript:myapp.clickMenu("'
										+ __my.MENU[seq[j]].href + '");');
						// $('a', __mItem).attr('href', __my.MENU[seq[j]].href);
						$("#m-menu-label").removeClass('m-menu-label-on');
						$('.m-menu-icon', __mItem).attr('src',
								__my.MENU[seq[j]].img);
					} else {
						$('.menu-bar-col', __mItem).attr("sel", "1");
						if (__my.menuReload)
							$('a', __mItem).attr(
									'href',
									'javascript:myapp.clickMenu("'
											+ __my.MENU[seq[j]].href + '");');
						else
							$('a', __mItem).attr('href', "#");
						$("#m-menu-label").addClass('m-menu-label-on');
						$('.m-menu-icon', __mItem).attr('src',
								__my.MENU[seq[j]].imgon);
					}

					$('.m-menu-icon', __mItem).css('height',
							__relParam[__my.screenType].mico);
					$('#m-menu-label', __mItem).html(
							__my.LANG[__my.setLang][__my.MENU[seq[j]].label]);
					$('.menu-bar-col', __mItem).css('width', __p + '%');
					__footWrap.append($(__mItem).html());
				}
			}// end for

			if (__my.MENU[seq[j]]) {
				$('.menu-bar-col', __mItem).attr("id", seq[j]);

				if (selected != seq[j]) {
					$('.menu-bar-col', __mItem).attr("sel", "0");
					$('a', __mItem).attr(
							'href',
							'javascript:myapp.clickMenu("'
									+ __my.MENU[seq[j]].href + '");');
					$("#m-menu-label").removeClass('m-menu-label-on');
					$('.m-menu-icon', __mItem).attr('src',
							__my.MENU[seq[j]].img);
				} else {
					$('.menu-bar-col', __mItem).attr("sel", "1");
					if (__my.menuReload)
						$('a', __mItem).attr(
								'href',
								'javascript:myapp.clickMenu("'
										+ __my.MENU[seq[j]].href + '");');
					else
						$('a', __mItem).attr('href', "#");
					$("#m-menu-label").addClass('m-menu-label-on');
					$('.m-menu-icon', __mItem).attr('src',
							__my.MENU[seq[j]].imgon);
				}

				$('.m-menu-icon', __mItem).css('height',
						__relParam[__my.screenType].mico);
				$('#m-menu-label', __mItem).html(
						__my.LANG[__my.setLang][__my.MENU[seq[j]].label]);
				$('.menu-bar-col', __mItem).css('width', (100 - __pc) + '%');
				__footWrap.append($(__mItem).html());
			}

			__footerBar.css('display', 'block');
			__mItem = __footerWrap = null;
		}
		__footerBar = null;
	}

	//for simulator
	__my.refreshMenuLabels = function(){
		$('div.my-footer div.menu-bar-col').each(function(){
			$('#m-menu-label', this).html(__my.LANG[__my.setLang][__my.MENU[$(this).attr('id')].label]);
		});
	};

	//for simulator
	__my.selectMenu = function(sel) {
		if (__my.NATIVE)
			return;

		var __cols = $('.menu-bar-col', __sel);
		if (__cols.length) {
			for ( var j = 0; j < __cols.length; j++) {
				var __id = $(__cols[j]).attr('id');
				var __sel = $('.menu-bar-row #' + __id);
				if (__id != sel) {
					$('.menu-bar-col', __sel).attr("sel", "0");
					$('a', __sel).attr(
							'href',
							'javascript:myapp.clickMenu("'
									+ __my.MENU[__id].href + '");');
					$("#m-menu-label").removeClass('m-menu-label-on');
					$('.m-menu-icon', __sel).attr('src', __my.MENU[__id].img);
				} else {
					$('.menu-bar-col', __sel).attr("sel", "1");
					if (__my.menuReload)
						$('a', __sel).attr(
								'href',
								'javascript:myapp.clickMenu("'
										+ __my.MENU[__id].href + '");');
					else
						$('a', __sel).attr('href', "#");
					$("#m-menu-label").addClass('m-menu-label-on');
					$('.m-menu-icon', __sel).attr('src', __my.MENU[__id].imgon);
				}
			}
		}
	}
	
	__my.detectMenu = function(topage) {
		var __res = [];
		var __elem = $(topage+" #my-footer .menu-bar-row").children();
		if(__elem.length){
			for ( var k = 0; k < __elem.length; k++) {
				var __id = $(__elem[k]).attr('id');
				__res.push(__id);
			}
		}else{
			__res = ["m1", "m2", "m3", "m4", "m5"];
		}
		return __res;
	}

	// ----------------------------------------------------------------
	// Progress bar useful function
	var __inter = null;
	var __count = 0;

	__my.initProgress = function() {
		__inter = null;
		__count = 0;
	}

	__my.updateProgress = function(percent) {
		if (__my.NATIVE) {
			__I_native_event('progress:' + percent);
			/*
			 * iFrame = document.createElement("IFRAME");
			 * iFrame.setAttribute("src", 'myapp://progress:'+percent);
			 * document.body.appendChild(iFrame);
			 * iFrame.parentNode.removeChild(iFrame); iFrame = null;
			 */
		} else {
			// var inter = null;
			clearInterval(__inter);
			function run_progress() {
				__count++;
				$('#progress_bar').css('width', __count + "%");
				if (__count == percent) {
					clearInterval(__inter);
				}
			}
			__inter = setInterval(run_progress, 10);
		}
	};

	__my.endProgress = function() {
		clearInterval(__inter);
		$('#progress_bar').css('width', "100%");
		__my.initProgress();
	};

	// ----------------------------------------------------------------
	// 

	/*
	 * Click action on a static list previously created with myapp.staticList. (
	 * To be used in association with static menu : myapp.myMenu.) @id id of the
	 * related menu (param "id" of the menu item). see <my_params><menu idx>
	 * @page id of the item menu in the object list. @disBack disable Back
	 * button of the destination page (see "to" param of the menu item).
	 * 
	 * Remark : id and page can be different, but generaly they have the same
	 * value. Example : { "1201":{"id":"1201", "en":false, "sim_aid" : "4" ,"to" :
	 * "_120", "loop":false, "label":{"fr":{"0" : "Neuf"}},"img":{}} }
	 * 
	 */
	__my.advancedClick = function(id, page, Change, useTitle, disBack) {
		var __to, __id, __aid;
		change=( (Change==null) || (Change==undefined) )?MY_DEF_NO_TRANS:Change;
		isTitle = (useTitle == null) ? true : useTitle;
		disback = (disBack == null) ? false : disBack;

		for ( var i in __my.myMenu[page]) {
			if (__my.myMenu[page][i]["id"] == id) {
				__to = __my.myMenu[page][i]["to"];
				__aid = __my.myMenu[page][i]["sim_aid"];
				__id = i;
				bk = __my.myMenu[page][i]["bk"];
				bk = (bk == null) ? false : bk;
				break;
			}
		}

		if (__to) {
			// disable back button of the destination page.
			if (disback) {
				__my.setBackLink(__to, null);
			} else {
				myapp.setBackLink(__to, page);
			}

			// case of video agregation
			if (__to == "my-video") {
				// 10000 = videos
				var __url = "/_mCont_3.php?list=1&it=10000";
				__my.updateNativePage(__url, __to);
				if (!__my.sim) return;
			} else if (__to == "my-gallery") {
				// case of gallery
				if (! __my.sim) {
					window.location = "myapp://gallery";
					return;
				}
			} else if (__to == "my-account") {
				// case of account
				if (! __my.sim) {
					window.location = "myapp://my-account";
					return;
				}
			}	else if (__to == "my-natif-geoloc") {
				// case of account
				if (! __my.sim) {
					window.location = "myapp://geoloc";
					return;
				}
			}

			var __type = $('#' + __to).attr('my-role');

			var __cont = $('#' + __to).attr('my-content');
			if ((__cont) && (__cont == "local")) {
				// redirect to a local content page.
				$('#' + __to).live('pageshow', function(evt, ui) {
					$('#' + __to).die('pageshow');
					if (__my.NATIVE)
						__I_native_event('enmenu');
				});
				if (__my.NATIVE)
					__I_native_event('dismenu');
				$.mobile.changePage("#" + __to, MY_DEFAULT_TRANSITION, false);
			} else {
				// redirect to an extern content page.

				// register the id as the current agregation.
				__my.currentAgr = id;
				var __title = null, __url;

				if (isTitle) {
					try{
						__title = __my.myMenu[page][__id]["label"][__my.config.lang][0];
					}catch(e){
						__title = __my.currentTitle;
					}
				}

				if (__type == "page") {
					//url override
					if(__my.myMenu[page][__id].hasOwnProperty('urlOverride')){
						__url = __my.myMenu[page][__id].urlOverride;
					}else{
						__url = "/_mCont_3.php?page=1&it=" + id;
					}

					//change = (change == MY_DEF_NO_TRANS) ? false : change;
					__my.updatePage(__to, __url, __title, change, id);
				} else if (__type == "listw") {
					var __favFilter = "";

					if (__my.isFav) {
						__favFilter = __getFavFilter(id);
						if (__favFilter != "")
							__favFilter = "&ffav=" + __favFilter;
					}

					if(__my.myMenu[page][__id].hasOwnProperty('urlOverride')){
						__url = __my.myMenu[page][__id].urlOverride;
					}else{
						if (bk) __url = "/_mCont_3.php?list=1&bk=1&it=" + id + __favFilter;
						else __url = "/_mCont_3.php?list=1&it=" + id + __favFilter;
					}

					// test if __to is a static-list
					if (__my.myMenu[__to]) {
						$.mobile.changePage("#" + __to, MY_DEF_NO_TRANS, false);
					} else {
						__my.updateList2(__to, __url, __title, change, false, true, false, id);
					}
				}
			}
			
			// EG - 24.07.12 Ajout evenement de changement de page sur click dans le menu. 
			if (__my.sim) __my.content_changePage(__aid,'group_elem');
		} else {
			console.log("[advancedClick] to not found for id:" + id + " ("
					+ page + ") !");
		}
	};

	/*
	 * use to shortcut the static menu in case of only one item is enabled.
	 * Avoid displaying intermediary menu with only one item in the menu list.
	 */
	__my.shortcutMenu = function(page) {
		if (__my.myMenu[page].nb) {
			if (__my.myMenu[page].nb == 1) {
				var __idx = -1;
				for ( var i in __my.myMenu[page]) {
					// get the first elem with en=true parameters
					if (__my.myMenu[page][i]["en"] != undefined) {
						if (__my.myMenu[page][i]["en"] === true) {
							__idx = i;
							break
						}
					} else {
						__idx = i;
						break
					}
				}// end for
				if (__idx !== -1) {
					// get the destination page
					return __my.myMenu[page][__idx]["id"];
				} else
					return null;
			} else
				return null;
		} else
			return null;
	}// end shortcutMenu

	// ----------------------------------------------------------------
	// External CSS adding.

	__my.addCSSRules = function(url) {
		var __find = false;
		var patt1 = new RegExp(url, 'gi');
		var __allscript = document.getElementsByTagName("link");
		for ( var k = 0; k < __allscript.length; k++) {
			__item = __allscript[k];
			if (__item.href.match(patt1)) {
				__find = true;
				break;
			}
		}
		if (!__find) {
			var headID = document.getElementsByTagName("head")[0];
			var cssNode = document.createElement('link');
			cssNode.type = 'text/css';
			cssNode.rel = 'stylesheet';
			cssNode.href = url;
			headID.appendChild(cssNode);
		}
	};
	
	function __addHeadStyle(ids, content){
		var __find = false;
		var __item = null;
		var __allscript = document.getElementsByTagName("style");
		for ( var k = 0; k < __allscript.length; k++) {
			__item = __allscript[k];
			if (__item.id == ids) {
				__find = true;
				break;
			}
		}

		if (__find) {
			__item.innerText = "";			
			__item.innerText = content;			
		}else{
			var headID = document.getElementsByTagName("head")[0];
			var cssNode = document.createElement('style');
			cssNode.type = 'text/css';
			cssNode.id = ids;
			cssNode.innerText = content;
			headID.appendChild(cssNode);
		}
	}

	__my.loadStoreCSSRules = function(url, cssname) {
		/*
		 * $.ajax({ url:"http://localhost/mob/fidomes/styles/test.css",
		 * success:function(data){ $("<style></style>").appendTo("head").html(data); } })
		 */
		var __style = __I_db_read("__udef_css");
		if(__style != null){
			// load css from localstorage (cssname)
			__addHeadStyle("__cs", __style);
		}
		__style == null;
		
		$.ajax({
			url : url
		}).success(function(data) {
			// ajout du nouveau
			__addHeadStyle("__cs", data);
			// delete previous localstorage css
			__I_db_delete("__udef_css");
			// store current css in the localstorage in cssname.
			__I_db_save("__udef_css", data);
		}).error(function(err) {
			console.log("[loadStoreCSSRules] unable to find custom CSS ("+err.statusText+") ...")
		});
	};

	// ----------------------------------------------------------------
	// External JS link.
	__my.addJSLink = function(src) {

		var __find = false;
		var patt1 = new RegExp(src, 'gi');
		var __allscript = document.getElementsByTagName("script");
		for ( var k = 0; k < __allscript.length; k++) {
			__item = __allscript[k];
			if (__item.src.match(patt1)) {
				__find = true;
				break;
			}
		}

		if (!__find) {
			// check if src exist.
			var headID = document.getElementsByTagName("head")[0];
			var jsNode = document.createElement('script');
			jsNode.type = 'text/javascript';
			jsNode.src = src;
			headID.appendChild(jsNode);
		}

	};

	// ----------------------------------------------------------------
	// Splash useful function.

	__my.configSplash = function() {

		if (__my.NATIVE)
			return true;

		var __s = $("#my-splash"), __splash;
		if (__s && __s[0]) {
			__splash = __s[0];
			__splash.style.width = __my.W;
			__splash.style.height = __my.H;

			// Get the background image of the splash screen.
			// Image link is stored in __bckImg[]
			// index is given by the "my-bi" attribut in the <img> HTML
			// definition
			var __spshImg = $("#my-back-img", __s);
			// Evaluate
			var __spos = setBackImage(__spshImg, __my.W, __my.H);
			if (__spos != 0)
				$("#load_wrap", __s).css('top', __spos + 'px');
			__spshImg = __s = __splash = null;
		}
	};

	/*
	 * Init the splash screen. call : just after the loading of the
	 * id="my-splash" block in the HTML definition (see. index.html).
	 */
	__my.initSplash = function(load_txt) {
		// Initialization and resizing of the splash if it exist.
		console.log("[initSplash] Enter ...");

		__my.updateProgress(0);

		if (!__my.NATIVE) {
			var __splash = $("#my-splash");
			if (__splash.length) {
				if (load_txt) {
					// depending on the default lang display the correct
					// "loading" message.
					var __s = $("#my-splash .loading")[0];
					if (__s) {
						__s.innerHTML = __my.LANG[__my.setLang][load_txt];
					}
					__s = null;
				}
				// set splash to visible now, resizing is finished.
				__splash.css('visibility', 'visible');
			}
		}

		__splash = null;

		// TODO : check and load the stored data.
		if (typeof __my.storedInitialContent != 'function') {
			__my.getInitialContent();
		}

		__my.updateProgress(20);

		// TODO : init the properties with the stored configuration.

		// add touchmove Event on the document to avoid problem with iScroll.
		// document.addEventListener('touchmove', function (e) {
		// e.preventDefault(); }, false);
		$('#scroller').bind('touchmove', function(e) {
			e.preventDefault();
		});

		__my.updateProgress(30);
		__splashOk = true;
		if (!__my.splash_auto_end)
			__my.endSplash();

	};// End initSplash

	__my.forceEndSplash = true;

	
	/*
	 * Function to ensure the transition between splash (native) and first page to display.
	 * by default we display the "my-home" page.
	 * 
	 * REMARK : selection of page to display can customized by implement the "__myEndSplashCustom" function  
	 */
	__my.endSplash = function() {
		if (__splashOk && __docLoad && __my.forceEndSplash) {
			console.log("[endSplash] finalization ...");
			// intialize the rest of the page
			__my.updateProgress(40);

			// intialize the rest of the page
			__my.initPages();
			__my.updateProgress(60);

			if (!__my.NATIVE)
				__I_initGPS();
			__my.updateProgress(60);

			// Register the main event.
			__my.registerEvent();
			__my.updateProgress(80);
            
			console.log("[endSplash] 80 ...");

			// execute background process.
			__my.execLoadProcess();

			// add a delay (1.5 sec.) before close the splash screen
			if (__my.NATIVE) {
				if(__my.existFunc("__myEndSplashCustom")){
					var __fn = window['__myEndSplashCustom'];
					__fn();
					$("#my-splash").css('visibility', 'hidden');
				}else{
					$.mobile.changePage("#my-home", MY_DEF_NO_TRANS, false);
					$("#my-splash").css('visibility', 'hidden');
				}	
				// finish the progress bar.
				if (typeof __my.storedInitialContent == 'function') {
					__my.storedInitialContent();
				}
				__my.updateProgress(100);
				setTimeout(__finish_launch_natif, 1500);
			} else {
				setTimeout(__finish_launch, 500);
			}
		} else {
			try{
				console.warn("[endSplash] Unable to start endSplash (" + __splashOk + ":" + __docLoad + ":" + __my.forceEndSplash + ")\n- Verify that you enter well in \"[endSplash] finalization ...\" after this log.\n- Verify your myapp.addFlowPage with endsplash=true!");
			}catch(e){}
		}
	};// End initSplash endSplash

	function __finish_launch() {
		// finish the progress bar.
		if (typeof __my.storedInitialContent == 'function') {
			__my.storedInitialContent();
		}
		__my.endProgress();
		// launch com to server to check for message
		setTimeout(__launch_serverMsg, 1000);
		// slapsh is finished, now display the main page
		if(__my.existFunc("__myEndSplashCustom")){
			var __fn = window['__myEndSplashCustom'];
			__fn();
			$("#my-splash").css('visibility', 'hidden');
		}else{
			$.mobile.changePage("#my-home", "fade");
			$("#my-splash").css('visibility', 'hidden');
		}
		$(document).trigger("endSplash").unbind("endSplash");
	}

	function __finish_launch_natif() {
		// slapsh is finished, now display the main page
		if (__my.NATIVE) {
			// launch com to server to check for message
			setTimeout(__launch_serverMsg, 1000);
			__I_native_event('end_splash:' + __my.nat_end_splash);
			// get POI
			__my.getPOI();
		}
		console.log("[end splash] Loc :" + __my.config.loc);
	}

	// Check for server message once finish launch (__finish_launch) terminated
	function __launch_serverMsg() {
		__my.checkForMessage();
	}

	/*
	 * Init the splash screen. call : once window loading finished (see.
	 * index.html).
	 */
	__my.initPages = function() {
		var __acc = $('#account_form');
		if (__acc.length) {
			// set userconfig panel.
			$('#account_form #my-acc-mail')[0].value = __my.config.mail;
			$('#account_form #my-acc-push')[0].checked = __my.config.push;
			$('#account_form #my-acc-loc')[0].checked = __my.config.loc;
		}
		// initialize the page label with current lang.
		__changeLang(__my.config.lang);

	};// end initPages

	// ----------------------------------------------------------------
	// Event function

	__my.hasEvent = function(elem, evt) {
		var __prevEvent = $(elem).data("events");
		if (__prevEvent == undefined) {
			return false;
		} else {
			if (__prevEvent[evt] == undefined) {
				return false;
			} else {
				return true;
			}
		}
	}

	/*
	 * Register all the event. call : once window loading finished (see.
	 * index.html).
	 */

	__my.registerEvent = function() {
		console.log(" ... Register my-scroll event !");

		// Event raise, once a page loaded just before show it in order to
		// evaluate the header, body, footer height.
		// Use also to set the iscroll of the page.
		
		$('[my-scroll="body"]').live('pageloaded', __my.updatebodyScroll);
		$('[my-scroll="picture"]').live('pageloaded', {"T" : "picture"}, __my.updatebodyScroll);

		// Event to set the previous page link of the simple dialog, allowing
		// the go back to calling page.
		// $('#my-simple-diag').live('pageshow', __my.updateBackLink);
		// loading of the my-loc page
		// $('#my-loc').live('pageloaded', __showGoogleMap).live('pageshow',__my.updateBackLink);
		// $('#account_form input').change(__changeAccount);
		
	};// End registerEvent

	__my.updatebodyScroll = function(evt) {
		console.log("[UpdatebodyScroll] for page");
		var __isPicture = false;
		if (evt.data) {
			if (evt.data.T == "picture") {
				// console.log("[UpdatebodyScroll] TYPE picture for page : " +
				// $(evt.currentTarget).attr('id'));
				__my.iscrollParam.hScrollbar = true;
				__my.iscrollParam.hScroll = true;
				__isPicture = true;
				var __elPict = $(evt.currentTarget).attr('my-picture');
				if (__elPict ? (__elPict == 'zoomable') : false) {
					__my.iscrollParam.zoom = true;
					__my.iscrollParam.wheelAction = 'zoom';
					__my.iscrollParam.onZoomEnd = scrollZoom;
					__my.iscrollParam.zoomMin = 0.5;
					__my.iscrollParam.zoomMax = 1;
				} else {
					__my.iscrollParam.zoom = false;
					__my.iscrollParam.wheelAction = 'scroll';
					__my.iscrollParam.onZoomEnd = null;
					__my.iscrollParam.zoomMin = 1;
					__my.iscrollParam.zoomMax = 4;
				}
			}
		} else {
			console.log("[UpdatebodyScroll] for page : "
					+ $(evt.currentTarget).attr('id'));
			__my.iscrollParam.hScrollbar = false;
			__my.iscrollParam.zoom = false;
			__my.iscrollParam.wheelAction = 'scroll';
			__my.iscrollParam.onZoomEnd = null;
			__my.iscrollParam.zoomMin = 1;
			__my.iscrollParam.zoomMax = 4;
		}
		
		__updatebodyScroll(evt.currentTarget, __isPicture);
	};

	__my.updatebodyScroll_Active = function() {
		console.log("[UpdatebodyScroll] for active");
		var __cur = $('*[active="1"]');
		if(__cur.length){
			try{
				if( __cur[0].id === "my-splash") return;
			}catch(e){
				return;
			}
			__my.iscrollParam.hScrollbar = false;
			__my.iscrollParam.zoom = false;
			__my.iscrollParam.wheelAction = 'scroll';
			__my.iscrollParam.onZoomEnd = null;
			__my.iscrollParam.zoomMin = 1;
			__my.iscrollParam.zoomMax = 4;
			
			__updatebodyScroll(__cur[0], false);
		}
	}
	
	/*
	 * Call once page with my-scroll='body' is loaded, my-scroll='picture'
	 */
	function __updatebodyScroll(elem, __isPicture) {
		// check if we need to configure a "pull to refresh" action
		var __tg = elem, __offHH, __offFixH=0, __offFH, __bodPad, __tmp,
		__bodyRef = $("#my-body", __tg),
		__bodyScroll = __bodyRef[0],
		__conf = $(__tg).attr("my-conf"), __that;

		__offHH = ((__tmp = $("#my-header", __tg))[0]) ? __tmp[0].offsetHeight
				: 0;
		/*__offFixH = ((__tmp = $("#fixed_head", __tg))[0]) ? __tmp[0].offsetHeight
				: 0;*/
		$("#fixed_head, div.fixed_head", __tg).each(function(e){
			__that=$(this);
			__offFixH+=__that[0] ? __that[0].offsetHeight : 0;
		});
		__that=null;
		__offFH = ((__tmp = $("#my-footer", __tg))[0]) ? __tmp[0].offsetHeight
				: 0;
		
		if(__offHH !== 0){
			if(__my.sim && __my.simCfg.blockHeadEvt){
				// update header to block event in case of simulator.
				var __fH = $("#my-header", __tg);
				var __cDiv = '<div class="block_event" style="position:absolute; z-index:1000; width:100%;height:'+__offHH+'px;"></div>';
				var __blck = $(".block_event", __tg);
				if(__blck.length == 0){
					$(".headerTable", __fH).prepend(__cDiv);
				}
			}
		}

		if(__offFixH !== 0){
			if(__my.sim && __my.simCfg.blockFixHeadEvt){
				// update fixedHead blocker in case of simulator.
				var __fH = $("#fixed_head", __tg);
				var __cDiv = '<div class="block_event" style="position:absolute; z-index:1000; width:100%;height:'+__offHH+'px;"></div>';
				var __blck = $(".block_event", __tg);
				if(__blck.length == 0){
					$(__fH).prepend(__cDiv);
				}
			}
		}

		__offSM = 0;
		var __SM = $("#slidedownmenu", __tg);
		if (__SM.length) {
			// __offSM = parseInt($(__SM).attr('curHeight'));
			__offSM = ((__tmp = $("#slidedownmenu .handle", __tg))[0]) ? __tmp[0].offsetHeight
					: 0;
			console.log("[UpdatebodyScroll] slide menu : " + __offSM);
		}

		// Eveluation of the padding on body.
		__bodPad = __my.extractFirstNums(__bodyRef.css("paddingTop"))
				+ __my.extractFirstNums(__bodyRef.css("paddingBottom"));

		// calculation of the body height.
		//var __bodyH = __tg.offsetHeight - __offHH - __offFH - __bodPad - __offSM;
		var __bodyH = __my.H - __offHH - __offFH - __bodPad - __offSM;
		try{
			/*if (__isPicture) {
				__setElemSize(__bodyScroll, __bodyScroll.offsetWidth, __bodyH);
			} else {
				__setElemSize(__bodyScroll, __bodyScroll.offsetWidth, __bodyH);
			}*/
			if (__isPicture) {
				__setElemSize(__bodyScroll, __my.W, __bodyH);
			} else {
				__setElemSize(__bodyScroll, __my.W, __bodyH);
			}
		}catch(e){
			console.error(e);
		}

		// initialize the home page background if necessary.
		var __himg = $("#my-back-img", __bodyRef);
		if (__himg) {
			for (i = 0; i < __himg.length; i++) {
				setBackImage($(__himg[i]), __my.W, __bodyH);
			}
		}
		__tmp = null;

		// TODO : verifier l'utilité de cette variable
		// not yet use
		/*
		 * var __pager = $(__tg).attr('pager'); var __useP = false; if(__pager){
		 * __useP = __pager; } __pager = null; __updateiScroll(__bodyScroll,
		 * "#scroller", null, (__bodyH - __offFixH), __useP);
		 */
		try{
			if (__isPicture) {
				__updateiScroll(__bodyScroll, "#scroller",
				__bodyScroll.offsetWidth, (__bodyH - __offFixH));
			} else {
				__updateiScroll(__bodyScroll, "#scroller",
				__bodyScroll.offsetWidth, (__bodyH - __offFixH));
			}
		}catch(e){
			console.error(e);
		}

		// update the menu item.
		var __prevImg = $('#m_img_on');
		if (__prevImg.length != 0) {
			var __src = __prevImg.attr('src');
			if (__src.match('on')) {
				__src = __src.replace(/on/, 'off');
			}
			__prevImg.attr('src', __src);
			__prevImg.attr('id', "m_img_off");
		}

		var __foot = $("#my-footer", __tg);
		if (__foot.attr('update') == '1') {
			var __sel = $('.menu-bar-col[sel="1"]', __foot);
			__idCurrentMenu = __sel.attr('id');

			var __img = $(".m-menu-icon", __sel);
			__src = __img.attr('src');
			if (__src.match('off')) {
				__src = __src.replace(/off/, 'on');
			}
			__img.attr('src', __src);
			__img.attr('id', "m_img_on");
		} else {
			if (__idCurrentMenu != "") {
				var __sel = $('#' + __idCurrentMenu, __foot);
				if (__sel.length > 0) {
					var __img = $(".m-menu-icon", __sel);
					__src = __img.attr('src');
					if (__src.match('off')) {
						__src = __src.replace(/off/, 'on');
					}
					__img.attr('src', __src);
					__img.attr('id', "m_img_on");
				}
			}
		}
		__src = __prevImg = __img = null;
		__bodyRef = __bodyScroll = __tg = null;
	};

	// -----------------------------------------------------------------------------------------------------------
	// -----------------------------------------------------------------------------------------------------------
	// Action management.
	// -----------------------------------------------------------------------------------------------------------
	var __planSend = false;

	__my.bindAction = function() {
		$('a[action="tel"]').live('click', function(evt) {
			var __agr = $(this).attr('agr');
			__my.getActionTel(__agr);
		});
		$('a[action="com"]').live('click', function(evt) {
			var __agr = $(this).attr('agr');
			__my.getActionCom(__agr);
		});
		$('a[action="share"]').live('click', function(evt) {
			var __agr = $(this).attr('agr');
			__my.getActionShare(__agr);
		});
		$('a[action="agenda"]').live('click', function(evt) {
			var __agr = $(this).attr('agr');
			__my.getActionAgenda(__agr);
		});
		$('a[action="link"]').live('click', function(evt) {
			var __agr = $(this).attr('agr');
			__my.getActionLink(__agr);
		});
	}

	__my.getActionTel = function(agr) {
		__my.registerAction(agr, ACT_TEL_AGR);
	}

	__my.getActionShare = function(agr) {
		__my.registerAction(agr, ACT_SHR_AGR);
	}

	__my.getActionCom = function(agr) {
		__my.registerAction(agr, ACT_COM_AGR);
	}

	__my.getActionAgenda = function(agr) {
		__my.registerAction(agr, ACT_CAL_AGR);
	}

	__my.getActionLink = function(agr) {
		__my.registerAction(agr, ACT_LNK_COM);
	}

	__my.registerAction = function(agr, action) {
		if(__my.NATIVE){
			if (agr == null)
			return;
			var __curTime = (new Date()).getTime();

			if (__I_db_exist("__actionList")) {
				__my.actionList = $.evalJSON(__I_db_read("__actionList"));
			} else {
				__my.actionList = {};
				__my.actDate = __curTime;
				__my.actionList.list = {};
			}

			if (COUNTPROP(__my.actionList.list) > 200) {
				// Reduce the list is it too populate
				console.log("[registerAction] To many object reduce the list ...");
				__my.actionList = {};
			}

			if (__my.actionList.list[agr]) {
				__my.actionList.list[agr].a |= action;
				__my.actionList.list[agr].t = __curTime;
			} else {
				__my.actionList.list[agr] = {};
				__my.actionList.list[agr].a = action;
				__my.actionList.list[agr].t = __curTime;
			}

			var __tmp = $.toJSON(__my.actionList);
			__I_db_save("__actionList", __tmp);
			if (!__planSend) {
				__planSend = true;
				// send stat every minutes.
				setTimeout(__my.saveStats, __my.statFreq);
			}
		}
	}

	// Send stat to server ...
	__my.saveStats = function() {
		console.log("[saveStats] Launch ...");
		if (__I_db_exist("__actionList")) {
			var __act = $.evalJSON(__I_db_read("__actionList"));
			__I_db_delete("__actionList");
			__my.actionList = {};

			__I_db_save("__tmpAction", $.toJSON(__act));
			__my.actNonce = Math.floor(Math.random() * 1000000);

			var __url = BASE_URL + "/_mStats.php?stat=1&u=" + __my.UDID + "&n="
					+ __my.actNonce;
			__my.postObjectFrom(__url, __act, __my.statSaved, __my.statError);
		} else {
			__planSend = false;
		}
	}

	// Call back function on stat return
	__my.statSaved = function(data) {
		if (data) {
			if (data.res) {
				if (data.nonce) {
					if (data.nonce == __my.actNonce) {
						// Mise à jour de la fréquence d'envoi des stats
						if (data.freq) {
							__my.statFreq = data.freq * 1000;
							console
									.log("[__statSaved] Stat correctly saved and freq updated ("
											+ __my.statFreq + ")...");
						} else {
							console
									.log("[__statSaved] Stat correctly saved ...");
						}
						__I_db_delete("__tmpAction");
					} else {
						console
								.log("[__statSaved] Stat saved with different nonce ...");
						__my.statMerge();
					}
				}
			} else {
				__my.statMerge();
				console.log("[__statSaved] Server response res = false ...");
			}
		} else {
			__my.statMerge();
			console.log("[__statSaved] Bad data server format ...");
		}
		__planSend = false;
	}

	// Call back function on stat error
	__my.statError = function(err) {
		console.log("ERR [statMerge] ( code:" + err.statusText + ")");
		__my.statMerge();
		__planSend = false;
	}

	__my.statMerge = function() {
		console.log("[statMerge] merge current and previous list ...");
		var __tmp;
		var __actlist = null;
		var __tmplist = null;
		if (__I_db_exist("__actionList")) {
			__actlist = $.evalJSON(__I_db_read("__actionList"));
		}

		if (__I_db_exist("__tmpAction")) {
			try {
				var __db = __I_db_read("__tmpAction");
				__tmplist = $.evalJSON(__db);
			} catch (e) {
				console.log("ERR [statMerge] error :" + e.message);
			}
		}

		if (__actlist != null) {
			if (__tmplist != null) {
				for ( var agr in __tmplist.list) {
					if (!__actlist.list[agr]) {
						__actlist.list[agr] = {};
						__actlist.list[agr].a = __tmplist.list[agr].a;
						__actlist.list[agr].t = __tmplist.list[agr].t;
					}
				}
				var __tmp = $.toJSON(__actlist);
				__I_db_save("__actionList", __tmp);
			}
		} else {
			if (__tmplist != null) {
				var __tmp = $.toJSON(__tmplist);
				__I_db_save("__actionList", __tmp);
			}
		}
		__tmp = __actlist = __tmplist = null;
	}// end __statMerge

	/*
	 * function __getCurrentDateWithoutHour(){ var __date = new Date(); var y =
	 * __date.getFullYear(); var m = __date.getMonth(); var d = __date.getDay();
	 * retrun new Date(y, m, d, 0, 0, 0, 0); }
	 * 
	 * function __isSameDay(timestmp1, timestmp2){ var __d1 = new
	 * Date(timestmp1); var __d2 = new Date(timestmp2); return
	 * (__d1.getFullYear() == __d2.getFullYear()) && (__d1.getMonth() ==
	 * __d2.getMonth()) && (__d1.getDay() == __d2.getDay()); }
	 */

	// ----------------------------------------------------------------------------------
	// ----------------------------------------------------------------------------------
	// -- Communication function
	/*
	 * Private method - get Server JSON Object. WARNING You have to nest
	 * parameters names with a double quot ". You need use " instead of ' in the
	 * parameter name of your JSON object else jQuey doesn't evaluated it.
	 * {"p1":"test1", "p2":123} instead of {'p1':'test1', 'p2':123} or
	 * {p1:'test1', p2:123} @IsRSS check if we process a RSS flow or a JSON
	 * flow. @IsPage used with IsRSS, if true tell the RSS flow concern a page
	 * and not a list
	 */
	__my.getObjectFrom = function(url, succH, errorH, IsRSS, IsPage) {

		isRSS = (IsRSS == null) ? __my.rss : IsRSS;
		isRSSpage = (IsPage == null) ? false : IsPage;

		if (isRSS) {
			$.ajax({
				type : "GET",
				url : url,
				dataType : "xml"
			}).success(function(data) {
				succH(__my.processRSS(data, isRSSpage));
			}).error(errorH);
		} else {
			$.getJSON(url).success(succH).error(errorH);
		}
	}// end getObjectFrom

	__my.postObjectFrom = function(url, data, succH, errorH) {
		$.post(url, data, function(data) {
			try {
				succH(data);
			} catch (e) {
				console.log("ERR [postObjectFrom] error " + e.message);
				errorH();
			}
		}, "json").error(errorH);
		;
	}

	// Ask the server to get message
	__my.checkForMessage = function() {
		if (__my.checkForMsgs) {
			$
					.get(BASE_URL + '/_mMsg.php?chk=1&u=' + __my.UDID)
					.success(
							function(data) {
								if (data.res) {
									if (data.res == 1) {
										var __type = (data.type) ? data.type
												: "dialog";
										var __msg = (data.msg) ? Base64
												.decode(data.msg) : null;
										var __msgID = (data.id) ? data.id : "";
										var __nonce = (data.nonce) ? data.nonce
												: "";
										var __prms = '{"id":"' + __msgID
												+ '","nonce":"' + __nonce
												+ '"}';
										if (__msg != null) {
											// check type of dialog to display
											switch (__type) {
											case "prompt":
												if (data.answ) {
													// create button list
													__I_create_dialog(
															__msg,
															"__CB_checkForMessage",
															"prompt", __prms,
															data.answ);
												}
												break;
											default: // dialog
												__I_create_dialog(__msg,
														"__CB_checkForMessage",
														"dial", __prms);
												break;
											}// end switch.
										} else {
											console.log("ERR [checkForMessage] no message content ... ");
										}
										__type = __msg = __msgID = __nonce = __prms = null;
										data = null;
									} else {
										console.log("ERR [checkForMessage] data.res == 0 ");
									}
								} else {
									if (data.conf){
										// protocole de configuration ...
										// TODO EG 07.08.12 - implémenter le protocole de configuration
										
										// recupération objet config
										
										// serialization du code hash de l'objet
										
										// Mise à jour des paramètres 
										
									}else{
										console.log("ERR [checkForMessage] no data.res ");
									}
								}
							}).error(
							function(err) {
								console.log("ERR [checkForMessage] ( code:" + err.statusText + ")");
							});
		}
	};// checkForMessage

	/*
	 * id : id of the message sel : selection made by the user.
	 */
	__my.selFromPrompt = function(id, sel, nonce) {
		// __my.msgID
		if (__my.checkForMsgs) {
			$
					.get(
							BASE_URL + '/_mMsg.php?resp=1&i=' + id + '&n='
									+ nonce + '&s=' + sel + '&u=' + __my.UDID)
					.success(
							function(data) {
								if (data.res) {
									if (data.res == 1) {
										// response registered ...
									} else {
										console
												.log("ERR [selFromPrompt] data.res == 0 ");
									}
								} else {
									console
											.log("ERR [selFromPrompt] no data.res ");
								}
							}).error(
							function(err) {
								console.log("ERR [selFromPrompt] ( code:"
										+ err.statusText + ")");
							});
		}// end if
	}// end selFromPrompt

	
	
	// deprecated functions ...
	// ---------------------------------------------------------------------------------------
	// ---------------------------------------------------------------------------------------

	// @deprecated ... related to iscroll_3 not used with iscroll4
	function onPullUp() {
		console.log("PULL :" + "pullup" + __my.pagerPage + "()");
		eval("pullup" + __my.pagerPage + "()");
		__my.iscroll.refresh();
	}

	/*
	 * @deprecated replace by my_list.__getlistContentErr() Manage error message
	 *             during communication process with the server
	 */
	__my.comError = function(err, callback) {
		CBack = (callback) ? callback : null;
		__msg = MY_ERROR_MESSAGE[__my.setLang]["1000"];
		if (err.statusText == 'error') {
			// alert(__msg +"\n"+ err.status);
			__I_create_dialog(__msg + "\n" + err.status, "__CB_comError");

		}
		if (err.statusText == 'timeout') {
			// alert(__msg +"\n"+ MY_ERROR_MESSAGE[__my.setLang]["1005"]);
			__I_create_dialog(__msg + "\n"
					+ MY_ERROR_MESSAGE[__my.setLang]["1005"], "__CB_comError");
		}
	}

	function __CB_comError(id, sel) {
	}

	
    /*
     * Method call by native layer to notify active application.
     * @deprecated replaced by savePIN
     */
    __my.registerDevice = function() {
             var __url = BASE_URL + "/_mStats.php?reg=1&dev=" + __my.native_device
             + "&ver=" + __my.native_version + "&u="
             + __my.UDID;
             console.log("PUSHSTAT : maj stat, reg device : " + __my.UDID);
             __my.getObjectFrom(__url, __my.deviceSaved, __my.deviceErr);            
    }

    /*
     * Call back function on stat return
     * @deprecated Replaced by pinSaved
     */ 
    __my.deviceSaved = function(data) {
        if (data) {
            __my.updateSetup();
            console.log("[deviceSaved] UDID saved ...");
        } else {
            console.log("[deviceSaved] Bad data server format ...");
            setTimeout('__my.registerDevice', 30000);
        }
    }

    /*
     * Call back function on stat return
     * @deprecated Replaced by pinErr
     */
    __my.deviceErr = function(err) {
        setTimeout('__my.registerDevice', 30000);
    }	
	
	// Expose my to the world
	return __my;
})(jQuery, window);
