/**
 * Copyright (c) 2011 myapphone.com, http://myapphone.com/
 * Version 1.0.0 - Last updated: -
 * 
 * Module to manage a rss feed on a ajax url.
 * This module also populate the realted element with list content.
 *
 * Usage :	
 * $('#rss_list').rssListReader(url);
 * 
 * Where url is the RSS url.
 */

var mapp =	(function(my_proc, $){
	
		//uses $.ajax query to get the raw rss xml
		my_proc.rss = true;
		my_proc.rssMapID; // mapping between the rss item and the PID of the list
		
		//objects inside the RSS2Item object
		function RSS2Enclosure(encElement){
			if (encElement == null){
				this.url = null;
				this.length = null;
				this.type = null;
			}else{
				this.url = encElement.getAttribute("url");
				this.length = encElement.getAttribute("length");
				this.type = encElement.getAttribute("type");
			}
		}

		function RSS2Guid(guidElement){
			if (guidElement == null){
				this.isPermaLink = null;
				this.value = null;
				this.numID = null;
			}else{
				this.isPermaLink = guidElement.getAttribute("isPermaLink");
				if(my_proc.existFunc("__myGetGUIDUrl")){
					this.value = __myGetGUIDUrl(guidElement.childNodes[0].nodeValue);
				}else{
					this.value = guidElement.childNodes[0].nodeValue;
				}
				if(my_proc.existFunc("__myGetGUID")){
					this.numID = __myGetGUID(guidElement.childNodes[0].nodeValue);
				}else{
					this.numID = guidElement.childNodes[0].nodeValue;
				}
			}
		}

		function RSS2Source(souElement){
			if (souElement == null){
				this.url = null;
				this.value = null;
			}else{
				this.url = souElement.getAttribute("url");
				this.value = souElement.childNodes[0].nodeValue;
			}
		}

		//objects inside the RSS2Channel object
		function RSS2Category(catElement){
			if (catElement == null){
				this.domain = null;
				this.value = null;
			}else{
				this.domain = catElement.getAttribute("domain");
				this.value = catElement.childNodes[0].nodeValue;
			}
		}

		//object containing RSS image tag info
		function RSS2Image(imgElement){
			if (imgElement == null){
				this.url = null;
				//this.link = null;
				//this.width = null;
				//this.height = null;
				//this.description = null;
			}else{
				var imgProp = new Array("url");
				//var imgProp = new Array("url","title","link","width","height","description");
				var tmpElement = null;
				for (var i=0; i<imgProp.length; i++){
					tmpElement = imgElement.getElementsByTagName(imgProp[i])[0];
					if (tmpElement!= null){
						try{
							eval("this."+imgProp[i]+"=tmpElement.childNodes[0].nodeValue");
						}catch(err){
							console.log("[RSS] Image : " + err.description);
						}
					}
				}
				
			}
		}//end RSS2Image

		//object containing RSS calendar tag info
		function RSS2Calendar(calElement){
			if (calElement == null){
				this.start = null;
				this.end = null;
				this.title = null;
				this.adress = null;
				this.lat = null;
				this.long = null;
			}else{
				var calProp = new Array("start","end","title","adress","lat","long");
				var tmpElement = null;
				for (var i=0; i<calProp.length; i++){
					tmpElement = calElement.getElementsByTagName(calProp[i])[0];
					if (tmpElement!= null){
						try{
							eval("this."+calProp[i]+"=tmpElement.childNodes[0].nodeValue");
						}catch(err){
							console.log("[RSS] Calendar : " + err.description);
						}
					}
				}
			}
			
		}//end RSS2Calendar

		// Remove anchor from a text
		function removeAnchor(text){
			// remove <a>
			// var __reg = new RegExp("(<[a|A][^>]*>|</[a|A]>)", "g");
			// text = text.replace(__reg,"");
			
			// remove relative link <a>
			var __reg = new RegExp("<a.*href=[\"|'](?!http|mailto|tel).*>\(.*\)</a>", "gi");
			text = text.replace(__reg,"$1");
			
			// remove <img>
			//var __reg = new RegExp("(<[img|IMG][^>]*>)", "g");
			//return text.replace(__reg,"");

			// remove relative link on image <img>
			__reg = new RegExp("<img.*src=[\"|'](?!http).*>", "gi");
			text = text.replace(__reg,"");

			return text;
		}

		//object containing the parsed RSS 2.0 channel
		function RSS2Channel(rssxml){
			//required
			this.page;
			this.title;
			this.link;
			this.description;

			//array of RSS2Item objects
			this.items = new Array();

			//optional vars
			this.language;
			this.copyright;
			this.managingEditor;
			this.webMaster;
			this.pubDate;
			this.lastBuildDate;
			this.generator;
			this.docs;
			this.ttl;
			this.rating;

			//optional objects
			this.category;
			this.image;
			
			var chanElement = rssxml.getElementsByTagName("channel")[0];
			// get page number
			this.page = chanElement.getAttribute('page');
			
			var itemElements = rssxml.getElementsByTagName("item");

			for (var i=0; i<itemElements.length; i++){
				Item = new RSS2Item(itemElements[i]);
				this.items.push(Item);
				//chanElement.removeChild(itemElements[i]);
			}

			var properties = new Array("title", "description", "link", "language", "copyright", "managingEditor", "webMaster", "pubDate", "lastBuildDate", "generator", "docs", "ttl", "rating");
			var tmpElement = null;
			for (var i=0; i<properties.length; i++)
			{
				tmpElement = chanElement.getElementsByTagName(properties[i])[0];
				if (tmpElement!= null){
					try{
						eval("this."+properties[i]+"=tmpElement.childNodes[0].nodeValue");
					}catch(err){
						console.log("[RSS] Channel : " + err.description);
					}
				}
			}
			
			// management of the properties but with <a> removing 
			var properties = new Array("title", "description");
			var tmpElement = null;
			for (var i=0; i<properties.length; i++)
			{
				tmpElement = chanElement.getElementsByTagName(properties[i])[0];
				if (tmpElement!= null){
					try{
						eval("this."+properties[i]+"=removeAnchor(tmpElement.childNodes[0].nodeValue)");
					}catch(err){
						console.log("[RSS] Channel : " + err.description);
					}
				}
			}
			
			this.category = new RSS2Category(chanElement.getElementsByTagName("category")[0]);
			this.image = new RSS2Image(chanElement.getElementsByTagName("image")[0]);
			
			// change lastBuildDate to timestamp
			if(this.lastBuildDate){
				this.lastBuildDate = Date.parse(this.lastBuildDate);
			}
		}//end RSS2Channel
		
		//object containing the RSS 2.0 item
		function RSS2Item(itemxml){
			//required
			this.title;
			this.link;
			this.description;

			//optional vars
			this.author;
			this.comments;
			this.pubDate;
			this.email;

			//optional objects
			this.category;
			this.enclosure;
			this.guid;
			this.source;
			
			this.p_guid = undefined;
			this.n_guid = undefined;

			// management of the properties 
			var properties = new Array("link", "email", "author", "comments", "pubDate", "p_guid", "n_guid");
			var tmpElement = null;
			for (var i=0; i<properties.length; i++){
				tmpElement = itemxml.getElementsByTagName(properties[i])[0];
				if (tmpElement != null){
					try{
						eval("this."+properties[i]+"=tmpElement.childNodes[0].nodeValue");
					}catch(err){
						console.log("[RSS] item: " + err.description);
					}
				}
			}
			
			// management of the properties but with <a> removing 
			properties = new Array("title", "description");
			tmpElement = null;
			for (var i=0; i<properties.length; i++){
				tmpElement = itemxml.getElementsByTagName(properties[i])[0];
				if (tmpElement != null){
					try{
						eval("this."+properties[i]+"=removeAnchor(tmpElement.childNodes[0].nodeValue)");
					}catch(err){
						console.log("[RSS] item: " + err.description);
					}
				}
			}

			//this.category = new RSS2Category(itemxml.getElementsByTagName("category")[0]);
			//this.enclosure = new RSS2Enclosure(itemxml.getElementsByTagName("enclosure")[0]);			
			this.guid = new RSS2Guid(itemxml.getElementsByTagName("guid")[0]);
			//this.source = new RSS2Source(itemxml.getElementsByTagName("source")[0]);
			this.image = new RSS2Image(itemxml.getElementsByTagName("image")[0]);
			this.calendar = new RSS2Calendar(itemxml.getElementsByTagName("calendar")[0]);
		}//end RSS2Item

		//processes the received rss xml
		my_proc.processRSS = function (rssxml, isPage){
			RSS = new RSS2Channel(rssxml);
			rssxml = null;
			if(isPage) return createRSSObject(RSS);
			else return createRSSListObject(RSS);
		}//End processRSS

		//transform the RSS flow as JSON object list
		function createRSSListObject(RSS){
			if(my_proc.rssMapID == null){
				console.log("[createRSSListObject] WARNING no mapping ID found ...");
				return null;
			}
			
			if(RSS.items.length == 0){
				console.log("[createRSSListObject] WARNING no RSS item found ...");
				return null;
			}else{
				// display list.
				var __res = {};

				__res.up = 1;
				__res.pm = {};
				__res.pm.pid = true;
				__res.pm.bk = 1;
				__res.c = {};
				
				if(RSS.page != null){
					__res.pg ={};
					__res.pg.t = "pull"
					__res.pg.i = RSS.page;
					__res.pg.nb = 0;
				}
				
				for (var i=0; i<RSS.items.length; i++){
					//RSS.items[i].title
					__res.c[i] = {};
					
					// specific defintion for ID
					if((my_proc.rssMapID.id)&&(my_proc.rssMapID.id.p)){
						if(RSS.items[i][my_proc.rssMapID.id.p] != null) __res.c[i].id = RSS.items[i][my_proc.rssMapID.id.p];
						else __res.c[i].id = "";
					}else{
						if(RSS.items[i].guid.value != null) __res.c[i].id = RSS.items[i].guid.value;
						else __res.c[i].id = "";
						
						if(RSS.items[i].guid.numID != null) __res.c[i].guid = RSS.items[i].guid.numID;
						else __res.c[i].guid = "";
					}
					
					// update label
					__res.c[i].label = {};
					if(my_proc.rssMapID.label){
						for(__pid in my_proc.rssMapID.label){
							__res.c[i].label[__pid] = RSS.items[i][my_proc.rssMapID.label[__pid]];
						}
					}//end if
					
					// update image
					__res.c[i].img = {};
					if(my_proc.rssMapID.img){
						for(__pid in my_proc.rssMapID.img){
							__res.c[i].img[__pid] = {};
							var __img = RSS.items[i].image.url;
							if(__img){
								__res.c[i].img[__pid].v = __img;
							}else{
								if(RSS.items[i].guid.value != null){
									__res.c[i].img[__pid].v = __myGetImageFromGUID(RSS.items[i].guid.value);
								}
							}
						}
					}//end if
					
				}//end for
				
				RSS = null;
				my_proc.rssMapID = null;
				return __res;
			}
		}//end createRSSListObject

		
		//transform the RSS flow as JSON object page
		function createRSSObject(RSS){
			if(my_proc.rssMapID == null){
				console.log("[createRSSObject] WARNING no mapping ID found ...");
				return null;
			}
			
			if(RSS.items.length == 0){
				console.log("[createRSSObject] WARNING no RSS item found ...");
				return null;
			}else{
				// display Object.
				var __res = {};

				__res.up = 1;
				__res.pm = {};
				__res.pm.pid = true;
				__res.pm.guid = RSS.items[0].guid.numID;

				// check for navigation button
				with(RSS.items[0]){
					if((p_guid)||(n_guid)){
						__res.pm.nav = {};
						if(p_guid) __res.pm.nav.p = p_guid;
						if(n_guid) __res.pm.nav.n = n_guid;
					}
				}
				
				// Update label
				__res.label = {};
				if(my_proc.rssMapID.label){
					for(__pid in my_proc.rssMapID.label){
						__res.label[__pid] = RSS.items[0][my_proc.rssMapID.label[__pid]];
					}
				}//end if
				
				// Update image
				__res.img = {};
				if(my_proc.rssMapID.img){
					for(__pid in my_proc.rssMapID.img){
						__res.img[__pid] = {};
						var __img = RSS.items[0].image.url;
						if(__img){
							__res.img[__pid].v = __img;
						}else{
							__res.img[__pid].v = my_proc.rssMapID.def.img;
						}
					}
				}//end if

				//Update agenda
				if(RSS.items[0].calendar.start != null){
					__res.ag = {};
					__res.ag.ds = RSS.items[0].calendar.start;
					__res.ag.de = RSS.items[0].calendar.end;
					__res.ag.t = RSS.items[0].calendar.title;
				}
				
				RSS = null;
				my_proc.rssMapID = null;
				return __res;
			}
		}//end createRSSObject

		return my_proc;
	})(myapp, jQuery);

