/**
 * Copyright (c) 2011 myapphone.com, http://myapphone.com/
 * Version 1.0.0 - Last updated: -
 * 
 * Module to manage the dynamic list.
 * This module ask the server for content update. If necessary download the new content from 
 * the server then update the application page.
 */

// -----------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------
// Declaration of the callback functions for dialogs box ...

		
// -----------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------

var myapp = (function(my_app, $){
	// private properties. 
	
	my_app.scrollCenter = function(fx, fy, imgW, imgH){
		cx = (Math.round(my_app.iscrollWindow.w/2)) - fx;
		cy = (Math.round(my_app.iscrollWindow.h/2)) - fy;

		if(imgW) cx = cx - (Math.round(imgW/2));
		if(imgH) cy = cy - (Math.round(imgH/2));

		cx = (cx > 0)?0:cx;
		cy = (cy > 0)?0:cy;

		if(my_app.iscroll != null){
			my_app.iscroll.scrollTo(cx, cy, 500);
		}
	};//end scrollCenter
	
	my_app.evalPictMiddleBottom=function(fx, fy, imgW, imgH){
		cx = fx - (Math.round(imgW/2));
		cy =  fy - imgH;
		return {"px":cx, "py":cy};
	};//end evalPictMiddleBottom
	
	my_app.posLongLat = function(map, lg, lt){
		if(my_app.preCalc == null) my_app.preCalc = {};
		if(my_app.preCalc[map] == undefined){
			my_app.preCalc[map] = {};
		}

		/*if(my_app.preCalc[map] == undefined){
			var __mm = minMax(map);
			my_app.preCalc[map] = {};
			
			my_app.preCalc[map].dx = (__mm.ltmin.c - __mm.ltmx.c)/(__mm.ltmin.p - __mm.ltmx.p);
			my_app.preCalc[map].dy = (__mm.lgmx.c - __mm.lgmin.c )/(__mm.lgmx.p - __mm.lgmin.p);
			my_app.preCalc[map].ltO = __mm.ltmx.c -( __mm.ltmx.p * my_app.preCalc[map].dx);
			my_app.preCalc[map].lgO = __mm.lgmx.c -( __mm.lgmx.p * my_app.preCalc[map].dy);
		}
		
		nx = Math.round((lt - my_app.preCalc[map].ltO)/my_app.preCalc[map].dx); 
		ny = Math.round((lg - my_app.preCalc[map].lgO)/my_app.preCalc[map].dy);*/

		if(my_app.preCalc[map].Mtrans == undefined){
			var __pixX=[];
			var __pixY=[];

			var __coordLg=[];
			var __coordLt=[];

			for(var __x in my_app.custoMap[map].cal){
				__pixX.push(my_app.custoMap[map].cal[__x]["x"]["p"]);
				__pixY.push(my_app.custoMap[map].cal[__x]["y"]["p"]);
				__coordLg.push(my_app.custoMap[map].cal[__x]["x"]["lg"]);
				__coordLt.push(my_app.custoMap[map].cal[__x]["y"]["lt"]);
			}

			var __Mpix=$M([
				__pixX,
				__pixY
				]);

			var __Mcoord=$M([
				__coordLg,
				__coordLt,
				[1, 1, 1]
				]);

			__pixX=__pixY=__coordLg=__coordLt=null;

			my_app.preCalc[map].Mtrans=__Mpix.multiply(__Mcoord.inverse());
			my_app.preCalc[map].Mtrans.elements[2]=[0, 0, 1];

			__Mpix=__Mcoord=null;
		}

		var __Mgps=$M([
			[lg],
			[lt],
			[1]
			]);

		//multiplie la matrice de transformation par la matrice avec les coordonnées GPS
		var __Mres=my_app.preCalc[map].Mtrans.multiply(__Mgps);

		var nx=__Mres.elements[0][0];
		var ny=__Mres.elements[1][0];

		__Mres=__Mgps=null;

		return {"px":nx, "py":ny};
	};//end posLongLat
	
	// get Min / Max coordinate on 3 calibrations points.
	function minMax(map){		
		var __latMx = __longMx = __latMin = __longMin = null;
		var __init = false;
		for (var point in my_app.custoMap[map].cal){
			if(!__init){
				__latMin = {}; 
				__latMin.c = my_app.custoMap[map].cal[point].y.lt;
				__latMin.p = my_app.custoMap[map].cal[point].y.p;
					
				__latMx = {};
				__latMx.c = my_app.custoMap[map].cal[point].y.lt;
				__latMx.p = my_app.custoMap[map].cal[point].y.p;
				
				__longMin = {};
				__longMin.c = my_app.custoMap[map].cal[point].x.lg;
				__longMin.p = my_app.custoMap[map].cal[point].x.p;
				
				__longMx = {};
				__longMx.c = my_app.custoMap[map].cal[point].x.lg;
				__longMx.p = my_app.custoMap[map].cal[point].x.p;
				
				__init = true;
			}else{
				if(my_app.custoMap[map].cal[point].y.lt < __latMin.c){
					__latMin.c = my_app.custoMap[map].cal[point].y.lt; 
					__latMin.p = my_app.custoMap[map].cal[point].y.p; 
				}
				if(my_app.custoMap[map].cal[point].y.lt > __latMx.c){
					__latMx.c = my_app.custoMap[map].cal[point].y.lt; 
					__latMx.p = my_app.custoMap[map].cal[point].y.p; 
				}
				
				if(my_app.custoMap[map].cal[point].x.lg < __longMin.c){
					__longMin.c = my_app.custoMap[map].cal[point].x.lg; 
					__longMin.p = my_app.custoMap[map].cal[point].x.p; 
				}
				if(my_app.custoMap[map].cal[point].x.lg > __longMx.c){
					__longMx.c = my_app.custoMap[map].cal[point].x.lg; 
					__longMx.p = my_app.custoMap[map].cal[point].x.p; 
				}
			}
		}
		return {"ltmx": __latMx, "ltmin":__latMin, "lgmx":__longMx, "lgmin":__longMin};
	}
	
	return my_app;
	
})(myapp, jQuery);
