/*
 * functions utiles pour le simulateur.
 */

//mise à jour des messages d'erreur pour le simulateur;
MY_ERROR_MESSAGE["en"]["1000"] = "";
MY_ERROR_MESSAGE["en"]["1005"] = "";
MY_ERROR_MESSAGE["en"]["1006"] = "";
MY_ERROR_MESSAGE["en"]["2001"] = "";

MY_ERROR_MESSAGE["fr"]["1000"] = "Une erreur est survenue lors de la connexion avec le service !<br/><br/>Veuillez verifier votre connexion internet!<br/>Videz le cache de votre navigateur si le problème persiste redémarrez le!";
MY_ERROR_MESSAGE["fr"]["1005"] = "Le serveur n'a pas répondu assez rapidement!<br/><br/>Veuillez verifier votre connexion internet!<br/>Videz le cache de votre navigateur si le problème persiste redémarrez le!";
MY_ERROR_MESSAGE["fr"]["1006"] = "Le contenu n'a pas pu être téléchargé!<br/><br/>Veuillez verifier votre connexion internet!<br/>Videz le cache de votre navigateur si le problème persiste redémarrez le!";
MY_ERROR_MESSAGE["fr"]["2001"] = "Impossible de télécharger le diaporama!<br/><br/>Veuillez verifier votre connexion internet!<br/>Videz le cache de votre navigateur si le problème persiste redémarrez le!";


(function(my_app, $, win){

	if(!my_app.hasOwnProperty("LANG")) my_app.LANG={};
	if(!my_app.LANG.hasOwnProperty("fr")) my_app.LANG['fr']={};
	if(!my_app.LANG.hasOwnProperty("en")) my_app.LANG['en']={};
	my_app.LANG['fr']['__l5000'] = 'Chargement ...';
	my_app.LANG['en']['__l5000'] = 'Loading ...';

	var sim_info_dialog = true;
	
	my_app.sim = true;
	my_app.NATIVE = false;

	// Configuration du blocage des événements sur le simulateur.
	// - sur la barre d'entête (blockHeadEvt)
	// - les barres fixées (blockFixHeadEvt)
	// - La barre de menu (blockMenuBar)
	my_app.simCfg = {
		blockEvent : false,
		blockHeadEvt : false,
		blockFixHeadEvt : false,
		blockMenuBar : false
	};

	//object contains function for simulator
	my_app.simFn={};

	my_app.config.loc = true; // activation GPS ...

	//
	my_app.checkForMsgs = false;
	
	// dummy content for simulator
	my_app.UDID = "12345677890";
	my_app.PIN = "AZERTYUIOP";
	my_app.native_device = "iphone";
	my_app.native_version = "4.0.2";
	
	// add support for spinning wheel ...
	my_app.addJSLink('../common/scripts/spinner/spinningwheel.js');
	my_app.addCSSRules('../common/scripts/spinner/spinningwheel.css');

	// add gallery process and styles
	my_app.addJSLink('../common/scripts/my_gallery.js');
	my_app.addCSSRules('../common/styles/my_gallery.css');

	// add gallery process and styles
	my_app.addJSLink('../common/scripts/my_goodies.js');
	my_app.addCSSRules('../common/styles/my_goodies.css');

	// add video process and styles
	my_app.addJSLink('../common/scripts/my_video.js');
	
	// add geoloc location process and styles
	my_app.addJSLink('../common/scripts/my_geoloc.js');
	
	// EG 26.07.12 #634
	$(window).load(function (e){
		$('a[action]').live('click',function(e){
			var __act = $(e.currentTarget).attr('action');
			if((__act)&&(__act === 'link')){
				if (e.stopPropagation)  e.stopPropagation();
				e.cancelBubble = true;
				my_app.simAlert("Le simulateur ne permet pas la navigation internet ...<br/>Lien selectionné : " + $(e.currentTarget).attr('href'));
				return false;
			}
			return true;
		});
	});

	//JB 2012 09 27 15:10
	$(document).bind("endSplash", function(){
		if(window.frames.parent.myapp && window.frames.parent.myapp.cms){
			window.frames.parent.myapp.cms.sim.queueToExec();
		}
	});

	// to avoid scroll bar in the simulator. 
	$("<style type='text/css'>body{overflow: hidden;}</style>").appendTo("head");

	// Disable link on my account 
	$("a.my_but_acc_ico_header").live('click', function(e) {
		if (e.preventDefault) e.preventDefault();
		my_app.simAlert(MY_ERROR_MESSAGE[my_app.setLang]["3001"]);
		return false;
	});

	$('*[id^="SearchTopBar"]').live('click', function(e){
		my_app.simAlert(MY_ERROR_MESSAGE[my_app.setLang]["3001"]);
		return false;
	});
	
	$('*[id^="SortTopBar"]').live('click', function(e){
		my_app.simAlert(MY_ERROR_MESSAGE[my_app.setLang]["3001"]);
		return false;
	});

	//img click diaporama
	$('img[max_size]').live('click', function(e){
		var __ms=$(e.currentTarget).attr('max_size');
		try{
			__ms=$.parseJSON(__ms);
		}catch(e){
			console.error(e);
		}
		if(__ms && __ms.zoom){
			my_app.simAlert(window.frames.parent.myapp.translate("Simulator does not support the display of article's slideshow !"));
		}
		return false;
	});

	// @see my_app.simCfg (ci-dessus) 
	$(".block_event").live('click', function(e) {
		if (e.stopPropagation) e.stopPropagation();
		e.cancelBubble = true;
		__dialog('info', 'sim_message_no_supported');
		return false;
	});
	
	function __dialog(title, message) {
		if(sim_info_dialog){
			var __title = window.frames.parent.myapp.translate(title),
			__msg = window.frames.parent.myapp.translate(message); 
			window.frames.parent.myapp_modal_alert(__title, __msg);
		}
	}

	// misc function ...
	// @deprecated remplaced by content_changePage
	my_app.sim_menuClick = function(page){
		return true;
	};

	// Test for click on the toolbar Menu;
	my_app.sim_clickMenu = function(){
		if(!my_app.simCfg.blockMenuBar) return false;
		else{
			if (window.frames.parent.myapp) {
				var __title = window.frames.parent.myapp.translate('info'),
				__msg = window.frames.parent.myapp.translate('sim_message_info'); 
				window.frames.parent.myapp_modal_alert(__title, __msg);
			}
			return true;
		}
	};

// Action simulateur => contenu.
	/*
	 * changement du gestionnaire contenu suite à un changement de page du simulateur.
	 */ 
	my_app.content_changePage = function(aid, origin){
		if(window.frames.parent && window.frames.parent.myapp && window.frames.parent.myapp.cms){
			if(window.frames.parent.myapp.cms.pushUI) return;
			if (window.frames.parent.myapp.cms) window.frames.parent.myapp.cms.fromSimChangePage(aid, origin);
		}
	};//end content_changePage
	
	/**
	 * @aid id de l'item
	 * @origin selecteur utilisé dans myappCms
	 * @open utilisé avec les accordéons open = ouvert, !open = fermé 
	 * 
	 * @see myappCms.js fromSimChangeItem
	 */
	my_app.content_changeItem = function(aid, origin, open){
		if(window.frames.parent && window.frames.parent.myapp && window.frames.parent.myapp.cms){
			if(window.frames.parent.myapp.cms.pushUI) return;
			if (window.frames.parent.myapp.cms) window.frames.parent.myapp.cms.fromSimChangeItem(aid, origin, open);
		}
	};//end content_changeItem
	

// Action contenu => simulateur
	// call from main page : document.simframe.myapp.sim_changePage("3");
	my_app.sim_changePage = function(aid){
		var __aids = $('div[aid="'+ aid +'"]');
		if(__aids.length){
			var __sel = __aids[0],
			__id = $(__sel).attr("id"); 
			$.mobile.changePage("#"+__id, "none", false);
		}
	};

	// call from main page : document.simframe.myapp.sim_changeAndRefresh("5");
	my_app.sim_changeAndRefresh = function(aid){
		var __aids = $('div[aid="'+ aid +'"]');
		if(__aids.length){
			var __sel = __aids[0];
			__refresh(aid, __sel);
		}
	};
	
	// call from main page : document.simframe.myapp.sim_changeAndRefresh("5");
	my_app.sim_changePageFromList = function(aid){
		var __acts = $('div[active="1"]');
		if(__acts.length){
			var __sel = __acts[0],
			__id = $(__sel).attr("id");
			$("#"+__id+" li").filter("[my-id="+aid+"]").trigger("click",['frompage']);
		}
	};
	
	
	// call from main page : document.simframe.myapp.sim_refreshActive();
	my_app.sim_refreshActive = function(aid){
		var __acts = $('div[active="1"]');
		if(__acts.length){
			var __sel = __acts[0],
			__aid = (aid) ? aid : $(__sel).attr("aid");
			__refresh(__aid, __sel);
		}
	};
	
	// EG - 25.07.12 Appelle la methode spécial refresh 
	// Utilisé pour les templates spéciaux (Resto/carte ...)
	// @see cms/cms_tools/tools_tplxxx/tools_tplxxx.php
	// Implémenté dans tools_tplFood
	my_app.sim_refreshSpecial = function(event, from, open){
		if (eval("typeof " + "my_special_refresh" + " == 'function'")) {
			// function exist
			my_special_refresh(event, from, open);
		}
	};

	function __foundParent(aid){
		//browse main menu items
		for(var __x in myapp.myMenu){
			if(myapp.myMenu.hasOwnProperty(__x)){
				for(var __y in myapp.myMenu[__x]){
					if(myapp.myMenu[__x].hasOwnProperty(__y)){
						if(myapp.myMenu[__x][__y].sim_aid==aid){
							return __x;
						}
					}
				}
				__y=null;
			}
		}
		__x=null;
		return false;
	}

	function __checkUrl(aid){
		//browse main menu items
		for(var __x in myapp.myMenu){
			if(myapp.myMenu.hasOwnProperty(__x)){
				for(var __y in myapp.myMenu[__x]){
					if(myapp.myMenu[__x].hasOwnProperty(__y)){
						if(myapp.myMenu[__x][__y].sim_aid==aid){
							if(myapp.myMenu[__x][__y].hasOwnProperty("urlOverride")){
								return myapp.myMenu[__x][__y].urlOverride;
							}else{
								return false;
							}
						}
					}
				}
				__y=null;
			}
		}
		__x=null;
		return false;
	}

	function __refresh(aid, sel) {
		var __sel=$(sel),
		__id = __sel.attr("id"),
		__role = __sel.attr("my-role"),
		__static = __sel.attr("my-next"),
		__events = $("#"+__id).data('events'),
		__title = $("#my-header span.my-head-titleLabel", sel).text(),
		//__parentAid = __foundParent(aid),
		__urlOverride = __checkUrl(aid);

		//JB : 2013-04-24 : added for event refresh
		if(__events && __events.pagebeforeshow){
			__events.pagebeforeshow[0].handler();
		}
		/*
		JB : 2012-12-06 remove condition && (aid==135 || aid==171) (fix issue on tpl_cycle home)
		aid(135) = agenda
		aid(171) = program
		*/
		if(__events && __events.pagetobedisplay){
			__events.pagetobedisplay[0].handler();
		}else if( (__static !== "static-list") ){
			var __url;
			// detection de la page active.
			if(__role === "page"){
				__url = __urlOverride ? __urlOverride : "/_mCont_3.php?page=1&it=" + aid;
				my_app.updatePage(__id, __url, __title, true, aid);
			}else if(__role === "listw"){
				__url = __urlOverride ? __urlOverride : "/_mCont_3.php?list=1&it=" + aid ;
				my_app.updateList2(__id, __url, __title, true, false, true, false, aid);
			}
			/*if(__parentAid) $('#'+__parentAid+' li[my-id='+aid+']').trigger('click');
			else $('li[my-id='+aid+']', 'div[active=1]').trigger('click');*/
		}else{
			//JB : 2012 09 17 fix added for home as static-list with page(some dynamic contents) @see tpl_hotel
			if( (__id =="my-home") && (__static == "static-list") && (window.my_home_load && typeof my_home_load == 'function') ){
				my_home_load();
			}else{
				$.mobile.changePage("#"+__id, "none", false);
			}
		}

		$('img[src=""][pid]').attr('src', '../common/styles/empty.png');
	};//end __refresh
	
	my_app.sim_geoloc = function(callback){
		my_app.localization.status = MY_GPS_POSITION;
		my_app.localization.error = MY_OK;
		myapp.localization.longitude = 6.142638;
		myapp.localization.latitude = 49.35625;
		if((callback != undefined)&&(callback != null)){
			var __fn = window[callback];
			__fn();
		}
	};

	/*SIM PUSH*/
	my_app.sim_push={
		instance:'',
		create:function(msg){
			var __pushDialog=$(document.createElement('div'));
			__pushDialog.appendTo('body');

			__pushDialog.html(msg);
			__pushDialog.append('<br/><br/>');
			__pushDialog.css({
				'background-color':'#0F1C41',
				border:'1px solid #858B9B',
				'border-radius':'20px',
				'box-shadow':'3px 3px 3px #333333',
				color:'#ffffff',
				left:'5%',
				padding:'5% 4%',
				position:'absolute',
				'text-align':'center',
				top:'30%',
				width:'82%',
				'z-index':999
			});
			__pushDialog.attr('id', 'sim_pushDialog');

			var __pushDialogCloseBtn=$(document.createElement('span'));
			__pushDialogCloseBtn.appendTo(__pushDialog);

			if (window.frames.parent.myapp) {
				__pushDialogCloseBtn.html(window.frames.parent.myapp.translate('Close'));
			}else{
				__pushDialogCloseBtn.html('Close');
			}
			__pushDialogCloseBtn.css({
				'background-color':'#606981',
				color:'#0F1C41',
				cursor:'pointer',
				border:'1px solid #858B9B',
				'border-radius':'20px',
				margin:'auto',
				padding:'5px 10px',
				width:'50%'
			});
			__pushDialog.attr('id', 'sim_pushDialogCloseBtn');

			__pushDialogCloseBtn.bind('click', this.destroy);

			this.instance=__pushDialog;

			__pushDialogCloseBtn=__pushDialog=null;

			setTimeout(my_app.sim_push.destroy, 15000);
		},
		destroy:function(){
			my_app.sim_push.instance.remove();
		}
	};
	
	// IOS dialog box 
	my_app.addCSSRules('../common/styles/myiospopup.css');
	my_app.delayBet2ErrorMsg = 5000;

	// IOS alert dialog box
	var __iosDialog='<div id="iosAlert" style="display: none"><div><div><div id="iosAlertBox"><div id="iosGlow">&nbsp;</div><div id="iosAlertBg"><div id="iosWrapper"><div id="iotitle">Message</div><div id="iocontent"><br/>Content</div><div class="ioButton" onclick="myapp.quitAlert();">OK</div></div></div></div></div></div></div>';
	$('body').append(__iosDialog);
	
	// Préchargement des images nécéssaire à la boite de dialogue.
	dialogImage = []; 
	dialogImage[0] = new Image(); 
	dialogImage[0].src = "../common/styles/myiosglow.png";
	dialogImage[1] = new Image(); 
	dialogImage[1].src = "../common/styles/myiosbg.png";
	dialogImage[2] = new Image(); 
	dialogImage[2].src = "../common/styles/myiosbutton.png";
	
	my_app.alertDialog = function(message, modalCallBack, IDCallBack, params, Buttons, Type, Title){
		my_app.simAlert(message, Title, modalCallBack, IDCallBack, params);
	};
	
	my_app.quitAlert = function(){
		var __iosA = $('#iosAlert'),
		__modalCB = __iosA.attr("cb"),
		__idCB = __iosA.attr("idcb"),
		__pCB = __iosA.attr("pcb");
		$('#iosAlert').hide();
		// do the call back
		if((__modalCB != undefined)&&(__modalCB != null)){
			var __fn = window[__modalCB];
			__fn(__idCB, 0, __pCB);
		}
		
		__iosA.removeAttr("cb").removeAttr("idcb").removeAttr("pcb");
	};
	
	my_app.simAlert = function(msg,title,modalCallBack, IDCallBack, params){
		title=(typeof(title)==='undefined')?'Info':title;
		$('#iotitle').html(title);
		$('#iocontent').html('<br/>'+msg);
		
		if(modalCallBack && (modalCallBack != null)){
			$('#iosAlert').attr("cb",modalCallBack);
			if(IDCallBack) $('#iosAlert').attr("idcb",IDCallBack);
			if(params) $('#iosAlert').attr("pcb",params);
		}
		$('#iosAlert').show();
	};//end simAlert

	// IOS loading box
	
	var __iosLoading='<div id="iosLoading" style="display: none"><div><div><div class="preloadpp"><div class="loadingpp-wrapper"><div class="loadingpp"></div></div><table style="height: 100%;"><tr><td valign="center"><h1 class="loading_titlepp">'+	my_app.LANG[my_app.setLang]['__l5000']+'</h1></td></tr></table></div></div></div></div>';
	$('body').append(__iosLoading);

	// Préchargement des images nécéssaire à la boite de dialogue.
	dialogImage[3] = new Image(); 
	dialogImage[3].src = "../common/styles/myiosloader.png";

	// turn on/off page loading message.
	function pageLoading( done ) {
		if ( done ) {
			// fermeture de la fenetre
			$('#iosLoading').hide();
		} else {
			// Ouverture de la fenetre
			$('#iosLoading').show();
		}
	};

	function setLanguage(){
		if(window.frames.parent.myapp && window.frames.parent.myapp.language){
			var appName=window.location.href.match(/sim\/apps\/(.*)\//);
			appName=appName[1];

			jQuery.post(window.location.origin+"/mob/?app="+appName+"&lang="+window.frames.parent.myapp.language.userLang, {'a':'lang'}).success(function(rsp){
				jQuery.extend(true, myapp.LANG[rsp.lang], rsp.datas);
				myapp.changeLang(rsp.lang);
			}).error(function(rsp){
				console.error(rsp);
			});
		}
	}

	setLanguage();

	$.extend( $.mobile, {
		pageLoading: pageLoading
	});

})(myapp, jQuery, window);