function myappDate(lang){
	//CONST
	var _monthNames={
		'en':['January', 'February', 'March', 'April', 'May', 'June', 'Jully',
		'August', 'September', 'October', 'November', 'December'],
		'fr':['Janvier', 'Février', 'Mars', 'Avril', 'Mai', 'Juin', 'Juillet',
		'Août', 'Septembre', 'Octobre', 'Novembre', 'Décembre']
	},
	_monthNamesShort={
		'en':['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
	'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
		'fr':['Jan', 'Fév', 'Mar', 'Avr', 'Mai', 'Jui',
	'Jui', 'Aoû', 'Sep', 'Oct', 'Nov', 'Déc']
	},
	_dayNames={
		'en':['Sunday', 'Monday', 'Tuesday', 'Wednesday',
	'Thursday', 'Friday', 'Satursday'],
		'fr':['Dimanche', 'Lundi', 'Mardi', 'Mercredi',
	'Jeudi', 'Vendredi', 'Samedi']
	},
	_dayNamesShort={
		'en':['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'],
		'fr':['Dim', 'Lun', 'Mar', 'Mer', 'Jeu', 'Ven', 'Sam']
	},
	_dayMS=86400000;//a day in milliseconds

	//VARS
	var self=this;
	self.date=new Date();
	self.lang=lang ? lang : 'en';

	//FUNCTIONS
	/**
	* @date : (Date) (optional)
	* @return (string) month name
	*/
	self.getStringMonth=function(date){
		return (_monthNames[self.lang] || _monthNames['en'])[(date || self.date).getMonth()];
	};

	/**
	* @date : (Date) (optional)
	* @return (string) short month name
	*/
	self.getStringMonthShort=function(date){
		return (_monthNamesShort[self.lang] || _monthNamesShort['en'])[(date || self.date).getMonth()];
	};

	/**
	* @d1 : (timestamp)
	* @d2 : (timestamp)
	* @return (string) LIKE : From d1 to d2
	*/
	self.getStringInterval=function(d1, d2){
		if( isNaN(d1) && isNaN(d2) ){
		}else{
			d1=new Date(d1);
			d2=new Date(d2);

			if(d1 && d2){
				var day1=d1.getDate(),
				month1=self.getStringMonthShort(d1),
				year1=d1.getFullYear(),
				day2=d2.getDate(),
				month2=self.getStringMonthShort(d2),
				year2=d2.getFullYear(),
				str1=day1, str2=day2;

				//month
				str2+=" "+month2;
				if(month1 == month2){
				}else{
					str1+=" "+month1;
				}

				//year
				str2+=" "+year2;
				if(year1 == year2){
				}else{
					str1+=" "+year1;
				}

				d1=d2=day1=day2=month1=month2=year1=year2=null;

				switch(self.lang){
					case "fr":
					return "Du "+str1+" au "+str2;
					break;
					default:
					return "From "+str1+" to "+str2;
				}
			}
		}
		return '';
	};

	/**
	* @d1 : (timestamp) date start
	* @d2 : (timestamp) date end
	* @return (object)
	*/
	self.getDiff=function(d1, d2){
		if( isNaN(d1) && isNaN(d2) ){
			return {
				"years":null,
				"months":null,
				"days":null
			};
		}else{
			var dateEnd = new Date(d2),
			dateStart = new Date(d1),
			duree = (dateEnd - dateStart)/86400000,
			years=Math.floor(duree/365.25),
			months=Math.floor(((duree/365.25)-years)*12),
			days=Math.floor(((((duree/365.25)-years)*12)-months)*30.43);
			dateEnd=dateStart=duree=null;
			return {
				"years":years,
				"months":months,
				"days":days
			};
		}
	};
}

//STATIC METHODS
/**
* @return (Date)
*/
myappDate.tomorrow=function(){
	return new Date(new Date().getTime()+86400000);
};

/**
* return year(2-digits) of a date
* @date (Date)
* @return (number)
*/
myappDate.getYear=function(date){
	return parseInt(date.getFullYear().toString().substring(2, 4), 10);
};

/**
* @date (Date)
* @return (number) timestamp in seconds
*/
myappDate.getSTimestamp=function(date){
	return parseInt(date.getTime()/1000, 10);
};

/**
* @number : (string, number)
* @return (string)
*/
myappDate.setTwoDigits=function(number){
	if(number.toString().length<2){
		return "0"+number;
	}else return number;
};