function MyappPayment(){
	//VARS
	var self=this;

	//CONSTS
	var _cards={
		/*"AE":"American Express",*/
		"AX":"American Express",
		"BC":"Bank Card",
		"BL":"Carte Bleu",
		"CB":"Carte Blanche",
		"CS":"CARTA SI",
		/*"DC":"Diners Club",*/
		"DN":"Diners Club",
		"DS":"Discover Card",
		"EC":"Eurocard",
		"EN":"ENROUTE",
		/*"EU":"Eurocard",*/
		"JC":"Japanese Credit Bureau Credit Card",
		"MA":"Maestro",
		"MC":"Master Card",
		"NN":"NOT REQ",
		"PP":"PREPAID",
		"SO":"Solo",
		"TP":"Universal Air Travel Card",
		"VE":"Visa Electron",
		"VI":"VIsa",
		/*"VS":"VIsa"*/
	};

	//FUNCTIONS
	/**
	* @list : (array) get only card provided in list (optional)
	* @return (object) cards list
	*/
	this.getCards=function(list){
		if(typeof list == "object"){
			var __cardsToReturn={};
			for(var i in list){
				if( _cards.hasOwnProperty(list[i]) ){
					__cardsToReturn[list[i]]=_cards[list[i]];
				}
			}
			return __cardsToReturn;
		}else{
			return _cards;
		}
	};
}
/******************************
		STATIC FUNCTIONS
******************************/
/**
* @list : (array) get only card provided in list (optional)
* @return (object) cards list
*/
MyappPayment.getCards=function(list){
	var __mp=new MyappPayment();
	return __mp.getCards(list);
};

//generic checks
MyappPayment.isValidCard=function(cardNumber){
	var ccard = new Array(cardNumber.length),
	i=0,
	sum=0;

	// 6 digit is issuer identifier
	// 1 last digit is check digit
	// most card number > 11 digit
	if(cardNumber.length < 11){
		return false;
	}
	// Init Array with Credit Card Number
	for(i = 0; i < cardNumber.length; i++){
		ccard[i] = parseInt(cardNumber.charAt(i), 10);
	}
	// Run step 1-5 above above
	for(i = 0; i < cardNumber.length; i = i+2){
		ccard[i] = ccard[i] * 2;
		if(ccard[i] > 9){
			ccard[i] = ccard[i] - 9;
		}
	}
	for(i = 0; i < cardNumber.length; i++){
		sum = sum + ccard[i];
	}
	return ((sum%10) == 0);
};

MyappPayment.isValidVISA_MasterCard=function(cardNumber){
	// if you want to accept Mastercard, Visa (Debit/Electron/Credit Card) ONLY!
	if(cardNumber.charAt(0) == '4' && (cardNumber.length == 13 || cardNumber.length == 16)){
		return isValidCard(cardNumber);
	}
	if(cardNumber.charAt(0) == '5' && (cardNumber.charAt(1) == '1' || cardNumber.charAt(1) == '5') && cardNumber.length == 16){
		return isValidCard(cardNumber);
	}
	return false;
};

MyappPayment.checkValid=function(cardNumber){
	if(isValidVISA_MasterCard(cardNumber)){
		alert('Credit Card number is valid VISA/MasterCard');
	}else{
		alert('Credit Card number is NOT valid VISA/MasterCard');
	}
};