/*
This javascript allow you to display information on a map created with canvas.
Dependance : my_process
*/

function myapp_Map(canvas_map, bg_img_path, map_name, map_data, map_area, map_info, bubble_page_selector, legend){
	/*PROPERTIES*/
	var __myMap={};

	var destX = 0;
	var destY = 0;
	var map_width = myapp.custoMap[map_name].size.w;
	var map_height =  myapp.custoMap[map_name].size.h;
    
    var __procuser = false;

	var __headerHeight=55;
	var __cell_dim=50;

	if(canvas_map){
		__myMap.canvas_map=document.getElementById(canvas_map);
		__myMap.context_map=__myMap.canvas_map.getContext("2d");
		
		var imageObj = new Image();
		imageObj.onload = function(){
			__myMap.context_map.drawImage(imageObj, destX, destY, map_width, map_height);

			//display legend
			if(legend){
				__myMap.draw_legend(__myMap.context_map);
			}
		};
		imageObj.src = bg_img_path;
	}

	__myMap.map_name=map_name;

	__myMap.clickProcess=0;

	__myMap.univers_selected="";
	__myMap.shape_selected="";
	__myMap.shape="";
	__myMap.shape_info="";

	__myMap.map_data=map_data;
	__myMap.map_data_area=map_area;
	__myMap.map_info=map_info;

	__myMap.bubble={created:0, zoomable:0};

	__myMap.gpsPin={x:100, y:100, radius:10, animate_sens:1};

	__myMap.zoomFactor=1;

	var gps_userImg= new Image();
	gps_userImg.src="img/myapp/crt_user2.png";
	
	var __univers_color="rgba(153,204,255, 0.5)";
	var __univers_color_shadow="rgba(153,204,255, 0.5)";
	

	/*FUNCTION*/
	/*draw a cell with highlight
	!use context
	*/
	__myMap.myapp_highlight_cell=function(ctx, data, color, colorShadow){
		(color) ? false : color = "#39F";
		(colorShadow) ? false : colorShadow = "rgba(50, 200, 255, 0.5)";

		//shadow params
		ctx.shadowOffsetX = 0;
		ctx.shadowOffsetY = 0;
		ctx.shadowBlur = 5;
		ctx.shadowColor = colorShadow;
		//fill & stroke
		ctx.fillStyle = color;
		ctx.lineWidth = 0.5;
		ctx.strokeStyle = "black";

		if(data){
			switch(data['type']){
				case 'polygon':
				//setTimeout(function(){__myMap.myapp_draw_polygon(ctx, data['points']);}, 150);
				__myMap.myapp_draw_polygon(ctx, data['points']);
				ctx.fill();
				ctx.stroke();
				//__myMap.myapp_draw_polygon(ctx, data['points']);
				break;
				case 'rect':
				//setTimeout(function(){ctx.rect(data['x'], data['y'], data['width'], data['height']);ctx.fill();ctx.stroke();}, 150);
				ctx.rect(data['x'], data['y'], data['width'], data['height']);
				ctx.fill();
				ctx.stroke();
				//ctx.rect(data['x'], data['y'], data['width'], data['height']);
				break;
			}
			//ctx.fill();ctx.stroke();
		}else{
			console.error("data undefined");
		}
	};

	/*draw a polygon
	!use context
	*/
	__myMap.myapp_draw_polygon=function(ctx, points){
		ctx.beginPath();

		ctx.moveTo(points[0][0], points[0][1]);
		for(var item=1 ; item < points.length ; item+=1 ){
			if(points[item]!=""){
				//console.log(__point);
				ctx.lineTo(points[item][0], points[item][1]);
			}
		}
		ctx.closePath();
		item=null;
	};

	/*draw a bubble with text into
	!use context
	@data : contains text to write in bubble
	@x : 
	@y : 
	*/
	__myMap.myapp_draw_bubble=function(data, x, y){
		var ctx=__myMap.context_map;
		var __bubbleFactor=1;

		//redraw
		//__myMap.reDrawCanvas();

		//if zoomable=true, zoomFactor is apply
		if(__myMap.bubble.zoomable){
			__bubbleFactor=__myMap.zoomFactor;
		}

		//measure max length of labels
		ctx.font='normal 600 12px/2 Unknown Font, sans-serif';
		var __label_width=[];
		var __label_measure=ctx.measureText(data['label']['2']);
		__label_width.push(__label_measure.width);
		__label_measure=ctx.measureText(data['label']['3']);
		__label_width.push(__label_measure.width);
		__label_measure=null;
		var padding=20/__bubbleFactor;
		var __max_length=Math.max(__label_width[0], __label_width[1])/__bubbleFactor;

		var w=__max_length+padding;
		var h=padding*3.5;
		__max_length=null;

		ctx.beginPath();
		//bubble tail draw
		ctx.moveTo(x, y);
		ctx.lineTo(x-(padding/2), y-padding);
		//bubble draw
		ctx.quadraticCurveTo(x-(w/2), y-padding, x-(w/2), y-(h/2)-padding);
		ctx.quadraticCurveTo(x-(w/2), y-h-padding, x, y-h-padding);
		ctx.quadraticCurveTo(x+(w/2), y-h-padding, x+(w/2), y-(h/2)-padding);
		ctx.quadraticCurveTo(x+(w/2), y-padding, x, y-padding);
		ctx.closePath();

		//shadow bubble
		ctx.shadowOffsetX = 5;
		ctx.shadowOffsetY = 5;
		ctx.shadowBlur = 5;
		ctx.shadowColor = "rgba(0, 0, 0, 0.5)";
		//bubble fill & stroke
		ctx.lineWidth = 0.5;
		ctx.strokeStyle = "#000";
		ctx.stroke();
		ctx.fillStyle = "#333";
		ctx.fill();
		//shadow text
		ctx.shadowOffsetX = 0;
		ctx.shadowOffsetY = 0;
		ctx.shadowBlur = 0;
		ctx.shadowColor = "rgba(50, 200, 255, 0.5)";
		//text fill
		ctx.fillStyle="#fff";
		ctx.textAlign="center";
		ctx.font='normal 600 12px/2 Unknown Font, sans-serif';
		ctx.fillText(data['label']['2'], x, y-padding*3);
		ctx.font='normal 400 12px/2 Unknown Font, sans-serif';
		ctx.fillText(data['label']['3'], x, y-padding*2);

		__myMap.bubble.created=1;
		__myMap.bubble.x=x-(w/2);
		__myMap.bubble.y=y-h-padding;
		__myMap.bubble.w=w;
		__myMap.bubble.h=h;
		__myMap.bubble.points=[[x-(w/2), y-h-padding],[x+(w/2), y-h-padding],[x+(w/2), y-padding],[x-(w/2), y-padding]];
		__myMap.bubble.data=data;

		//console.log("Bubble - Start point : "+__myMap.bubble.points[0][0]+"   "+__myMap.bubble.points[0][1]);
		//console.log("Bubble - End point : "+__myMap.bubble.points[2][0]+"   "+__myMap.bubble.points[2][1]);
		//console.log(__myMap.bubble.points);

		myapp.scrollCenter(__myMap.bubble.points[0][0]*__myMap.zoomFactor, __myMap.bubble.points[0][1]*__myMap.zoomFactor, w, h);

		padding = null;
	};

	/*
	!use context
	*/
	__myMap.myapp_gps_draw_position=function(){
		__myMap.context_geoloc.save();
		try{
		__myMap.canvas_geoloc.width = __myMap.canvas_geoloc.width;
		}catch(e){
		}
		__myMap.context_geoloc.clearRect(0,0,map_width,map_height);

		//fill & stroke settings
		__myMap.context_geoloc.fillStyle = "#3c6";
		__myMap.context_geoloc.lineWidth = 0.5;
		__myMap.context_geoloc.strokeStyle = "#3c9";
		
		__myMap.context_geoloc.arc(__myMap.gpsPin.x,__myMap.gpsPin.y,__myMap.gpsPin.radius,0,Math.PI*2,true);
		//__myMap.context_geoloc.clip();
		__myMap.context_geoloc.fill();
		__myMap.context_geoloc.stroke();
		__myMap.context_geoloc.drawImage(gps_userImg, __myMap.gpsPin.x-__myMap.gpsPin.radius, __myMap.gpsPin.y-__myMap.gpsPin.radius, __myMap.gpsPin.radius*2, __myMap.gpsPin.radius*2);
		
		// TODO check anim
		if(__mainThis.myapp.sup_canvas_anim){
			if(__myMap.gpsPin.animate_sens){
				__myMap.gpsPin.radius--;
				if(__myMap.gpsPin.radius==9) __myMap.gpsPin.animate_sens=false;
			}else{
				__myMap.gpsPin.radius++;
				if(__myMap.gpsPin.radius=11) __myMap.gpsPin.animate_sens=true;
			}
			__myMap.context_geoloc.restore();
			
			
			__myMap.gpsPin.draw_timeout=setTimeout(__myMap.myapp_gps_draw_position, 200);
		}
	};

	__myMap.myapp_gps_refresh_pos=function(){
		myapp.checkLocation('myapp.getCurrentUserPos');
	};
	
	__myMap.getCurrentUserPos=function(){
		var __pos=myapp.posLongLat(__myMap.map_name, __mainThis.myapp.localization.longitude, __mainThis.myapp.localization.latitude);
		__myMap.gpsPin.x=__pos.px;
		__myMap.gpsPin.y=__pos.py;
		__myMap.gpsPin.pos_timeout=setTimeout(__myMap.myapp_gps_refresh_pos, 20000);
	};

	__myMap.myapp_get_user_pos=function(){
        if(!__procuser){
            __procuser = true;
            var __pos=myapp.posLongLat(__myMap.map_name, __mainThis.myapp.localization.longitude, __mainThis.myapp.localization.latitude);
            __myMap.gpsPin.x = __pos.px;
            __myMap.gpsPin.y = __pos.py;
//            alert(__pos.px+":"+ __pos.py+":"+__mainThis.myapp.localization.longitude+":"+__mainThis.myapp.localization.latitude);
            
            __myMap.myapp_gps_draw_position();
            
            __myMap.gpsPin.pos_timeout = setTimeout(__myMap.myapp_gps_refresh_pos, 5000);
            __procuser = false;
        }
	};
    
	__myMap.myapp_gps_pos=function(ctx, x, y){
	};

	/*manage click on map*/
	__myMap.myapp_canvas_click=function(e){
		if(__myMap.clickProcess){
		}else{
			__myMap.clickProcess=1;

			//console.log("mouseclick : "+e.x+" "+e.y);
			//__mainThis.myapp.iscroll.scrollTo(-400,-300);
			var __off=__mainThis.myapp.iscroll.getOffset();
			//console.log("iscroll : "+off.x+" "+off.y);
			//alert(document.x);

			var __mapX = (e.x+__off.x)/__myMap.zoomFactor;
			var __mapY = ((e.y-__headerHeight)+__off.y)/__myMap.zoomFactor;

			//console.log("x : "+__mapX+" y : "+__mapY);

			var __areaX=Math.floor(__mapX/__cell_dim);
			var __areaY=Math.floor(__mapY/__cell_dim);

			var __area_id=__areaX+"_"+__areaY;

			var __points;

			if(__myMap.bubble.created && __myMap.shape_selected!="" && __myMap.pnpoly(__myMap.arrPntToObjPnt(__myMap.bubble.points), {x:__mapX, y:__mapY})){
				$.mobile.changePage(bubble_page_selector, "fade", false, null, {id:__myMap.shape_info.id, univers:__myMap.univers_selected});
			}else{
				__myMap.reDrawCanvas();

				//browse id in __myMap.map_data_area[__area_id]
				if(__myMap.map_data_area[__area_id]){
					if(__myMap.map_data_area[__area_id].length==1){
						__myMap.shape=__myMap.map_data[__myMap.map_data_area[__area_id][0]];
						(__myMap.shape_clicked(__myMap.shape, __mapX, __mapY)) ? __myMap.shape_selected=__myMap.map_data_area[__area_id][0] : false;
					}else{
						for(var __i=0;__i<__myMap.map_data_area[__area_id].length;__i++){
							__myMap.shape=__myMap.map_data[__myMap.map_data_area[__area_id][__i]];
							if(__myMap.shape_clicked(__myMap.shape, __mapX, __mapY)){
								__myMap.shape_selected=__myMap.map_data_area[__area_id][__i];
								break;
							}
						}
					}
				}

				//highlight shape
				for(var __x in __myMap.map_info){
					for(var __y in __myMap.map_info[__x]){
						if(__y==__myMap.shape_selected){
							__myMap.shape_info=__myMap.map_info[__x][__y];
							__myMap.univers_selected=__x;
							break;
						}
					}
					if(__myMap.shape_info!="") break;
				}

				if(__myMap.shape_selected==""){
				}else{
					__myMap.myapp_highlight_univers();
					__myMap.myapp_highlight_cell(__myMap.context_map, __myMap.shape);
					__myMap.myapp_draw_bubble(__myMap.shape_info, __mapX, __mapY);
				}
			}

			__myMap.clickProcess = 0;
		}
	};

	/*draw many shapes with symbolized an univers*/
	__myMap.myapp_highlight_univers=function(univers){
		if(univers){
		}else{
			univers=__myMap.univers_selected;
		}

		if(univers){
			for(var __x in __myMap.map_info[univers]){
				__myMap.myapp_highlight_cell(__myMap.context_map, __myMap.map_data[__x], __univers_color, __univers_color_shadow);
			}
			univers=null;
		}else{
			console.error("[__myMap] - None univers selected.");
		}
	};

	/*clear some canvas and properties*/
	__myMap.clearSelection=function(){
		__myMap.shape_selected="";
		__myMap.shape="";
		__myMap.shape_info="";
		__myMap.bubble={};
		try{
			__myMap.canvas_map.width = __myMap.canvas_map.width;
		}catch(e){
		}
		__myMap.context_map.clearRect(0, 0, __myMap.context_map.width, __myMap.context_map.height);
	};

	/* return 
	@shape : shape with points proprieties
	@x : x of click
	@y : y of click
	*/
	__myMap.shape_clicked=function(shape, x, y){
		var __points=[];

		for(var __j=0;__j<shape['points'].length;__j++){
			__points.push({x:shape['points'][__j][0], y:shape['points'][__j][1]});
		}
		return(__myMap.pnpoly(__points, {x: x, y: y}));
	};

	/*function isPointInPoly(poly, pt){
		for(var c = false, i = -1, l = poly.length, j = l - 1; ++i < l; j = i)
			((poly[i].y <= pt.y && pt.y < poly[j].y) || (poly[j].y <= pt.y && pt.y < poly[i].y))
			&& (pt.x < (poly[j].x - poly[i].x) * (pt.y - poly[i].y) / (poly[j].y - poly[i].y) + poly[i].x)
			&& (c = !c);
		return c;
	};*/

	/*check if a point is in a polygon
	*/
	__myMap.pnpoly=function(poly, pt){
		var i, j, c = 0, npol = poly.length; 
		for (i = 0, j = npol-1; i < npol; j = i++){
			/*console.log("i : "+i);
			console.log("j : "+j);
			console.log("c : "+c);*/
			if ((((poly[i].y <= pt.y) && (pt.y < poly[j].y)) || 
			((poly[j].y <= pt.y) && (pt.y < poly[i].y))) && 
			(pt.x < (poly[j].x - poly[i].x) * (pt.y - poly[i].y) / (poly[j].y - poly[i].y) + poly[i].x)) { 
				c =!c; 
			} 
		} 
		return c; 
	};

	__myMap.arrPntToObjPnt=function(arrPnt){
		var __objPnt=[];

		for(var __i=0;__i<arrPnt.length;__i++){
			__objPnt.push({x:arrPnt[__i][0], y:arrPnt[__i][1]});
		}
		__i=null;

		return __objPnt;
	};

	__myMap.deleteMap=function(){
		this.clearSelection();
		clearTimeout(__myMap.gpsPin.draw_timeout);
		clearTimeout(__myMap.gpsPin.pos_timeout);
         __procuser = false;
		delete this;
	};

	__myMap.draw_legend=function(ctx){
		ctx.globalCompositeOperation='source-over';
		ctx.save();
		var __nb_legend=1;
		var __label_maxWidth=0;
		for(var __x in legend){
			__nb_legend++;
			var __label_measure=ctx.measureText(legend[__x]["label"]);
			if(__label_maxWidth<__label_measure.width){
				__label_maxWidth=__label_measure.width;
			}
			__label_measure=null;
		}
		var __rectW=__label_maxWidth+20+10+5;//max width of labels + 20px(padding for rect) + 10px(color block size) +5px(marge for block)
		var __rectH=__nb_legend*20;//nb label * 20px(line_height)

		//draw bg legend
		/*ctx.strokeStyle="#000";
		ctx.strokeRect(0,0,__rectW,__rectH);*/

		ctx.restore();
		__nb_legend=0;

		for(var __x in legend){
			ctx.save();
			ctx.fillStyle=legend[__x]["color"];
			ctx.fillText(legend[__x]["label"], 20, 20+20*__nb_legend);
			ctx.fillRect(5,10+20*__nb_legend,10,10);

			ctx.restore();
			__nb_legend++;
		}

		ctx=__rectH=__rectW=__label_maxWidth=__x=null;
	};
	
	__myMap.setZoomFactor=function(fact){
		__myMap.zoomFactor=fact;
		//resize bubble
		if(__myMap.bubble.created && __myMap.bubble.zoomable){
			__myMap.myapp_draw_bubble(__myMap.bubble.data, __myMap.bubble.x/__myMap.zoomFactor, __myMap.bubble.y/__myMap.zoomFactor);
		}
	};

	__myMap.highlightCellById=function(univers, id){
		__myMap.shape_selected=id;

		__myMap.myapp_highlight_univers(univers);
		__myMap.myapp_highlight_cell(__myMap.context_map, map_data[id]);

		var __center=__myMap.centerOfForms(map_data[id]);
		__myMap.myapp_draw_bubble(__myMap.map_info[univers][id], __center.x, __center.y);

		__center=__x=__y=null;
	};

	__myMap.centerOfRect=function(originX,originY,width,height){
		var __x=parseInt(originX, 10)+(width/2);
		var __y=parseInt(originY, 10)+(height/2);

		return {"x":__x,"y":__y};
	};

	__myMap.centerOfPolygon=function(pts){
		var __x=0;
		var __y=0;

		var nPts = pts.length;
		var f;
		var j=nPts-1;
		var p1; var p2;

		for (var i=0;i<nPts;j=i++) {
			p1=pts[i];
			p2=pts[j];
			f=p1[0]*p2[1]-p2[0]*p1[1];
			__x+=(p1[0]+p2[0])*f;
			__y+=(p1[1]+p2[1])*f;
		}

		f=__myMap.centerOfPolygonArea(pts)*6;

		nPts=i=j=p1=p2=pts=null;

		return {"x":__x/f,"y":__y/f};
	};
	
	__myMap.centerOfPolygonArea=function(pts){
		var area=0;
		var nPts = pts.length;
		var j=nPts-1;
		var p1; var p2;

		for (var i=0;i<nPts;j=i++) {
			p1=pts[i]; p2=pts[j];
			area+=p1[0]*p2[1];
			area-=p1[1]*p2[0];
		}

		nPts=pts=i=j=p1=p2=null;

		return area/2;
	};

	__myMap.centerOfForms=function(data){
		switch(data["type"]){
			case "polygon":
				return __myMap.centerOfPolygon(data['points']);
			break;

			case "rect":
				return __myMap.centerOfRect(data['x'],data['y'],data['width'],data['height']);
			break;
		}
	};

	/*transform a string of points into array*/
	__myMap.ptsStrToPtsArr=function(str){
		var __pts=Array();

		var __oldPts=str.split(" ");
		for(var __i in __oldPts){
			var __pt=__oldPts[__i].split(",");
			__pts.push({"x":__pt[0], "y":__pt[1]});
		}
		__oldPts=__pt=__i=null;

		return __pts;
	};

	/*
	en:draw grid on map
	fr:dessine des repères sur la carte
	@canvas,
	@ctx,
	@cellSize
	*/
	__myMap.drawGridMark=function(canvas, ctx, cellSize){
		for(var __i=0;__i<canvas.width;__i+=cellSize){
			ctx.moveTo(__i,0);
			ctx.lineTo(__i,canvas.height);
		}

		__i=null;

		for(var __i=0;__i<canvas.height;__i+=cellSize){
			ctx.moveTo(0,__i);
			ctx.lineTo(canvas.width, __i);
		}

		__i=null;

		ctx.closePath();
		ctx.strokeStyle="#f00";
		ctx.stroke();
	};

	__myMap.reDrawCanvas=function(canvas, ctx){
		(canvas) ? false : canvas=__myMap.canvas_map;
		(ctx) ? false : ctx=__myMap.context_map;

		__myMap.clearSelection();

		//draw background image
		__myMap.context_map.drawImage(imageObj, destX, destY, map_width, map_height);

		//display legend
		if(legend){
			__myMap.draw_legend(__myMap.context_map);
		}
	};

	//add event on canvas
	if(canvas_map){
		__myMap.canvas_map.addEventListener("click", __myMap.myapp_canvas_click, false);
	}

/*	
	//init gps
	if(canvas_geoloc){
		setTimeout(function(){
			__myMap.myapp_gps_pos(__myMap.context_geoloc,50,50);
		}, 5000);
	}
*/
	
	//test for geoloc
	/*test_x=100;
	test_y=100;
	setInterval(function(){
		test_x+=10;
		test_y+=10;
		__myMap.gpsPin.x=test_x;
		__myMap.gpsPin.y=test_y;
	}, 2000);*/

	
	return __myMap;
};