function natEvents(){
	var self=this,
	__customEvents=[],
	__consts={
		aids:{
			galleryPhotos:104,
			galleryVideos:10000,
			geoloc:49999
		}
	},
	__events;

	this.run=function run(){
		_bindClickEvents();
	};

	this.stop=function stop(){
		_unbindClickEvents();
	};

	/**
	*
	*/
	this.addCustomEvent=function addCustomEvent(){
		if( arguments[0] && arguments[0] instanceof CustomEvent ){
			__customEvents.push(arguments[0]);
		}else if( arguments[0] && typeof arguments[0] == 'string' && arguments[1] && typeof arguments[1] == 'function' ){
			__customEvents.push(new CustomEvent(arguments[0], arguments[1]));
		}else{
			throw "natEvents.addCustomEvent : bad parameters sent.";
		}
	};

	/**
	*	@param id : (int) aid
	* 	@return (bool) true if aid is a specific aid, false otherwise
	*/
	this.checkAndDoSpecificAid=function checkAndDoSpecificAid(id){
		if(id == __consts.aids.galleryPhotos) natEvents.I_native_event(["gallery"]);
		else if(id == __consts.aids.galleryVideos) natEvents.I_native_event(["video"]);
		else if(id == __consts.aids.geoloc) natEvents.I_native_event(["geoloc"]);
		else return false;
		return true;
	};

	/********************
	*		PRIVATE
	*********************/

	/******* TOUCH *******/
	var touch;

	function setTouch(evt){
		touch = {
			moved : false,
			startX : evt.touches.item(0).pageX,
			startY : evt.touches.item(0).pageY,
			startTime : ( new Date() ).getTime()
		};
	}

	function unsetTouch(){
		touch = null;
	}
	
	function touch_start(evt){
		setTouch(evt);
	}

	function touch_move(evt){
		if (Math.abs(evt.touches[0].clientX - touch.startX) > 10 || Math.abs(evt.touches[0].clientY - touch.startY) > 10) {
            touch.moved = true;
        }
	}

	function touch_end(evt){
		//tap detection
		if (!touch.moved) {
			_clickEvents(evt);
		}
	}

	function touch_cancel(evt){
		unsetTouch();
	}
	
	function _bindClickEvents(){
		if(natEvents.isIDevice()){
			document.body.addEventListener("touchstart", touch_start);
			document.body.addEventListener("touchmove", touch_move);
			document.body.addEventListener("touchend", touch_end);
			document.body.addEventListener("touchcancel", touch_cancel);
		}else{
			//android
			document.addEventListener("click", _clickEvents);
		}
	}

	function _unbindClickEvents(){
		if(natEvents.isIDevice){
			//document.body.removeEventListener("touchstart", touch_start);
			document.body.removeEventListener("touchmove", touch_move);
			document.body.removeEventListener("touchend", touch_end);
		}else{
			//android
			document.removeEventListener("click", _clickEvents);
		}
	}

	function _checkCustomEvents(element){
		var __i, __j, __sel;

		for(__i=0;__i<__customEvents.length;__i++){
			__sel=document.querySelectorAll(__customEvents[__i].selector);
			if(__sel){
				for(__j=0;__j<__sel.length;__j++){
					if( element == __sel.item(__j) ){
						__customEvents[__i].func(element);
						return true;
					}
				}
			}
		}
		__i=__j=__sel=null;
		return false;
	}

	function _clickEvents(e){
		for (var element = e.target; element; element = element.parentNode) {
			//stats action
			_checkStatsAction(element);

			//check custom events
			if(__customEvents && 0<__customEvents.length){
				if( _checkCustomEvents(element) ) return;
			}

			//click events
            
			if( _bindClickOnSaveURL(element) ) return;
            if( _bindClickOnLoadURL(element) ) return;
			if( _bindClickToPageId(element) ) return;
			if( _bindClickAddEventInCalendar(element) ) return;
			if( _bindClickAddEventInFavorite(element) ) return;
			if( _bindClickOnDatePicker(element) ) return;
			if( _bindClickOnTel(element) ) return;
			if( _bindClickOnShare(element) ) return;
			if( _bindClickOnGeoloc(element) ) return;
			if( _bindClickOnImgToZoom(element) ) return;
			if( _bindClickOnAlbumOpen(element) ) return;
			if( _bindClickOnGetGps(element) ) return;
			if( _bindClickOnGallery(element) ) return;
			if( _bindClickOnVideo(element) ) return;
			if( _bindClickOnPlayVideo(element) ) return;
			if( _bindClickOnPicker(element) ) return;
			if( _bindClickOnList(element) ) return;
			if( _bindClickOnSimpleShare(element) ) return;
			if( _bindClickOnShowDialog(element) ) return;
			if( _bindClickOnMyAccount(element) ) return;
			if( _bindClickOnGeolocForEvent(element) ) return;
			if( _bindClickOnGeolocPOI(element) ) return;
            if( _bindClickOnMailTo(element) ) return;
            if( _bindLiClick(element) ) return;
			if( _bindClickToPage(element) ) return;
		}
	}
    
	function _checkStatsAction(element){
		if( element.nodeName.toUpperCase() == "A" && element.hasAttribute("action") && element.getAttribute("action") ){
			natEvents.I_native_event(["statsAdd", element.getAttribute("action")]);
		}
	}
    
	/******************************
	*		Click Events functions
	******************************/
	function _bindLiClick(element){
		if( element.nodeName.toUpperCase() == "LI" && element.hasAttribute("my-id") ){
			var __id=element.getAttribute("my-id");
            var __titletype = element.getAttribute("data-title-type");
            var __titlevalue = element.getAttribute("data-title-value");
            var __titlevalueisnotnull = __titlevalue != null;
            
            if(__titletype == "static" && __titlevalueisnotnull)
            {
                if(self.checkAndDoSpecificAid(__id));
                else natEvents.I_native_event(["clickOnLI", __id, __titlevalue]);
            }
            else if(__titletype == "dynamic" && __titlevalueisnotnull)
            {
                var __pid = element.querySelector('[pid="'+__titlevalue+'"]');
                var __value = __pid.innerHTML;
                
                if(self.checkAndDoSpecificAid(__id));
                else natEvents.I_native_event(["clickOnLI", __id, __value]);
            }
            else
            {
                if(self.checkAndDoSpecificAid(__id));
                else natEvents.I_native_event(["clickOnLI", __id]);
            }
            
			return true;
		}
		return false;
	}
    
	function _bindClickToPage(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "clickToPage" ){
				natEvents.I_native_event(["clickToPage", element.getAttribute("my-to")]);
				return true;
			}
		}
		return false;
	}
    
    function _bindClickToPageId(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "clickToPageId" ){
				natEvents.I_native_event(
                    [
                     "clickToPageId",
                     natEvents.getElementValueByPid(element.getAttribute("my-to"),element),
                     natEvents.getElementValueByPid(element.getAttribute("my-aid"),element)
                     ]
                );
				return true;
			}
		}
		return false;
	}

	function _bindClickAddEventInCalendar(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "calendar" ){
				natEvents.I_native_event(
					[
					"calendar",
					natEvents.getElementValueByPid(element.getAttribute("my-subject")),
					natEvents.getElementValueByPid(element.getAttribute("my-startDate")),
					natEvents.getElementValueByPid(element.getAttribute("my-endDate")),
					natEvents.getElementValueByPid(element.getAttribute("my-location")),
					natEvents.getElementValueByPid(element.getAttribute("my-locationURL"))
					]
				);
				return true;
			}
		}
		return false;
	}
    
    function _bindClickAddEventInFavorite(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "favorite" ){
				natEvents.I_native_event(
                                         [
                                          "favorite"
                                          ]
                                         );
				return true;
			}
		}
		return false;
	}
    
	function _bindClickOnDatePicker(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "datepicker" ){
				natEvents.I_native_event(
					[
					"datepicker",
					element.getAttribute("my-callback") || '',
					element.getAttribute("my-startDate") || 'date'
					]
				);
				return true;
			}
		}
		return false;
	}
    
	function _bindClickOnTel(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "tel" ){
                
                var newElement = natEvents.getBetterItemToParse(element);
                
				natEvents.I_native_event(
					[
					"tel",
                     natEvents.getElementValueByPid(element.getAttribute("my-tel"), newElement),
                     natEvents.getElementValueByPid(element.getAttribute("my-message"), newElement)
					]
				);
				return true;
			}
		}
		return false;
	}
    
	function _bindClickOnShare(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "share" ){
				natEvents.I_native_event(
					[
					"share",
					element.getAttribute("my-buttons") || ''
					]
				);
				return true;
			}
		}
		return false;
	}
    
	function _bindClickOnGeoloc(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "geoloc" ){
				natEvents.I_native_event(
					[
					"geoloc",
					( (element.getAttribute("my-lng") || 0) + ',' + (element.getAttribute("my-lat") || 0) ),
					element.getAttribute("my-type") || 0,
					element.getAttribute("my-address") || ''
					]
				);
				return true;
			}
		}
		return false;
	}
    
	function _bindClickOnImgToZoom(element){
		if( element.nodeName.toUpperCase() == "IMG" && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "imgZoom" ){
				natEvents.I_native_event(
					[
					"imgZoom",
					element.getAttribute("my-id") || ''
					]
				);
				return true;
			}
		}
		return false;
	}
    
	function _bindClickOnAlbumOpen(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "albumOpen" ){
				natEvents.I_native_event(
					[
					"albumOpen",
					element.getAttribute("my-id") || ''
					]
				);
				return true;
			}
		}
		return false;
	}
    
	function _bindClickOnGetGps(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "getgps" ){
				natEvents.I_native_event(
					[
					"getgps",
					element.getAttribute("my-cb") || ''
					]
				);
				return true;
			}
		}
		return false;
	}
    
	function _bindClickOnSaveURL(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "saveurl" ){
				natEvents.I_native_event(
					[
					"saveurl",
					element.getAttribute("my-url") || ''
					]
				);
				return true;
			}
		}
		return false;
	}
    
	function _bindClickOnGallery(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "gallery" ){
				natEvents.I_native_event(
					[
					"gallery"
					]
				);
				return true;
			}
		}
		return false;
	}
    
	function _bindClickOnVideo(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "video" ){
				natEvents.I_native_event(
					[
					"video",
					element.getAttribute("my-datas") || ''
					]
				);
				return true;
			}
		}
		return false;
	}
    
	function _bindClickOnPlayVideo(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "playvideo" ){
				natEvents.I_native_event(
					[
					"playvideo",
					element.getAttribute("my-url") || ''
					]
				);
				return true;
			}
		}
		return false;
	}
    
    
    function _bindClickOnMailTo(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "mailto" ){
                
                var newElement = natEvents.getBetterItemToParse(element);

                
				natEvents.I_native_event(
                                         [
                                          "mailto",
                                          "%_MAIL_%?subject="+encodeURIComponent(natEvents.getElementValueByPid(element.getAttribute("my-subject"),newElement))+"&"+
                                         "body="+encodeURIComponent(natEvents.getElementValueByPid(element.getAttribute("my-body"),newElement))
                                          ]
                                         );
				return true;
			}
		}
		return false;
	}
    
	function _bindClickOnPicker(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "picker" ){
				natEvents.I_native_event(
					[
					"picker"
					]
				);
			}
		}
		return false;
	}
    
	function _bindClickOnList(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "list" ){
				natEvents.I_native_event(
					[
					"list"
					]
				);
				return true;
			}
		}
		return false;
	}
    
	function _bindClickOnSimpleShare(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "simpleshare" ){
                
                var newElement = natEvents.getBetterItemToParse(element),
                __eventsArr=[
                	"simpleshare",
					natEvents.getElementValueByPid(element.getAttribute("my-subject"),newElement),
					natEvents.getElementValueByPid(element.getAttribute("my-body"),newElement)
                ];

                if( element.hasAttribute("my-image") ){
                	__eventsArr.push(natEvents.getElementValueByPid(element.getAttribute("my-image"),newElement));
                }

				natEvents.I_native_event(__eventsArr);
				return true;
			}
		}
		return false;
	}
    
	function _bindClickOnShowDialog(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "showdialog" ){
				natEvents.I_native_event(
					[
					"showdialog",
					element.getAttribute("my-message") || ''
					]
				);
				return true;
			}
		}
		return false;
	}
    
	function _bindClickOnMyAccount(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "my-account" ){
				natEvents.I_native_event(
					[
					"my-account"
					]
				);
				return true;
			}
		}
		return false;
	}
    
	function _bindClickOnLoadURL(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && (element.hasAttribute("my-event") || element.hasAttribute("action")) ){
			if( element.hasAttribute("my-event") && element.getAttribute("my-event") == "loadurl" ){
				natEvents.I_native_event(
                                         [
                                          "loadurl",
                                          element.getAttribute("my-url") || '',
                                          element.getAttribute("my-title") || '',
                                          element.getAttribute("my-bool") || 0
                                          ]
                                         );
				return true;
			}
			// Not used, because now, for the old version, the action link will be called in the method : __I_native_event
			/* else if( element.hasAttribute("action") && element.getAttribute("action") == "link" ){
				natEvents.I_native_event(
                                         [
                                          "loadurl",
                                          element.getAttribute("href") || '',
                                          element.getAttribute("my-title") || '',
                                          element.getAttribute("my-bool") || 0
                                          ]
                                         );
				return true;
			}*/
		}
		return false;
	}

    function _bindClickOnGeolocForEvent(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "geolocforevent" ){
				natEvents.I_native_event(
					[
					"geolocforevent",
					natEvents.getElementValueByPid(element.getAttribute("my-poiid") || '')
					]
				);
				return true;
			}
		}
		return false;
	}

	function _bindClickOnGeolocPOI(element){
		if( (element.nodeName.toUpperCase() == "BUTTON" || element.nodeName.toUpperCase() == "A") && element.hasAttribute("my-event") ){
			if( element.getAttribute("my-event") == "geolocpoi" ){
				natEvents.I_native_event(
					[
					"geolocpoi",
					natEvents.getElementValueByPid(element.getAttribute("my-datas") || '')
					]
				);
				return true;
			}
		}
		return false;
	}

	//JB : important to not move this var
	__events={
		"saveurl" : _bindClickOnSaveURL,
        "loadurl" : _bindClickOnLoadURL,
		"clickToPageId" : _bindClickToPageId,
		"calendar" : _bindClickAddEventInCalendar,
		"favorite" : _bindClickAddEventInFavorite,
		"datepicker" : _bindClickOnDatePicker,
		"tel" : _bindClickOnTel,
		"share" : _bindClickOnShare,
		"geoloc" : _bindClickOnGeoloc,
		"imgZoom" : _bindClickOnImgToZoom,
		"albumOpen" : _bindClickOnAlbumOpen,
		"getgps" : _bindClickOnGetGps,
		"gallery" : _bindClickOnGallery,
		"video" : _bindClickOnVideo,
		"playvideo" : _bindClickOnPlayVideo,
		"picker" : _bindClickOnPicker,
		"list" : _bindClickOnList,
		"simpleshare" : _bindClickOnSimpleShare,
		"showdialog" : _bindClickOnShowDialog,
		"my-account" : _bindClickOnMyAccount,
		"geolocforevent" : _bindClickOnGeolocForEvent,
		"geolocpoi" : _bindClickOnGeolocPOI,
        "mailto" : _bindClickOnMailTo,
        "clickOnLI" : _bindLiClick,
		"clickToPage" : _bindClickToPage,
	};
	/********************
	*		PUBLIC
	*********************/

	/**
	* call an event function by its name
	* @param eventName : (string) @see documentation : native-web-communication.html
	* @param element : (DOMElement)
	*/
	this.triggerEventOn=function(eventName, element){
		if( __events && __events.hasOwnProperty(eventName) && typeof __events[eventName] == "function" ){
			__events[eventName](element);
		}
	};
}

/** Mimic old behavior to keep compatibility */
function __I_native_event(event) {
    console.log("__I_native_event call");
	natEvents.I_native_event(event);
}

/********************
STATIC
*********************/
natEvents.isAndroid=function(){
	return (/android/gi).test(navigator.appVersion);
};

natEvents.isIDevice=function(){
	return (/iphone|ipad/gi).test(navigator.appVersion);
};

natEvents.getVendor=function(){
	return (/webkit/i).test(navigator.appVersion) ? 'webkit' :
	(/firefox/i).test(navigator.userAgent) ? 'Moz' :
	'opera' in window ? 'O' : '';
};

natEvents.getElementValue=function(element){
    if(!element){
        return "";
    }
    
    var tag=element.tagName,value;
    console.log('passe dans natEvents.getElementValue');
    
    switch(tag){
        case "IMG":
            value=element.getAttribute("src");
            break;
            
        case "INPUT":
        case "SELECT":
            console.log("Passe into Imput or Select tag : "+tag);
            value=element.value;
            break;
            
        default:
            console.log("Passe into innerHTML : "+tag);
            value=element.innerHTML;
            break;
    }
    
    return value;
};

natEvents.getElementValueByPid=function(pid,element){
	element= element?element:document;

	if(pid){
		var pidArray = pid.split(","),
		res = "",
		i;

		for(i = 0; i < pidArray.length; i++) {
            if(natEvents.getElementValue(element.querySelector("[pid='"+pidArray[i]+"']"))){
                res += " "+natEvents.getElementValue(element.querySelector("[pid='"+pidArray[i]+"']"));
            }else if(element.querySelector("[pid='"+pidArray[i]+"']")){
                res += " ";
            }else{
                res += " "+pidArray[i];
            }
		}

	    return res;
	}
	return "";
};

natEvents.getBetterItemToParse = function(element){
    var newElement = element,
    liFound = false;

    while(liFound == false){
        if(newElement.parentNode != null){
            // If list item found
            newElement = newElement.parentNode;
            if(newElement.tagName == "LI"){
                liFound = true;
            }
        }
        // If it's the high level and not found list item (page case)
        else{
            liFound = true;
        }
    }
    return newElement;
};

natEvents.I_native_event=function(event){
	if(event instanceof Array){
		var __tmp="";
		for(var __i=0;__i<event.length;__i++){
			__tmp+=encodeURIComponent(event[__i])+':';
		}
		event=__tmp.slice(0, -1);
		__tmp=__i=null;
	}
    
	if(natEvents.isIDevice()){
		try{
			iFrame = document.createElement("IFRAME");
			iFrame.setAttribute("src", 'myapp://' + event);
            iFrame.setAttribute("style",'display:none');
			document.body.appendChild(iFrame);
			document.body.removeChild(iFrame);
			iFrame = null;
		}catch(err){
		}
	}else if(natEvents.isAndroid()){
		if(typeof(myapp.androidEvent) != "undefined"){
			console.log('i_native_event '+event);
			myapp.androidEvent(event);
		}else console.log("android js interface undefined");
	}
};

natEvents.init=function(){
	var __ne=new natEvents();
	__ne.run();
	return __ne;
};

natEvents.kill=function(){
	var __ne=new natEvents();
	__ne.stop();
	__ne=null;
};

natEvents.loadScript=function(url, callback){		
    // Adding the script tag to the head as suggested before		
	    var head = document.getElementsByTagName('head')[0],		
	    script = document.createElement('script');		
	    script.type = 'text/javascript';		
	    script.src = url;		
			
	    // Then bind the event to the callback function.		
	    // There are several events for cross browser compatibility.		
	    if( typeof callback == "function"){		
	        script.onreadystatechange = callback;		
	        script.onload = callback;		
	    }		
			
	    // Fire the loading		
	    head.appendChild(script);
};		
			
natEvents.loadStyle=function(url, callback){		
	    // Adding the link tag to the head as suggested before		
	    var head = document.getElementsByTagName('head')[0],		
	    style = document.createElement('link');		
	    style.rel = 'stylesheet';		
	    style.href = url;		
			
	    // Then bind the event to the callback function.		
	    // There are several events for cross browser compatibility.		
	    if( typeof callback == "function"){		
	        style.onreadystatechange = callback;		
	        style.onload = callback;		
	    }		
			
	    // Fire the loading		
	    head.appendChild(style);		
};

/**
* @param element : (DOMElement)
* @param value : (string) value to inject
* @param pathAlterPicture : (string) @see in IOS project
* @param pathSpinner : (string) @see in IOS project
* @param documentsDirectory : (string) @see in IOS project
*/
/*natEvents.injection = function(element, value, pathAlterPicture, pathSpinner, documentsDirectory){
	var __type = element.getAttribute('my-ctype'),
	__pid = element.getAttribute('pid');

	natEvents.blockId(__pid, value);

	if( value ){
		//dont inject anything
	}else{
	    switch(type){
	  		case 'image' :
	    	if(datas['imageExist'] == 'no'){
	          	element.setAttribute('src', pathAlterPicture);
	          	resizeImageWithPercent(element);
	        }else if(datas['status'] == 0){
	        	element.setAttribute('id',value.substr(0,value.lastIndexOf('.')));
	            element.setAttribute('src',pathSpinner);
	            resizeImageWithPercent(element);
	        }else{
	            element.setAttribute('src', documentsDirectory+value);
	            element.setAttribute('onerror','this.src="'+pathAlterPicture+'"');
	            resizeImageWithPercent(element);
	        }
	        break;
	    	case 'imagelocal' :
	        element.setAttribute('src', value);
	        element.setAttribute('onerror','this.src="'+pathAlterPicture+'"');
	        resizeImageWithPercent(element);
	        break;
	    	case 'string' :
	        element.innerHTML = ((value == undefined)?'':value);
	        break;
	    	case 'html' :
	        element.innerHTML = ((value == undefined)?'':value);
	        break;
			case 'date' :
			// @todo implement
			break;
			case 'table':
			// @todo implement
			break;
			case 'tablist':
			// @todo implement
			break;
			case 'video':
			// @todo implement
			break;
			case 'link':
			element.setAttribute('href', value);
			break;
			case 'accordion_menu':
			// @todo implement
			break;
			case 'timestamp':
			// @todo implement
			break;
			case 'email':
			element.setAttribute('href', 'mailto:'+value);
			break;
			case 'phone':
			element.setAttribute('href', 'tel:'+value);
			var __textElements = element.querySelectorAll('.phoneText');
			if( __textElements ){
				for(var __i=0;__i<__textElements.length;__i++){
				__textElements[__i].innerText = ((value == undefined)?'':value);
				}
			}
			break;
			case 'address':
			element.setAttribute('my-event', 'geoloc');
			if( typeof value == 'string' ){
				var __locdatas = JSON.parse(value);
				element.setAttribute('my-lng', __locdatas.lng);
				element.setAttribute('my-lat', __locdatas.lat);
				element.setAttribute('my-address', __locdatas.addr+' '+__locdatas.zip+' '+__locdatas.city);
			}
			break;
			case 'contact':
			// @todo implement
			break;
			case 'descr':
			// @todo implement
			break;
			case 'number':
			element.innerText = ((value == undefined)?'':value);
			break;
			case 'price':
			// @todo implement
			break;
			case 'hidden':
			element.setAttribute('value',value);
			break;
			case 'select':
			// @todo implement
			break;
			case 'input':
			element.setAttribute('value',value);
			break;
			case 'visible_or_hidden':
			// @todo implement
			break;
			case 'aid':
			element.setAttribute('my-aid',value);
			break;
	        default :
	        element.innerHTML = value;
	        break;
	    }
	}
}*/

/**
* @param pid : (int)
* @param value : (string)
*/
natEvents.blockId = function(pid, value){
	var __elements = document.querySelectorAll('[blockid="'+pid+'"]'), __i;
	for(__i=0;__i<__elements.length;__i++){
		if( value ){
			__elements[__i].style.display="";
		}else{
			__elements[__i].style.display="display:none;";
		}
	}
	
}

/**
* CLASS customEvent
*
* @selector
* @func
*/
function CustomEvent(selector, func){
	if(typeof selector == 'string') this.selector=selector;
	else throw 'CustomEvent : first parameter must be a string.';

	if(typeof func == 'function') this.func=func;
	else throw 'CustomEvent : second parameter must be a function.';
}